Army = 1
Army1 = 1
Army2 = 1
Titan = 4
Ally = 2
Moving = 0
destroyed = 0 

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

escortDead = false
escortComplete = false

function onDeployStart()
	SpawnUnits("Enemy",Army2)
	SpawnUnits("finalWave",Army1)
	SpawnUnits("titan",Titan)
	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("waypoint_1b", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
	SetTriggerCallbacks("waypoint_1c", onTriggerEnter_Waypoint1C, onTriggerLeave_Waypoint1C)
--	SetTriggerCallbacks("waypoint_1d", onTriggerEnter_Waypoint1D, onTriggerLeave_Waypoint1D)
	SetTriggerCallbacks("spawn_wave1", onTriggerEnter_Wave1)
	SetTriggerCallbacks("spawn_wave2", onTriggerEnter_Wave2)
	SetTriggerCallbacks("spawn_wave3", onTriggerEnter_Wave3)
	SetTriggerCallbacks("spawn_wave4", onTriggerEnter_Wave4)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	AddTargetCircle("waypoint_1d")	
	AddTimer(5.5, showGoal)
--[[	
	-- <Kooz> DOT-24527: Show banner icons for allied units
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetForceShowBannerIcon(unit, true)
	end
--]]
end

function onLevelStart()
--	SetAlliedPlayers(0,2)
--	SetEnemyPlayers(1,2)
	SetWinnable(false)
--	SetVictoryBarEnabled(false)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
end

function showGoal()
	ShowDialog("talkingheads/full/guard","TXT_MISSIONAKINGDOMLOSTALT_1")
	FrameCamera("waypoint_1d")
	AddTimer(3.0, camReturn)
	AddTimer(2.9, removeText)
end

function removeText()
	HideDialog()
end

function camReturn()
	ReturnCamera()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

--[[
function onTriggerEnter_Start_Zone(unit)
	if unit.attacker then
		DisableTrigger("start_zone")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
		--AddTimer(5,SpawnWaveOne)
	end
end


function onTriggerEnter_Waypoint1A(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1a")
		SetUnitStandGuard(unit, true)
		AddTimer(10,waypoint1ADelay,unit)
		Moving = Moving + 1
	end
end

function waypoint1ADelay(unit)
	SetUnitStandGuard(unit, false)
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	
end

function onTriggerEnter_Waypoint1B(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1b")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
		--AddTimer(5,SpawnWaveTwo)
		Moving = Moving + 1
	end
end

function onTriggerEnter_Waypoint1C(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1c")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1d")
		Moving = Moving + 1
	end
end
--]]

function onTriggerEnter_Wave1(unit)
	if unit.attacker then
		AddTimer(1.0,SpawnWaveOneFX)
		DisableTrigger("spawn_wave1")
	end
end

function onTriggerEnter_Wave2(unit)
	if unit.attacker then
		AddTimer(1.0,SpawnWaveTwoFX)
		DisableTrigger("spawn_wave2")
	end
end

function onTriggerEnter_Wave3(unit)
	if unit.attacker then
		AddTimer(1.0,SpawnWaveThreeFX)
		DisableTrigger("spawn_wave3")
	end
end

function onTriggerEnter_Wave4(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "spawn_allies1")
		PlayVFX("PA_SpawnReinforcement", "spawn_allies2")
		AddTimer(1.0,SpawnWaveFour)
		ShowDialog("talkingheads/full/guard","TXT_MISSIONAKINGDOMLOSTALT_2")
		DisableTrigger("spawn_wave4")
	end
end

--[[
function onTriggerEnter_Waypoint1D(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1d")
		SetUnitStandGuard(unit, true)
		AddTimer(1,finish) -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED		
--		escortComplete = true
		ClearTargetCircles()
		
		enemyUnits =  GetUnits("*", "*", 1)
		if #enemyUnits > 0 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_7")
		else
			LevelComplete()
		end
		
	end
end

function finish() -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
	Win()
end

function onUnitDestroyed(unit)
	if unit.spawnId == "movingUnit_[start]" then
	
		ShowDialog("talkingheads/full/guard","TXT_MISSIONSP_C3M1_3")
		
		escortDead = true
		AddTimer(2,Lose)
	elseif unit.defender then -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
		destroyed = destroyed + 1
		if destroyed == 11 then
			Win()
		end
	end
elseif unit.defender then
		if escortComplete then
			enemyUnits =  GetUnits("*", "*", 1)
			if #enemyUnits == 0 then
				LevelComplete()
			end
		end
	end

end


function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		HideDialog()
	end
end

function LevelComplete()
	--ShowDialog("talkingheads/full/guard","TXT_MISSIONAKINGDOMLOSTALT_3")
	AddTimer(2, Win)
end
--]]

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 11 then
			SetTriggerCallbacks("waypoint_1d", onTriggerEnter_Waypoint1D)
		end
	end
end
	
function onTriggerEnter_Waypoint1D(unit)
	if unit.attacker then
		DisableTrigger("waypoint_1d")
		AddTimer(3,finish) 
		end
	end

function finish()
	ClearTargetCircles()
	Win()
end

function SpawnWaveOneFX()
	AddTimer(1, SpawnWaveOne)
end

function SpawnWaveOne()
	SpawnUnits("wave1",Army2)
end

function SpawnWaveTwoFX()
	PlayVFX("PA_SpawnReinforcement", "spawn_enemies3")
	PlayVFX("PA_SpawnReinforcement", "spawn_enemies4")
	AddTimer(1, SpawnWaveTwo)
end

function SpawnWaveTwo()
	SpawnUnits("wave2",Army1)
end

function SpawnWaveThreeFX()
	PlayVFX("PA_SpawnReinforcement", "spawn_enemies8")
	AddTimer(1, SpawnWaveThree)
end

function SpawnWaveThree()
	SpawnUnits("wave3",Army1)
end

function SpawnWaveFour()
	SpawnUnits("wave4",Ally)
end

--[[
function moveStartTo1A()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
	AddTimer(2.0, moveStartTo1ACheck)
end

function moveStartTo1ACheck()
	if Moving == 0 then
		moveStartTo1A()
	end
	if Moving == 1 then
	
	end
end

function move1ATo1B()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	AddTimer(2.0, moveStartTo1BCheck)
end

function moveStartTo1BCheck()
	if Moving == 1 then
		move1ATo1B()
	end
	if Moving == 2 then
	
	end
end


function move1BTo1C()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
	AddTimer(2.0, moveStartTo1CCheck)
end

function moveStartTo1CCheck()
	if Moving == 2 then
		move1BTo1C()
	end
	if Moving == 3 then
	
	end
end

function move1CTo1D()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1d")
	AddTimer(2.0, moveStartTo1DCheck)
end

function moveStartTo1DCheck()
	if Moving == 3 then
		move1CTo1D()
	end
end
--]]

function createStartingTroops(forPlinthInspector)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army2)
		SpawnUnits("finalWave",Army1)
		SpawnUnits("titan",Titan)
		SpawnUnits("wave1",Army2)
		SpawnUnits("wave2",Army1)
		SpawnUnits("wave3",Army1)
		SpawnUnits("wave4",Ally)
	end
end
