destroyed = 0
SpellLevel = 0
Rank = 0
Army = 25
Titan = 60

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_290_10")
	GiveDefenderSpoil("H_186_10")
	GiveDefenderSpoil("H_302_10")
	GiveDefenderSpoil("H_246_10")
	GiveDefenderSpoil("H_310_10")
	GiveDefenderSpoil("H_171_10")
	GiveDefenderSpoil("H_194_10")
	GiveDefenderSpoil("EV_260_10")
	GiveDefenderSpoil("EV_346_10")
	GiveDefenderSpoil("EV_411_10")
	GiveDefenderSpoil("EV_412_10")
	GiveDefenderSpoil("EV_378_10")
	GiveDefenderSpoil("EV_241_10")
	GiveDefenderSpoil("EV_224_10")
	GiveDefenderSpoil("EV_107_10")
	GiveDefenderSpoil("EV_331_10")
	GiveDefenderSpoil("EV_367_10")
	GiveDefenderSpoil("EV_387_10")
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1.0, framecamera)
	end
end

function framecamera(seconds)
    FrameCamera("camera")
	AddTimer(0.5, talkingHead1)
	AddTimer(5.5, removeText)
	AddTimer(6.0, ReturnCamera)
	AddTimer(7.0, talkingHead2)
	AddTimer(12.0, removeText)
	AddTimer(13.0, revealUI)
	EnableCameraControl(false)
end

function talkingHead1()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_HUMANADVENTURELEVEL11_1","BOTTOM_LEFT")
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_HUMANADVENTURELEVEL11_2","BOTTOM_LEFT")
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	EnableCameraControl(true)
end

function removeText()
	HideDialog()
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx2wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx3wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx4wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx5wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx6wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx7wave1")
	PlayVFX("PA_SpawnReinforcement", "vfx8wave1")
	AddTimer(1.0, spawnwave1)
	
end

function spawnVfx2()

	PlayVFX("PA_SpawnReinforcement", "vfx1wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx2wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx3wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx4wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx6wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx7wave2")
	PlayVFX("PA_SpawnReinforcement", "vfx8wave2")
	AddTimer(1.0, spawnwave2)
	
end

function spawnwave1()

	SpawnUnits("wave1",Army)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	SpawnUnits("Titan",Titan)
	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			AddTimer(1.0, spawnVfx1)
		end
		if destroyed == 17 then
			AddTimer(1.0, spawnVfx2)
		end
		if destroyed == 29 then
			SetWinnable(true)
		end
	end
	
end


function createStartingTroops(forPlinthInspector)

			
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("Titan",Titan)
	end
	
	
end










