SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0

math.randomseed(os.time())
local randomSpawn6 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	SpawnUnits("Militia1", Army18)
	SpawnUnits("Militia2", Army18)
	SpawnUnits("Skeleton1", Army18)
	SpawnUnits("Skeleton2", Army18)
	SpawnUnits("Archer2", Army18)
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	
	
	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	GiveDefenderSpoil("H_288_5")
	GiveDefenderSpoil("H_62_5")
	GiveDefenderSpoil("H_300_5")
	GiveDefenderSpoil("H_65_5")
	GiveDefenderSpoil("H_289_10")
	GiveDefenderSpoil("H_301_10")
	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	AddTimer(0.3, waveMultiplier)

	AddTimer(7.0, vfx1)
	AddTimer(14.0, vfx2)
	AddTimer(20.0, vfx3)
	AddTimer(26.0, vfx4)
	AddTimer(32.0, vfx5)
	AddTimer(38.0, vfx6)
	AddTimer(44.0, vfx7)
	
	
	FadeDeadUnits()
	AddTimer(300,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(1)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 32 then
		SetWinnable(true)
		end
	end
end

function vfx1()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawn1)
end

function vfx2()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawn2)
end

function vfx3()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawn3)
end

function vfx4()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	AddTimer(1.0, spawn4)
end

function vfx5()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	AddTimer(1.0, spawn5)
end

function vfx6()
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawn6)
end

function vfx7()
	AddTimer(1.0, spawn7)
end

function spawn1()
	RespawnUnits("Archer1", Army18)
	RespawnUnits("Archer2", Army18)
	RespawnUnits("Archer3", Army18)
end

function spawn2()
	RespawnUnits("Militia1", Army18)
	RespawnUnits("Militia2", Army18)
	RespawnUnits("Militia3", Army18)
	RespawnUnits("Militia4", Army18)
end

function spawn3()
	RespawnUnits("Archer1", Army18)
	RespawnUnits("Archer2", Army18)
	RespawnUnits("Archer3", Army18)
	RespawnUnits("Archer4", Army18)
end

function spawn4()
	RespawnUnits("MilitiaRaid1", Army18)
	RespawnUnits("Skeleton1", Army18)
	RespawnUnits("Skeleton2", Army18)
end

function spawn5()
	RespawnUnits("MilitiaRaid1", Army18)
	RespawnUnits("Militia1", Army18)
	RespawnUnits("Militia2", Army18)
	RespawnUnits("Skeleton3", Army18)
end

function spawn6()
	RespawnUnits("Skeleton4", Army18)
	RespawnUnits("Archer1", Army18)
	RespawnUnits("Archer3", Army18)
	RespawnUnits("SkeletonRaid2", Army18)
end

function spawn7()
	RespawnUnits("SkeletonRaid1", Army18)
	RespawnUnits("Skeleton1", Army18)
	RespawnUnits("Skeleton2", Army18)
	RespawnUnits("Skeleton3", Army18)
	RespawnUnits("Skeleton4", Army18)
end

function introText()
	randomIntroText1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_1_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_1_TALKING_HEAD_V2","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_1_TALKING_HEAD_V3","BOTTOM_LEFT")
	end
end

function turnOnHUD(unit)

	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	
end

