SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60
gate1 = 0
gate2 = 0
gate3 = 0
gate4 = 0
gate5 = 0

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local randomSpawn1 = 0

math.randomseed(os.time())
local randomSpawn2 = 0

math.randomseed(os.time())
local randomSpawn3 = 0

math.randomseed(os.time())
local randomSpawn4 = 0

math.randomseed(os.time())
local randomSpawn5 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end


function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	
	RespawnUnits("HordeMiddle1", Army24) -- 8 units 1 raid
	RespawnUnits("HordeMiddle2", Army24)
	RespawnUnits("HordeMiddle3", Army24)
	RespawnUnits("HordeMiddle4", Army24)
	RespawnUnits("HordeRight1", Army24)
	RespawnUnits("HordeRight2", Army24)
	RespawnUnits("HordeLeft1", Army24)
	RespawnUnits("HordeLeft2", Army24)
	RespawnUnits("SkeletonRaidMiddle1", Army24)
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	
	GiveDefenderSpoil("D_6")
	GiveDefenderSpoil("D_7")
	GiveDefenderSpoil("D_8")
	GiveDefenderSpoil("D_9")
	GiveDefenderSpoil("D_10")
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(300,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(8)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 9 then
			AddTimer(0.5, vfxWave1)
			AddTimer(1.5, spawnWave1)
		end
		if destroyed == 21 then
			AddTimer(0.5, vfxWave2)
			AddTimer(1.5, spawnWave2)
		end
		if destroyed == 33 then
			AddTimer(0.5, vfxWave3)
			AddTimer(1.5, spawnWave3)
		end
		if destroyed == 45 then
			AddTimer(0.5, vfxWave4)
			AddTimer(1.5, spawnWave4)
		end
		if destroyed == 58 then
			AddTimer(0.5, vfxWave5)
			AddTimer(1.5, spawnWave5)
		end
		if destroyed == 74 then
			AddTimer(0.5, vfxWave6)
			AddTimer(1.5, spawnWave6)
		end
		if destroyed == 90 then
		SetWinnable(true)
		end
	end
end

function spawnWave1()
	-- 9 normal 3 raid, 12 total
	RespawnUnits("RagnarRaidTopLeft1", Army25)
	RespawnUnits("RagnarRaidTopRight1", Army25)
	RespawnUnits("MossmaneRaidTop1", Army25)
	RespawnUnits("HordeTopRight1", Army25)
	RespawnUnits("HordeTopRight2", Army25)
	RespawnUnits("HordeTopLeft1", Army25)
	RespawnUnits("HordeTopLeft2", Army25)
	RespawnUnits("HordeTop1", Army25)
	RespawnUnits("UnakTopRight1", Army25)
	RespawnUnits("UnakTopRight2", Army25)
	RespawnUnits("UnakTopLeft1", Army25)
	RespawnUnits("UnakTopLeft2", Army25)
end

function vfxWave1()
	
end

function spawnWave2()
	-- 9 normal 3 raid, 12 total
	RespawnUnits("SkeletonRaidRight1", Army25)
	RespawnUnits("SkeletonRaidLeft1", Army25)
	RespawnUnits("SkeletonRaidMiddle1", Army25)
	RespawnUnits("StormMaidenTopRight1", Army25)
	RespawnUnits("StormMaidenTopRight2", Army25)
	RespawnUnits("StormMaidenRaidTopLeft1", Army25)
	RespawnUnits("StormMaidenRaidTopLeft2", Army25)
	RespawnUnits("HordeLeft1", Army25)
	RespawnUnits("HordeLeft2", Army25)
	RespawnUnits("HordeRight1", Army25)
	RespawnUnits("HordeRight2", Army25)
	RespawnUnits("MossmaneTop1", Army25)
end

function vfxWave2()
	
end

function spawnWave3()
	-- 9 normal 3 raid, 12 total
	RespawnUnits("UnakRaidRight1", Army25)
	RespawnUnits("UnakRaidLeft1", Army25)
	RespawnUnits("SkeletonRaidMiddle1", Army25)
	RespawnUnits("MossmaneRight1", Army25)
	RespawnUnits("MossmaneRight2", Army25)
	RespawnUnits("MossmaneLeft1", Army25)
	RespawnUnits("MossmaneLeft2", Army25)
	RespawnUnits("HordeMiddle2", Army25)
	RespawnUnits("HordeMiddle3", Army25)
	RespawnUnits("HordeTopRight1", Army25)
	RespawnUnits("HordeTopLeft1", Army25)
	RespawnUnits("StormMaidenTop1", Army25)
end

function vfxWave3()
	
end

function spawnWave4()
	-- 10 normal 3 raid, 13 total
	RespawnUnits("MossmaneRaidTopLeft1", Army25)
	RespawnUnits("MossmaneRaidTopRight1", Army25)
	RespawnUnits("MossmaneRaidTop1", Army25)
	RespawnUnits("UnakTopLeft1", Army25)
	RespawnUnits("UnakTopRight1", Army25)
	RespawnUnits("RagnarTopRight1", Army25)
	RespawnUnits("RagnarTopLeft1", Army25)
	RespawnUnits("HordeMiddle1", Army25)
	RespawnUnits("HordeMiddle4", Army25)
	RespawnUnits("HordeTop1", Army25)
	RespawnUnits("HordeRight1", Army25)
	RespawnUnits("HordeRight2", Army25)
	RespawnUnits("HordeTopRight1", Army25)
end

function vfxWave4()
	
end

function spawnWave5()
	-- 11 normal 4 raid 1 Titan 16 total
	RespawnUnits("Titan1", Titan4)
	RespawnUnits("StormMaidenRaidTop1", Army25)
	RespawnUnits("MossmaneRaidTop1", Army25)
	RespawnUnits("ElithenRaidTop1", Army25)
	RespawnUnits("ElithenRaidTop2", Army25)
	RespawnUnits("RagnarRight1", Army25)
	RespawnUnits("RagnarLeft1", Army25)
	RespawnUnits("HordeLeft1", Army25)
	RespawnUnits("HordeLeft2", Army25)
	RespawnUnits("HordeRight1", Army25)
	RespawnUnits("HordeRight2", Army25)
	RespawnUnits("HordeTop1", Army25)
	RespawnUnits("MossmaneTop1", Army25)
	RespawnUnits("RagnarTopRight1", Army25)
	RespawnUnits("RagnarTopLeft1", Army25)
	RespawnUnits("MossmaneLeft1", Army25)
end

function vfxWave5()
	
end

function spawnWave6()
	-- 11 normal 4 raid 1 titan, 16 total
	RespawnUnits("Titan2", Titan5)
	RespawnUnits("SkeletonRaidMiddle1", Army25)
	RespawnUnits("SkeletonRaidRight1", Army25)
	RespawnUnits("SkeletonRaidLeft1", Army25)
	RespawnUnits("MossmaneRaidTop1", Army25)
	RespawnUnits("HordeRight1", Army25)
	RespawnUnits("HordeRight2", Army25)
	RespawnUnits("HordeLeft1", Army25)
	RespawnUnits("HordeLeft2", Army25)
	RespawnUnits("HordeTopRight1", Army25)
	RespawnUnits("HordeTopLeft1", Army25)
	RespawnUnits("RagnarTopLeft1", Army25)
	RespawnUnits("UnakTopLeft1", Army25)
	RespawnUnits("RagnarTopRight1", Army25)
	RespawnUnits("HordeTopRight1", Army25)
	RespawnUnits("StormMaidenTop1", Army25)
end

function vfxWave6()
	
end

function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_8_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end

function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

