

destroyed = 0
spawned = false
notdead = false
SpellLevel = 13
Army = 17
Titan = 25
Rank = 0

function onDeployStart()
 createStartingTroops(False)
 raininghell()
 SetFightButtonEnabled(true)

end

function createStartingTroops(forPlinthInspector)
	

 SpawnUnits("start",Army)
 
 -- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("EvilHero",Titan)
		SpawnUnits("rand1",Army)
		SpawnUnits("rand2",Army)
		SpawnUnits("rand3",Army)
		SpawnUnits("rand4",Army)
	end
end

function stopdefender()
 local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
end

function startdefender()
 local units = GetUnits("*","*",1)
   for i,unit in pairs(units) do
      SetUnitStandGuard(unit, false)
  end
end

function trigger1_onTriggerEnter(unit)
  startdefender()
  DisableTrigger ("trigger1")
end

function onLevelStart()
  stopdefender()
  SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter)
--	SetupVictoryBar()
	
end



function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialogInPosition("talkingheads/full/guard","TXT_HEROSPAWNING_1","TOP_LEFT")
		--ShowDialogInPosition("talkingheads/full/guard","TXT_HEROSPAWNING_1A","TOP_LEFT")
	end

end

function onTalkingHeadFinish(text)
	if text == "TXT_HEROSPAWNING_1A" then
		--SetFightButtonEnabled(true)
	end
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
	end
	if destroyed == 3 then
		SpawnUnits("EvilHero",Titan)
		spawned = true
		ShowDialog("talkingheads/full/brendon", "TXT_HEROSPAWNING_2")
		AddTimer(4.0, removeText)
		AddTimer(3.0, makearmy)
	end
	if  unit.spawnId == "EvilHero" and spawned == true  then
		notdead = true
		AddTimer(3.0, WinConditionMet)
		ShowDialog("talkingheads/full/brendon", "TXT_HEROSPAWNING_3")	
		AddTimer(4.0, removeText)
	end		
end

function removeText()
	HideDialog()
end




function makearmy()
	if spawned == true and notdead == false then
		SpawnUnits("rand1",Army)
		AddTimer(5.0, makearmy2)		
	end
end

function makearmy2()
	if spawned == true and notdead == false then
		SpawnUnits("rand2",Army)
		AddTimer(5.0, makearmy3)		
	end
end

function makearmy3()
	if spawned == true and notdead == false then
		SpawnUnits("rand3",Army)
		AddTimer(5.0, makearmy4)		
	end
end

function makearmy4()
	if spawned == true and notdead == false then
		RespawnUnits("rand4",Army)
	end
end

function WinConditionMet()
	local units = GetUnits("*", "*", 1)
	for i,u in pairs(units) do
		RadialDamageUnit(u, 100, 100, 4)
	end
--	AddTimer(3.0, Win)
end

function raininghell()
	CastSpell("Lightning", SpellLevel, "strikes"..math.random(7), 3)
--	PlayVFX("PA_TutorialFireball", "strikes"..math.random(7))
	AddTimer(math.random(8), raininghell)
end



