Titan = 60
Army = 25
destroyed = 0
AllyArmy = 25
SpellLevel = 20

math.randomseed(os.time())
local lightning1 = 0

math.randomseed(os.time())
local lightning2 = 0

math.randomseed(os.time())
local lightning3 = 0

math.randomseed(os.time())
local lightning4 = 0

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0

math.randomseed(os.time())
local allytoop1 = 0

math.randomseed(os.time())
local allytoop2 = 0

math.randomseed(os.time())
local allytoop3 = 0

math.randomseed(os.time())
local allytoop4 = 0

math.randomseed(os.time())
local allytoop5 = 0

math.randomseed(os.time())
local allytoop6 = 0

math.randomseed(os.time())
local allytoop7 = 0

math.randomseed(os.time())
local allytoop8 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("start", Army)
	SpawnUnits("Boss", Titan)
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
			
	AddTimer(15.0, spawnRandomTroop1)
	AddTimer(30.0, spawnRandomTroop2)
	AddTimer(45.0, spawnRandomTroop3)
	AddTimer(60.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	AddTimer(10.0, beginLightning1)
	AddTimer(20.0, beginLightning2)
	AddTimer(30.0, beginLightning3)
	AddTimer(40.0, beginLightning4)
	
	GiveDefenderSpoil("H_385_10")
	GiveDefenderSpoil("H_515_10")
	GiveDefenderSpoil("H_391_10")
	GiveDefenderSpoil("H_393_10")
	GiveDefenderSpoil("EV_272_10")
	GiveDefenderSpoil("EV_450_10")
	
	AddTimer(0.3, waveMultiplier)
	
	AddTimer(60.0, autoCast)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose

end

function autoCast()
	GiveDefenderAutocastSkill("REvent_Lightning5")
end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
	GiveDefenderAutocastSkill("REvent_Lightning_5_Buff")
end

function waveMultiplier()
	UseContestWaveMultiplier(5)
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop4)
	
end

function beginLightning1()

	lightning1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning1 == 1) then
		CastSpell("Lightning", SpellLevel, "spell4",1)
	elseif (lightning1 == 2) then
		CastSpell("Lightning", SpellLevel, "spell5",1)
	elseif (lightning1 == 3) then
		CastSpell("Lightning", SpellLevel, "spell6",1)
	else
		CastSpell("Lightning", SpellLevel, "spell7",1)
	end
	
	AddTimer(3.5, beginLightning1)

end

function beginLightning2()

	lightning2 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning2 == 1) then
		CastSpell("Lightning", SpellLevel, "spell8",1)
	elseif (lightning2 == 2) then
		CastSpell("Lightning", SpellLevel, "spell9",1)
	elseif (lightning2 == 3) then
		CastSpell("Lightning", SpellLevel, "spell10",1)
	else
		CastSpell("Lightning", SpellLevel, "spell11",1)
	end
	
	AddTimer(3.5, beginLightning2)

end

function beginLightning3()
	
	lightning3 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (lightning3 == 1) then
		CastSpell("Lightning", SpellLevel, "spell12",1)
	elseif (lightning3 == 2) then
		CastSpell("Lightning", SpellLevel, "spell13",1)
	elseif (lightning3 == 3) then
		CastSpell("Lightning", SpellLevel, "spell14",1)
	else
		CastSpell("Lightning", SpellLevel, "spell15",1)
	end
	
	AddTimer(3.5, beginLightning3)

end

function beginLightning4()
	
	lightning3 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (lightning4 == 1) then
		CastSpell("Lightning", SpellLevel, "spell16",1)
	elseif (lightning4 == 2) then
		CastSpell("Lightning", SpellLevel, "spell17",1)
	elseif (lightning4 == 3) then
		CastSpell("Lightning", SpellLevel, "spell18",1)
	else
		CastSpell("Lightning", SpellLevel, "spell19",1)
	end
	
	AddTimer(3.5, beginLightning4)

end

function onCameraAnimationFinish(cameraName)

	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_LIGHTNING_LVL5","BOTTOM_LEFT")
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
		AddTimer(2.0, spawnAlliesVFX)
	end
	
end

function spawnAlliesVFX()

	PlayVFX("PA_SpawnReinforcement", "spawn1")
	PlayVFX("PA_SpawnReinforcement", "spawn2")
	PlayVFX("PA_SpawnReinforcement", "spawn3")
	PlayVFX("PA_SpawnReinforcement", "spawn4")
	PlayVFX("PA_SpawnReinforcement", "spawn5")
	PlayVFX("PA_SpawnReinforcement", "spawn6")
	PlayVFX("PA_SpawnReinforcement", "spawn7")
	PlayVFX("PA_SpawnReinforcement", "spawn8")
	
	AddTimer(1.0,spawnAllies)
	
end

function spawnAllies()

	allytoop1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop2 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop3 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop4 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop5 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop6 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop7 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop8 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (allytoop1 == 1) then
		SpawnUnits("MilitiaAlly1", AllyArmy)
	elseif (allytoop1 == 2) then
		SpawnUnits("ArcherAlly1", AllyArmy)
	else
		SpawnUnits("SpearmenAlly1", AllyArmy)
	end
	
	if (allytoop2 == 1) then
		SpawnUnits("MilitiaAlly2", AllyArmy)
	elseif (allytoop2 == 2) then
		SpawnUnits("ArcherAlly2", AllyArmy)
	else
		SpawnUnits("SpearmenAlly2", AllyArmy)
	end
	
	if (allytoop3 == 1) then
		SpawnUnits("MilitiaAlly3", AllyArmy)
	elseif (allytoop3 == 2) then
		SpawnUnits("ArcherAlly3", AllyArmy)
	else
		SpawnUnits("SpearmenAlly3", AllyArmy)
	end
	
	if (allytoop4 == 1) then
		SpawnUnits("MilitiaAlly4", AllyArmy)
	elseif (allytoop4 == 2) then
		SpawnUnits("ArcherAlly4", AllyArmy)
	else
		SpawnUnits("SpearmenAlly4", AllyArmy)
	end
	
	if (allytoop5 == 1) then
		SpawnUnits("HordeAlly1", AllyArmy)
	elseif (allytoop5 == 2) then
		SpawnUnits("RagnarAlly1", AllyArmy)
	else
		SpawnUnits("ElithenAlly1", AllyArmy)
	end
	
	if (allytoop6 == 1) then
		SpawnUnits("HordeAlly2", AllyArmy)
	elseif (allytoop6 == 2) then
		SpawnUnits("RagnarAlly2", AllyArmy)
	else
		SpawnUnits("ElithenAlly2", AllyArmy)
	end
	
	if (allytoop7 == 1) then
		SpawnUnits("UnakAlly1", AllyArmy)
	elseif (allytoop7 == 2) then
		SpawnUnits("MossmaneAlly1", AllyArmy)
	else
		SpawnUnits("MaidenAlly1", AllyArmy)
	end
	
	if (allytoop8 == 1) then
		SpawnUnits("UnakAlly2", AllyArmy)
	elseif (allytoop8 == 2) then
		SpawnUnits("MossmaneAlly2", AllyArmy)
	else
		SpawnUnits("MaidenAlly2", AllyArmy)
	end
	
end

function removeText()

	HideDialog()
	
end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function onUnitDestroyed(unit)
			if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
			end
end
