SpellLevel = 0
destroyed = 0
TooEasy = 1
Casual = 5
Easy = 6
Medium = 7
Heavy = 10

function QueueAssets()
  --QueueVFX("ElderStone_EnergyPropStones")
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)
	DisableAiSpells()
	SetWinnable(false)
end

function onLevelStart()
    SetVictoryBarEnabled(false)
    SetCanGrowAwareness("startMilitia",(false))
	--SetCanGrowAwareness("Easy",(false))
	--SetCanGrowAwareness("Medium",(false))
	--SetCanGrowAwareness("TitanCasual",(false))
	--SetCanGrowAwareness("TitanEasy",(false))
	--SetCanGrowAwareness("TitanMedium",(false))
	SetTriggerCallbacks("walka", walka_onTriggerEnter)
	SetTriggerCallbacks("walkb", walkb_onTriggerEnter)
	SetTriggerCallbacks("walkc", walkc_onTriggerEnter)
	SetTriggerCallbacks("beginCharge", beginCharge_onTriggerEnter)
	SetTriggerCallbacks("trap", trap_onTriggerEnter)
	SetTriggerCallbacks("playerSpawnIn", playerSpawnIn_onTriggerEnter)
	--AddTimer(1,friendArrival)
end

function beginCharge_onTriggerEnter(unit)
	if unit.attacker then
		--AddTimer(0.5,patrol1)
		AddTimer(0.5,patrol2)
		--SpawnUnits("militiaChargeRight",TooEasy)
		SpawnUnits("militiaChargeLeft",TooEasy)
		DisableTrigger("beginCharge")
		ClearTargetCircles()
	end
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("trapMilitia",TooEasy)
		DisableTrigger("trap")
		ClearTargetCircles()
	end
end

function playerSpawnIn_onTriggerEnter(unit)
	if unit.attacker then
		--SpawnUnits("enemy",TooEasy)
		--SpawnUnits("enemyTitan",TooEasy)
		PlayVFX("PA_SpawnReinforcement", "enemySpawnIn")
		AddTimer(1,enemyArrival)
		DisableTrigger("playerSpawnIn")
		ClearTargetCircles()
	end
end

function patrol1()
	GiveNamedUnitMoveOrder("militiaChargeRight", "walka")
end
function patrol2()
	GiveNamedUnitMoveOrder("militiaChargeLeft", "walkb")
end
--function patrol3()
	--GiveNamedUnitMoveOrder("chargeMossmane", "walkc")
--end

function enemyArrival()
    SpawnUnits("enemy",Casual)
	SpawnUnits("enemyback",Casual)
	SpawnUnits("enemyTitan",Casual)
	SetCanGrowAwareness("enemyBack",(false))
	PlayVFX("PA_SpawnReinforcement", "playerSpawnIn")
	AddTimer(1,friendArrival)
end
function friendArrival()
    SpawnUnits("friend",Casual)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
		AddTargetCircleWithArrow("beginCharge")
		end
		if destroyed == 2 then
			--SpawnUnits("militiaChargeLeft",TooEasy)
			--patrol2()
			SpawnUnits("militiaChargeRight",Easy)
			patrol1()
		end
		if destroyed == 3 then
			--SpawnUnits("chargeMossmane",TooEasy)
			--patrol3()
		AddTargetCircleWithArrow("trap")
		end
		if destroyed == 4 then
			--SpawnUnits("chargeMossmane",TooEasy)
			--patrol3()
		AddTargetCircleWithArrow("playerSpawnIn")
		end
		if destroyed == 11 then
			AddTimer(1,enterHero)
			AddTimer(1.2,killFriendly)
        end
		if destroyed == 16 then
			--SetWinnable(true)
			--AddTimer(1,rangerCatWalk)
			--AddTimer(2,killFriendly2)
			AddTimer(2,Win)
		end
	end
end

function enterHero()
	PlayVFX("PA_SpawnReinforcement", "hero")
	AddTimer(0.8,heroArrival)
end
function heroArrival()
	SpawnUnits("hero",Easy)
	framecamera1()
end
function killFriendly()
		local units = GetUnits("*","Archer5",  0)	
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
		local units = GetUnits("*","Pikemen5",  0)	
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
		AddTimer(1,killRanger)
end
function killRanger()
    local units = GetUnits("*","RangerElithenMaleSR4", 0)
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
	secondComing()
end

-- kill friendlys 2nd
function killFriendly2()
		local units = GetUnits("*","Archer5",  0)	
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
		local units = GetUnits("*","Pikemen5",  0)	
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
		local units = GetUnits("*","Militia5",  0)	
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end
		local units = GetUnits("*","InfiltratorElithenMaleRA6", 0)
			for i,unit in pairs(units) do
			KillUnit(unit)			
			HideDeadUnit(unit)
		    end		
end

-- 2nd major battle starts here
function secondComing()
        PlayVFX("PA_SpawnReinforcement", "enemy")
		AddTimer(1,enemyIn)
end
function enemyIn()
    SpawnUnits("evilRanger",Casual)
	SpawnUnits("evilPikeman",TooEasy)
	SpawnUnits("evilMilitia",TooEasy)
	PlayVFX("PA_SpawnReinforcement", "hero")
	AddTimer(1,playerIn)
end
function playerIn()
    SpawnUnits("goodMilitia",Casual)
	SpawnUnits("goodArcher",Casual)
	SpawnUnits("goodPikeman",Casual)
end

-- ranger cat walk here
function rangerCatWalk()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros0)
end
function catwalkHeros0()
	SpawnUnits("0",Easy)
	--SpawnUnits("1",Easy)
	--SpawnUnits("2",Easy)
	--SpawnUnits("3",Easy)
	--SpawnUnits("4",Easy)
	--SpawnUnits("5",Easy)
	--SpawnUnits("6",Easy)
	--SpawnUnits("7",Easy)
	--SpawnUnits("8",Easy)
	--SpawnUnits("9",Easy)
	--SpawnUnits("10",Easy)
	--SpawnUnits("11",Easy)
	--SpawnUnits("12",Easy)
	--SpawnUnits("13",Easy)
	--SpawnUnits("14",Easy)
	--SpawnUnits("15",Easy)
	--AddTimer(20,Win)
	AddTimer(2,rangerCatWalk1)
end
function rangerCatWalk1()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros1)
end
function catwalkHeros1()
	SpawnUnits("1",Easy)
	AddTimer(0.2,rangerCatWalk2)
end
function rangerCatWalk2()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros2)
end
function catwalkHeros2()
	SpawnUnits("2",Easy)
	AddTimer(0.2,rangerCatWalk3)
end
function rangerCatWalk3()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros3)
end
function catwalkHeros3()
	SpawnUnits("3",Easy)
	AddTimer(0.2,rangerCatWalk4)
end
function rangerCatWalk4()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros4)
end
function catwalkHeros4()
	SpawnUnits("4",Easy)
	AddTimer(0.2,rangerCatWalk5)
end
function rangerCatWalk5()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros5)
end
function catwalkHeros5()
	SpawnUnits("5",Easy)
	AddTimer(0.2,rangerCatWalk6)
end
function rangerCatWalk6()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros6)
end
function catwalkHeros6()
	SpawnUnits("6",Easy)
	AddTimer(0.2,rangerCatWalk7)
end
function rangerCatWalk7()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros7)
end
function catwalkHeros7()
	SpawnUnits("7",Easy)
	AddTimer(0.2,rangerCatWalk8)
end
function rangerCatWalk9()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros9)
end
function catwalkHeros9()
	SpawnUnits("9",Easy)
	AddTimer(0.2,rangerCatWalk10)
end
function rangerCatWalk10()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros10)
end
function catwalkHeros10()
	SpawnUnits("10",Easy)
	AddTimer(0.2,rangerCatWalk11)
end
function rangerCatWalk12()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros12)
end
function catwalkHeros12()
	SpawnUnits("12",Easy)
	AddTimer(0.2,rangerCatWalk13)
end
function rangerCatWalk13()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros13)
end
function catwalkHeros13()
	SpawnUnits("13",Easy)
	AddTimer(0.2,rangerCatWalk14)
end
function rangerCatWalk14()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros14)
end
function catwalkHeros14()
	SpawnUnits("14",Easy)
	AddTimer(0.2,rangerCatWalk15)
end
function rangerCatWalk15()
	PlayVFX("PA_SpawnReinforcement", "enemy")
	AddTimer(1.0,catwalkHeros15)
end
function catwalkHeros15()
	SpawnUnits("15",Easy)
	AddTimer(12,Win)
end
---------------------------------
----------
------

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("startMilitia",TooEasy)


	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
	SpawnUnits("startMilitia",TooEasy)

	end
end

function framecamera1(seconds)
	FrameCamera("hero")
	EnableCameraControl(true)
	--AddTimer(5, ReturnCamera)
end


