ArmyLevel = 20
TitanR3Level = 30
TitanR4Level = 40
timer = 1
SpellLevel = 25
destroyed = 0
AllyTitanLevel = 60

math.randomseed(os.time())
local titanSpawn1 = 0

math.randomseed(os.time())
local titanSpawn2 = 0

math.randomseed(os.time())
local randomIntroText1 = 0

math.randomseed(os.time())
local spellSpawnPool = 0

math.randomseed(os.time())
local spellSpawn1 = 0

math.randomseed(os.time())
local spellSpawn2 = 0

math.randomseed(os.time())
local spellSpawn3 = 0

function onDeployStart()

	titanSpawn1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	titanSpawn2 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (titanSpawn1 == 1) then
		SpawnUnits("AllyTitanA1", AllyTitanLevel, 0, false)
	elseif (titanSpawn1 == 2) then
		SpawnUnits("AllyTitanA2", AllyTitanLevel, 0, false)
	elseif (titanSpawn1 == 3) then
		SpawnUnits("AllyTitanA3", AllyTitanLevel, 0, false)
	else
		SpawnUnits("AllyTitanA4", AllyTitanLevel, 0, false)
	end
	
	if (titanSpawn2 == 1) then
		SpawnUnits("AllyTitanB1", AllyTitanLevel, 0, false)
	elseif (titanSpawn2 == 2) then
		SpawnUnits("AllyTitanB2", AllyTitanLevel, 0, false)
	elseif (titanSpawn2 == 3) then
		SpawnUnits("AllyTitanB3", AllyTitanLevel, 0, false)
	else
		SpawnUnits("AllyTitanB4", AllyTitanLevel, 0, false)
	end

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	
	SpawnUnits("AllyTitan1", AllyTitanLevel)
	SpawnUnits("AllyTitan2", AllyTitanLevel)

	SpawnUnits("S1",ArmyLevel) 
	SpawnUnits("S2",ArmyLevel) 
	SpawnUnits("S5",ArmyLevel) 
	SpawnUnits("MTL1",ArmyLevel) 
	SpawnUnits("MTR1",ArmyLevel) 
	SpawnUnits("SpM1",ArmyLevel) 
	SpawnUnits("RTL1",ArmyLevel) 
	SpawnUnits("RTR1",ArmyLevel) 
	
	AddTargetCircleWithArrow("lose")
	SetTriggerCallbacks("lose", onTriggerEnter_lose)
	
end

function onLevelStart()

	SetWinnable(false)
	SetBattleTimeoutTime(180, 0) -- set battle timer for 6 minutes
	AddTimer(180,Win)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
	FadeDeadUnits()
		
	commandUnits()
	
	timer = 1
	
	AddTimer(1.0, setWaveMultiplier1)
	AddTimer(30.0, setWaveMultiplier2)
	AddTimer(60.0, setWaveMultiplier3)
	AddTimer(90.0, setWaveMultiplier4)
	AddTimer(120.0, setWaveMultiplier5)
	AddTimer(150.0, setWaveMultiplier6)
	
	AddTimer(10.0, spawn1)
	AddTimer(25.0, spawn2)
	AddTimer(40.0, spawn3)
	AddTimer(60.0, spawn4)
	AddTimer(80.0, spawn5)

	AddTimer(1.0, freespells)

	AddTimer(60.0, timerValueChange2)
	AddTimer(90.0, timerValueChange3)
	
	AddTimer(20.0, spellDrop1)
	AddTimer(40.0, spellDrop2)
	AddTimer(60.0, spellDrop3)

end

function spellDrop1()

	spellSpawn1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (spellSpawn1 == 1) then
		DropSpell("Fireball", 25, "spell1")
	elseif (spellSpawn1 == 2) then
		DropSpell("Freeze", 25, "spell1")
	else
		DropSpell("Lightning", 25, "spell1")
	end
	
	AddTimer(30.0, spellDrop1)
	
end

function spellDrop2()

	spellSpawn2 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (spellSpawn2 == 1) then
		DropSpell("Fireball", 25, "spell2")
	elseif (spellSpawn2 == 2) then
		DropSpell("Freeze", 25, "spell2")
	else
		DropSpell("Lightning", 25, "spell2")
	end
	
	AddTimer(30.0, spellDrop2)
	
end

function spellDrop3()

	spellSpawn3 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (spellSpawn3 == 1) then
		DropSpell("Fireball", 25, "spell3")
	elseif (spellSpawn3 == 2) then
		DropSpell("Freeze", 25, "spell3")
	else
		DropSpell("Lightning", 25, "spell3")
	end
	
	AddTimer(30.0, spellDrop3)
	
end

function setWaveMultiplier1()
	UseContestWaveMultiplier(7)
end

function setWaveMultiplier2()
	UseContestWaveMultiplier(8)
end

function setWaveMultiplier3()
	UseContestWaveMultiplier(9)
end

function setWaveMultiplier4()
	UseContestWaveMultiplier(10)
end

function setWaveMultiplier5()
	UseContestWaveMultiplier(11)
end

function setWaveMultiplier6()
	UseContestWaveMultiplier(12)
end

function timerValueChange2()
	timer = 2
end

function timerValueChange3()
	timer = 3
end

function freespells()

	GiveSpellImmediate("Fireball", SpellLevel)
	GiveSpellImmediate("Fireball", SpellLevel)
	GiveSpellImmediate("Fireball", SpellLevel)
	GiveSpellImmediate("Fireball", SpellLevel)
	GiveSpellImmediate("Fireball", SpellLevel)
	GiveSpellImmediate("Freeze", SpellLevel)
	GiveSpellImmediate("Freeze", SpellLevel)
	GiveSpellImmediate("Freeze", SpellLevel)
	GiveSpellImmediate("Freeze", SpellLevel)
	GiveSpellImmediate("Freeze", SpellLevel)
	GiveSpellImmediate("Lightning", SpellLevel)
	GiveSpellImmediate("Lightning", SpellLevel)
	GiveSpellImmediate("Lightning", SpellLevel)
	GiveSpellImmediate("Lightning", SpellLevel)
	GiveSpellImmediate("Lightning", SpellLevel)
	GiveSpellImmediate("PoisonCloud", SpellLevel)
	GiveSpellImmediate("PoisonCloud", SpellLevel)
	GiveSpellImmediate("PoisonCloud", SpellLevel)
	GiveSpellImmediate("PoisonCloud", SpellLevel)
	GiveSpellImmediate("PoisonCloud", SpellLevel)
	GiveSpellImmediate("Rage", SpellLevel)
	GiveSpellImmediate("Rage", SpellLevel)
	GiveSpellImmediate("Rage", SpellLevel)
	GiveSpellImmediate("Rage", SpellLevel)
	GiveSpellImmediate("Rage", SpellLevel)
	
end

function spawn1()
	RespawnUnits("AR1",ArmyLevel) 
	RespawnUnits("AL1",ArmyLevel) 
	RespawnUnits("S3",ArmyLevel) 
	RespawnUnits("S4",ArmyLevel) 
	RespawnUnits("PTL1",ArmyLevel) 
	RespawnUnits("PTR1",ArmyLevel) 
	RespawnUnits("ETL1",ArmyLevel) 
	RespawnUnits("ETR1",ArmyLevel) 
end

function spawn2()
	RespawnUnits("STL1",ArmyLevel) 
	RespawnUnits("STR1",ArmyLevel) 
	RespawnUnits("RR1",ArmyLevel) 
	RespawnUnits("RL1",ArmyLevel) 
	RespawnUnits("SpL1",ArmyLevel) 
	RespawnUnits("SpR1",ArmyLevel) 
	RespawnUnits("MM1",ArmyLevel) 
	RespawnUnits("MM2",ArmyLevel) 
end

function spawn3()
	RespawnUnits("RTR2",ArmyLevel) 
	RespawnUnits("RTL2",ArmyLevel) 
	RespawnUnits("EM1",ArmyLevel) 
	RespawnUnits("STL2",ArmyLevel) 
	RespawnUnits("STR2",ArmyLevel) 
	RespawnUnits("PM1",ArmyLevel) 
	RespawnUnits("MR1",ArmyLevel) 
	RespawnUnits("ML1",ArmyLevel) 
end

function spawn4()
	RespawnUnits("PTL2",ArmyLevel) 
	RespawnUnits("PTR2",ArmyLevel) 
	RespawnUnits("EL1",ArmyLevel) 
	RespawnUnits("ER1",ArmyLevel) 
	RespawnUnits("PM2",ArmyLevel) 
	RespawnUnits("ML2",ArmyLevel) 
	RespawnUnits("MR2",ArmyLevel) 
	RespawnUnits("STL3",ArmyLevel) 
	RespawnUnits("STR3",ArmyLevel) 
end

function spawn5()
	RespawnUnits("PL1",ArmyLevel) 
	RespawnUnits("PR1",ArmyLevel) 
	RespawnUnits("EL2",ArmyLevel) 
	RespawnUnits("ER2",ArmyLevel) 
	RespawnUnits("RL2",ArmyLevel) 
	RespawnUnits("RR2",ArmyLevel) 
	RespawnUnits("AM1",ArmyLevel) 
	RespawnUnits("PL2",ArmyLevel) 
	RespawnUnits("PR2",ArmyLevel) 
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialogInPosition("talkingheads/full/guard","My Liege, if the enemy reaches the target we will fail.","BOTTOM_LEFT")
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_SPELLDEFENCE_LEVEL_1","BOTTOM_LEFT")
		FrameCamera("camera")
		AddTimer(3.0, ReturnCamera)
		AddTimer(5.0, getReady)
		AddTimer(3.0, removeText)
	end
end

function removeText()
	HideDialog()
end

function getReady()

	--ShowDialogInPosition("talkingheads/full/guard","Begin the fight my Liege, I will grant you extra FREE SPELLS!","BOTTOM_LEFT")
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_SPELLDEFENCE_LEVEL_2","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(3.0, enableControls)

end

function enableControls()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)

end

function onTriggerEnter_lose(unit)
	triggercheck()
end


function triggercheck()
	local var1 = CountDefendersInTrigger("lose")
	if var1 == 1 then 
		ShowDialogInPosition("talkingheads/full/guard","TXT_SPELLDEFENCE_LEVEL_3","BOTTOM_LEFT")
		Win()
	elseif var1 > 0 then
		AddTimer(3.0, triggercheck)
	end 
	
end

function commandUnits()
	local units = GetUnits("*", "*", 1)
          for i,unit in pairs(units) do
				GiveUnitMoveOrder(unit, "lose")
          end
	AddTimer(25.0, commandUnits)
end

function onUnitDestroyed(unit)

	if unit.spawnId == "S1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "S1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "S1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "S1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "S2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "S2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "S2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "S2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "S3" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "S3",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "S3",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "S3",ArmyLevel)
		end
	end
	
	if unit.spawnId == "S4" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "S4",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "S4",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "S4",ArmyLevel)
		end
	end
	
	if unit.spawnId == "S5" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "S5",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "S5",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "S5",ArmyLevel)
		end
	end
	
	
	
	
	
	if unit.spawnId == "ML1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ML1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ML1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ML1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ML2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ML2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ML2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ML2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MR2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MM1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MM1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MM1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MM1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MM2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MM2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MM2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MM2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MTL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MTL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MTL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MTL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "MTR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "MTR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "MTR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "MTR1",ArmyLevel)
		end
	end
	
	
	
	
	
	
	
	if unit.spawnId == "PTL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PTL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PTL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PTL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PTL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PTL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PTL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PTL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PTR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PTR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PTR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PTR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PTR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PTR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PTR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PTR2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PM1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PM1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PM1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PM1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PM2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PM2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PM2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PM2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "PR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "PR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "PR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "PR2",ArmyLevel)
		end
	end

	
	
	
	
	
	if unit.spawnId == "SpL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "SpL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "SpL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "SpL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "SpR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "SpR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "SpR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "SpR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "SpM1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "SpM1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "SpM1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "SpM1",ArmyLevel)
		end
	end
	
	
	
	
	
	
	
	if unit.spawnId == "EL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "EL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "EL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "EL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "EL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "EL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "EL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "EL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ER1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ER1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ER1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ER1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ER2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ER2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ER2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ER2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "EM1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "EM1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "EM1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "EM1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ETL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ETL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ETL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ETL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ETL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ETL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ETL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ETL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ETR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ETR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ETR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ETR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "ETR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "ETR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "ETR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "ETR2",ArmyLevel)
		end
	end
	
	
	
	
	
	
	
	
	if unit.spawnId == "RL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RR2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTR2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTR3" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTR3",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTR3",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTR3",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "RTL3" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "RTL3",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "RTL3",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "RTL3",ArmyLevel)
		end
	end
	
	
	
	
	
	
	
	if unit.spawnId == "STL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STL1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "STL2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STL2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STL2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STL2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "STL3" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STL3",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STL3",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STL3",ArmyLevel)
		end
	end
	
	if unit.spawnId == "STR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "STR2" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STR2",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STR2",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STR2",ArmyLevel)
		end
	end
	
	if unit.spawnId == "STR3" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "STR3",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "STR3",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "STR3",ArmyLevel)
		end
	end
	
	if unit.spawnId == "SR1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "SR1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "SR1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "SR1",ArmyLevel)
		end
	end
	
	if unit.spawnId == "SL1" then
		if timer == 1 then
			AddTimer(25.0, RespawnUnits, "SL1",ArmyLevel)
		
		elseif timer == 2 then 
			AddTimer(15.0, RespawnUnits, "SL1",ArmyLevel)
			
		elseif timer == 3 then 
			AddTimer(6.0, RespawnUnits, "SL1",ArmyLevel)
		end
	end
	
	
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		
	end
end