Army = 1
Army1 = 1
Army2 = 1
Moving = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

escortDead = false
escortComplete = false

function onDeployStart()
	SpawnUnits("Enemy1",Army2)
--	SpawnUnits("Enemy2",Army1)
--	SpawnUnits("Enemy3",Army)
	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("waypoint_1b", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
--	SetTriggerCallbacks("waypoint_1c", onTriggerEnter_Waypoint1C, onTriggerLeave_Waypoint1C)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	SetTriggerCallbacks("spawn_wave1", onTriggerEnter_spawn_wave1)
	SetTriggerCallbacks("spawn_wave2", onTriggerEnter_spawn_wave2)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
--	ShowDialog("talkingheads/full/guard","TXT_MISSIONT_1ALT_1")
	AddTargetCircle("waypoint_1c")
	AddTimer(4.5, showGoal)
--[[	
	-- <Kooz> DOT-24527: Show banner icons for allied units
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SetForceShowBannerIcon(unit, true)
	end
--]]
end

function onLevelStart()
	SetAlliedPlayers(0,2)
	SetEnemyPlayers(1,2)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
end

function showGoal()
	FrameCamera("waypoint_1c")
	AddTimer(3.0, camReturn)
end

function camReturn()
	ReturnCamera()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onTriggerEnter_Start_Zone(unit)
	if unit.attacker then
		DisableTrigger("start_zone")
--		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
--		ClearTargetCircles()
--		AddTargetCircle("waypoint_1c")
		AddTimer(5,SpawnWaveOne)
--		moveStartTo1A()
	end
end

--[[
function onTriggerEnter_Waypoint1A(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1a")
		SetUnitStandGuard(unit, true)
		AddTimer(10,waypoint1ADelay,unit)
		Moving = Moving + 1
	end
end

function moveStartTo1A()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
	AddTimer(2.0, moveStartTo1ACheck)
end

function moveStartTo1ACheck()
	if Moving == 0 then
		moveStartTo1A()
	end
	if Moving == 1 then
	
	end
end

function move1ATo1B()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	AddTimer(2.0, moveStartTo1BCheck)
end

function moveStartTo1BCheck()
	if Moving == 1 then
		move1ATo1B()
	end
	if Moving == 2 then
	
	end
end


function move1BTo1C()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
	AddTimer(2.0, moveStartTo1CCheck)
end

function moveStartTo1CCheck()
	if Moving == 2 then
		move1BTo1C()
	end
end

function waypoint1ADelay(unit)
	SetUnitStandGuard(unit, false)
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	
end
--]]
function onTriggerEnter_spawn_wave2(unit)
	if unit.attacker  then
		DisableTrigger("spawn_wave2")
--		AddTimer(.10,move2c)
--		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
		AddTimer(3,SpawnWaveTwo)
--		Moving = Moving + 1
	end
end

function onTriggerEnter_spawn_wave1(unit)
	if unit.attacker then	
		DisableTrigger("spawn_wave1")
		AddTimer(2,SpawnEnemy2FX)
	end
end

--[[
function move2c()
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
	AddTimer(5,SpawnWaveTwo)
	Moving = Moving + 1
end 
--]]

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 12 then
			SetTriggerCallbacks("waypoint_1c", onTriggerEnter_Waypoint1C)
		end
	end
end
	
function onTriggerEnter_Waypoint1C(unit)
	if unit.attacker then
		DisableTrigger("waypoint_1c")
		AddTimer(3,finish) 
		end
	end

function finish()
	ClearTargetCircles()
	Win()
end

--[[
function onUnitDestroyed(unit)
	if unit.spawnId == "movingUnit_[start]" then
	
		ShowDialog("talkingheads/full/guard","TXT_MISSIONSP_C3M1_3")
		
		escortDead = true
		AddTimer(2,Lose)
	elseif unit.defender then -- 	FIX FOR ESCORT MISSIONS - INSTANT WIN ON ENTER OR WIN ON ALL ENEMIES KILLED
		destroyed = destroyed + 1
		if destroyed == 12 then
			Win()
		end
	end

		elseif unit.defender then
		if escortComplete then
			enemyUnits =  GetUnits("*", "*", 1)
			if #enemyUnits == 0 then
				LevelComplete()
			end
		end
	end

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		HideDialog()
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_2")
		--AddTargetCircleWithArrow("start_zone")
	end
end


function LevelComplete()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_6")
	AddTimer(2, Win)
end
--]]

function SpawnWaveOne()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_3")
	AddTimer(3, hidetalkinghead1)
	SpawnUnits("wave1",Army2)
end

function hidetalkinghead1()
	HideDialog()
end

function SpawnEnemy2FX()
	PlayVFX("PA_SpawnReinforcement", "wave1FX1")	
	PlayVFX("PA_SpawnReinforcement", "wave1FX2")	
	PlayVFX("PA_SpawnReinforcement", "wave1FX3")	
	AddTimer(1, SpawnEnemy2)
end

function SpawnEnemy2()
	SpawnUnits("enemy2",Army1)
end

function SpawnWaveTwo()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8D_2_4")
	AddTimer(5, hidetalkinghead2)
	SpawnUnits("wave2",Army1)
end

function hidetalkinghead2()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	
	
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy1",Army2)
		SpawnUnits("Enemy2",Army1)
		SpawnUnits("Enemy3",Army)
		SpawnUnits("wave1",Army2)
		SpawnUnits("wave2",Army1)
	end
end
