-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 15
Army = 7
Army1 = 6
Army2 = 5

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Archers",Army2)
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("charge1", enter_onTriggerEnterRagnar)
	SetTriggerCallbacks("skeleton", enter_onTriggerEnterSkeleton)
	ClearTargetCircles()
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
	--AddTimer(16.0, spawnWave1)
	--AddTimer(50.0, moveUnits)
end

--function moveUnits()
	--GiveNamedUnitMoveOrder("Wave2","lossArea")
	--GiveNamedUnitMoveOrder("Wave3","lossArea")
	--GiveNamedUnitMoveOrder("Wave4a","lossArea")
	--GiveNamedUnitMoveOrder("Wave4b","lossArea")
	--GiveNamedUnitMoveOrder("Wave5","lossArea")
	--GiveNamedUnitMoveOrder("Titan","lossArea")
	--AddTimer(15.0, moveUnits)
--end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 11 then
			PlayVFX("PA_SpawnReinforcement", "titanSpawn")
			AddTimer(1.0,spawnFinalWave)
			ShowDialogInPosition("talkingheads/full/guard","TXT_AKL_1","BOTTOM_LEFT")
			AddTimer(1.0, moveOrder)
		end
		if destroyed == 14 then
			Win()
		end
	end
end

function spawnFinalWave()
	SpawnUnits("FinalWave",Army1)
	SpawnUnits("Titan",Titan)
end

function moveOrder()
	GiveNamedUnitMoveOrder("FinalWave","claim")	
	GiveNamedUnitMoveOrder("Titan","claim")	
end


function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Archers",Army2)
		SpawnUnits("FinalWave",Army1)
		SpawnUnits("Titan",Titan)
	end
end
