-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Army = 4
Titan = 10

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function onDeployStart()
	-- register the triggers in the level
	AddTimer(4.5, framecamera)
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(8.0, enableControls)
end

function framecamera()
	ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_MOSSMANE_3_3_1","BOTTOM_LEFT")
	AddTargetCircleWithArrow("centre")
	FrameCamera("camera")
	AddTimer(4.0, ReturnCamera)
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("centre", enter_onTriggerEnter)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnter(unit)
	ShowDialogInPosition("talkingheads/full/guard","TXT_DEFENSE_SKEL_INTRO","BOTTOM_LEFT")
	SpawnUnits("Wave1",Army)
	DisableTrigger("centre")
	AddTimer(26,spawnWave2a)
	ClearTargetCircles()
end

function spawnWave2a()
	SpawnUnits("Wave2a",Army)
	AddTimer(5,spawnWave2b)
end

function spawnWave2b()
	SpawnUnits("Wave2b",Army)
	AddTimer(20,spawnWave3)
end

function spawnWave3()
	SpawnUnits("Wave3",Army)
	AddTimer(6.0, spawnWave4)
end

function spawnWave4()
	SpawnUnits("Titan",Titan)
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 13 then
			Win()
		end
	end
end

function spawnFinalWave()
	SpawnUnits("FinalWave",Army)
	SpawnUnits("Titan",Titan)
end

function moveOrder()
	GiveNamedUnitMoveOrder("FinalWave","claim")	
	GiveNamedUnitMoveOrder("Titan","claim")	
end


function createStartingTroops(forPlinthInspector)
	--SpawnUnits("Wall")
	if forPlinthInspector then
		SpawnUnits("Wave1",Army)
		SpawnUnits("Wave2a",Army)
		SpawnUnits("Wave2b",Army)
		SpawnUnits("Wave3",Army)
		SpawnUnits("FinalWave",Army)
		SpawnUnits("Titan",Titan)
	end
end
