enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 30
Army = 14
Army1 = 13
Army2 = 12
Army3 = 11

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)
	SetWinnable(false)
end

function onLevelStart()
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	AddTimer(12.0, vfx1)
end

function vfx1()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	AddTimer(1.0, spawn1)
end

function spawn1()
	SpawnUnits("enemy1", Army3)
	AddTimer(2.0, vfx2)
end

function vfx2()
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	AddTimer(1.0, spawn2)
end

function spawn2()
	SpawnUnits("enemy2", Army3)
	AddTimer(1.7, vfx3)
end

function vfx3()
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	AddTimer(1.0, spawn3)
end

function spawn3()
	SpawnUnits("enemy3", Army3)
	AddTimer(1.4, vfx4)
end

function vfx4()
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	AddTimer(1.0, spawn4)
end

function spawn4()
	SpawnUnits("enemy4", Army2)
	AddTimer(1.1, vfx5)
end

function vfx5()
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	AddTimer(2.4, spawn5)
end

function spawn5()
	SpawnUnits("enemy5", Army2)
	AddTimer(0.9, vfx6)
end

function vfx6()
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawn6)
end

function spawn6()
	SpawnUnits("enemy6", Army2)
	AddTimer(0.8, vfx7)
end

function vfx7()
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	AddTimer(1.0, spawn7)
end

function spawn7()
	SpawnUnits("enemy7", Army1)
	AddTimer(0.6, vfx8)
end

function vfx8()
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	AddTimer(1.0, spawn8)
end

function spawn8()
	SpawnUnits("enemy8", Army1)
	AddTimer(0.5, vfx9)
end

function vfx9()
	PlayVFX("PA_SpawnReinforcement", "vfx9")
	AddTimer(1.0, spawn9)
end

function spawn9()
	SpawnUnits("enemy9", Army1)
	AddTimer(0.4, vfx10)
end

function vfx10()
	PlayVFX("PA_SpawnReinforcement", "vfx10")
	AddTimer(1.0, spawn10)
end

function spawn10()
	SpawnUnits("enemy10", Army)
	AddTimer(9.0, vfx11)
end

function vfx11()
	PlayVFX("PA_SpawnReinforcement", "vfx11")
	PlayVFX("PA_SpawnReinforcement", "vfx12")
	PlayVFX("PA_SpawnReinforcement", "vfx13")
	PlayVFX("PA_SpawnReinforcement", "vfx14")
	PlayVFX("PA_SpawnReinforcement", "vfx15")
	AddTimer(1.0, spawn11)
end

function spawn11()
	SpawnUnits("enemy11", Army)
	SpawnUnits("enemy12", Army)
	SpawnUnits("enemy13", Army)
	SpawnUnits("enemy14", Army)
	SpawnUnits("titan", Titan)	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 24 then
			SetWinnable(false)
			Win()
		end
    end
end



function createStartingTroops(forPlinthInspector)

		SpawnUnits("enemy",Army)
			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("enemy",Army)
		SpawnUnits("enemy1",Army3)
		SpawnUnits("enemy2",Army3)
		SpawnUnits("enemy3",Army3)
		SpawnUnits("enemy4",Army2)
		SpawnUnits("enemy5",Army2)
		SpawnUnits("enemy6",Army2)
		SpawnUnits("enemy7",Army1)
		SpawnUnits("enemy8",Army1)
		SpawnUnits("enemy9",Army1)
		SpawnUnits("enemy10",Army)
		SpawnUnits("enemy11", Army)
		SpawnUnits("enemy12", Army)
		SpawnUnits("enemy13", Army)
		SpawnUnits("enemy14", Army)		
	end
end









