
destroyed = 0
Army = 15
Army1 = 3
Army2 = 25
Army3 = 18
Ragnar = 15
Titan = 50

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
    createStartingTroops(False)
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SpawnUnits("start",Army)
	SpawnUnits("titan",Titan)
end

function createStartingTroops(forPlinthInspector)
	
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("elithen1",Army2)
		SpawnUnits("pike1",Army2)		
		SpawnUnits("skelspawn",Army)
		SpawnUnits("ragnar",Ragnar)
		SpawnUnits("moss",Army2)
		SpawnUnits("unak1",Army1)
		SpawnUnits("titan",Titan)
	end
end

function onLevelStart()
	DisableAiSpells()
	GiveSpellImmediate("Fireball",25)
	GiveSpellImmediate("Fireball",25)
	GiveSpellImmediate("Fireball",25)
	GiveSpellImmediate("Fireball",25)
	GiveSpellImmediate("Fireball",25)
	GiveSpellImmediate("Freeze",15)
	GiveSpellImmediate("Freeze",15)
	GiveSpellImmediate("Lightning",25)
	GiveSpellImmediate("Lightning",25)
	GiveSpellImmediate("Lightning",25)
	GiveSpellImmediate("Lightning",25)
	GiveSpellImmediate("Lightning",25)
	SetTriggerCallbacks("TriggerSpawns", attack_onTriggerEnter)
end

function attack_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("TriggerSpawns")
		AddTimer(1.0,skeleVFX)
		AddTimer(2.0,ragSpawnDelay)
		AddTimer(5.0,ragSpawnDelay2)
		AddTimer(4.0,fireball1)
		AddTimer(4.0,fireball2)
		AddTimer(4.0,fireball3)
		AddTimer(4.0,fireball4)
		AddTimer(4.0,fireball5)
		end
end

function skeleVFX()
		PlayVFX("PA_SpawnReinforcement", "skele1")
		PlayVFX("PA_SpawnReinforcement", "skele2")
		PlayVFX("PA_SpawnReinforcement", "skele3")
		PlayVFX("PA_SpawnReinforcement", "skele4")
		PlayVFX("PA_SpawnReinforcement", "skele5")
end

function ragSpawnDelay()
	SpawnUnits("skelspawn",Army2)
	
end

function ragSpawnDelay2()
	SpawnUnits("ragnar",Ragnar)
	SpawnUnits("moss",Army2)
end

function fireball1()
	CastSpell("Fireball", 1, "fb1",.1)
end

function fireball2()
	CastSpell("Fireball", 1, "fb2",.1)
end

function fireball3()
	CastSpell("Fireball", 1, "fb3",.1)
end

function fireball4()
	CastSpell("Fireball", 1, "fb4",.1)
end

function fireball5()
	CastSpell("Fireball", 1, "fb5",.1)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then	
			AddTimer(3.55, unak1FX)
			AddTimer(3.55, unak2FX)
			AddTimer(2.5, elithen1FX)
			AddTimer(2.0, elithen2FX)
			AddTimer(2.5, elithen3FX)
			AddTimer(1.5, pike1FX)
			AddTimer(1.0, pike2FX)
			AddTimer(1.5, pike3FX)
		end
		if destroyed == 26 then
			SetWinnable(true)
	    end
	end
end
	
function unak1FX()
	PlayVFX("PA_SpawnReinforcement", "unak1FX")
	AddTimer(1.0, unak1)
end 

function unak2FX()
	PlayVFX("PA_SpawnReinforcement", "unak2FX")
	AddTimer(1.0, unak2)
end 

function elithen1FX()
	PlayVFX("PA_SpawnReinforcement", "elithen1FX")
	AddTimer(1.0, elithen1)
end 

function elithen2FX()
	PlayVFX("PA_SpawnReinforcement", "elithen2FX")
	AddTimer(1.0, elithen2)
end 

function elithen3FX()
	PlayVFX("PA_SpawnReinforcement", "elithen3FX")
	AddTimer(1.0, elithen3)
end 

function pike1FX()
	PlayVFX("PA_SpawnReinforcement", "pike1FX")
	AddTimer(1.0, pike1)
end 

function pike2FX()
	PlayVFX("PA_SpawnReinforcement", "pike2FX")
	AddTimer(1.0, pike2)
end 

function pike3FX()
	PlayVFX("PA_SpawnReinforcement", "pike3FX")
	AddTimer(1.0, pike3)
end 

function unak1()
	SpawnUnits("unak1",Army1)
end

function unak2()
	SpawnUnits("unak2",Army1)
end

function elithen1()
	SpawnUnits("elithen1",Army3)
end

function elithen2()
	SpawnUnits("elithen2",Army3)
end

function elithen3()
	SpawnUnits("elithen3",Army3)
end

function pike1()
	SpawnUnits("pike1",Army3)
end

function pike2()
	SpawnUnits("pike2",Army3)
end

function pike3()
	SpawnUnits("pike3",Army3)
end