SpellLevel = 0
Army = 0
Army1 = 0
Army2 = 0
Rank = 0
Timer = 0
destroyed = 0
EnemySpawnTimer = 9
DontSpawn = false

CreateRandomisedListOfThings("List_Units","spawn","spawn1","spawn2")

function onDeployStart()
	AddTargetCircle("circle")
	createStartingTroops(False)
	SetFightButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
end

function onLevelStart()
	SetTriggerCallbacks("protect", protect_onTriggerEnter, protect_onTriggerLeave) -- Player approaches the capture point
	SetTriggerCallbacks("protect1", protect1_onTriggerEnter, protect1_onTriggerLeave)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
		    ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_1")
			AddTargetCircleWithArrow("circle")
		end	
	end
end


-- this trigger will check if the player has captured the starting zone
function protect_onTriggerEnter(unit)
	if unit.attacker then
	ClearTargetCircles()
	AddTimer(3,skeletontrap)
	AddTimer(1,skeletonspawn)
	AddTimer(40,Ending)
	AddTimer(60,Victory)
	SetBattleTimeoutTime(60,0)
	DisableTrigger("protect")
	ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_2")
	SetVictoryBarEnabled(true)
	SetVictoryBarFill(0.2)
	AddTimer(10,victorybarup1)
	AddTimer(20,victorybarup2)
	AddTimer(30,victorybarup3)
	AddTimer(40,victorybarup4)
	AddTimer(50,victorybarup5)
	end
end
function protect1_onTriggerLeave(unit)
	if unit.attacker then
	ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_3")
	DisableTrigger("protect1")
	end
end

function skeletonspawn()

	AddTimer(EnemySpawnTimer,skeletontrap)

end

function skeletontrap()
-- calls random function to spawn random skeleton units
    if not DontSpawn then
	    RespawnUnits(GetRandomisedRandomThing("List_Units"),Army2) 
	end
	AddTimer(1,skeletonspawn)
end

function Ending()
    ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_4")
end

function victorybarup1()
    SetVictoryBarFill(0.3)
end
function victorybarup2()
    SetVictoryBarFill(0.4)
end
function victorybarup3()
    SetVictoryBarFill(0.5)
end
function victorybarup4()
    SetVictoryBarFill(0.6)
end
function victorybarup5()
    SetVictoryBarFill(0.8)
end

function Victory()
    ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_5")
	--GiveNamedUnitMoveOrder("spawn", "retreat")
	--GiveNamedUnitMoveOrder("spawn1", "retreat1")
	--GiveNamedUnitMoveOrder("spawn2", "retreat2")
	Kill1()
	Kill2()
	Kill3()
	AddTimer(8,win)
	SetVictoryBarFill(0.9)
	DontSpawn = true
end

function Kill1()
	local units = GetUnits("spawn", "*", 1)
	for i,unit in pairs(units) do
	    KillUnit(unit)
		HideDeadUnit(unit)
	end
end
function Kill2()
	local units = GetUnits("spawn1", "*", 1)
	for i,unit in pairs(units) do
	    KillUnit(unit)
		HideDeadUnit(unit)
	end
end
function Kill3()
	local units = GetUnits("spawn2", "*", 1)
	for i,unit in pairs(units) do
	    KillUnit(unit)
		HideDeadUnit(unit)
	end
end

function win()
    Win()
	SetVictoryBarFill(1)
end


--Here is where the ranking of the grind will be made for time duration and enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 12 then			
			Army = 12
			Army1 = 11
			Army2 = 10
			SpellLevel = 10
		elseif Rank == 13 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end

	SpawnUnits("start",Army1)
	SpawnUnits("titan",Army2)
		
	if forPlinthInspector then
	    SpawnUnits("start",Army1)
	    SpawnUnits("titan",Army2)
		SpawnUnits("spawn",Army2)
		SpawnUnits("spawn1",Army2)
		SpawnUnits("spawn2",Army2)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
    ShowDialogEternal("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_2_INTRO")
	AddTimer(7, HideDialog)
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(7, ReturnCamera)
	AddTimer(7.5, buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end