SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0
escape = false
skeleton = false
victory = false

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(false)  -- This establishes the scaling and what shows on the plinth inspector
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
end

function onLevelStart()
	SetWinnable(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetTriggerCallbacks("escape", escape_onTriggerEnter, escape_onTriggerLeave)
	SetTriggerCallbacks("fx1", fx1_onTriggerEnter, fx1_onTriggerLeave)
	SetTriggerCallbacks("fx2", fx2_onTriggerEnter, fx2_onTriggerLeave)
	SetTriggerCallbacks("fx3", fx3_onTriggerEnter, fx3_onTriggerLeave)
	SetTriggerCallbacks("fx4", fx4_onTriggerEnter, fx4_onTriggerLeave)
	SetTriggerCallbacks("fx5", fx5_onTriggerEnter, fx5_onTriggerLeave)
	SetTriggerCallbacks("fx6", fx6_onTriggerEnter, fx6_onTriggerLeave)
	AddTimer(180.0, Fail)
	AddTimer(40.0, Reinforce)
	SetBattleTimeoutTime(180)
	triggercheck()
end

function triggercheck()
	local var1 = CountDefendersInTrigger("escape")
	
	local var2 = CountAttackersInTrigger("escape")
	if var1 > var2 then
	 escape = false
	elseif var1 < var2 then
	 escape = true
	end 
	Success()
end

function trigger1_onTriggerEnter(unit)

	if unit.attacker then
		SpawnUnits("spawn1",Army1)
		Skeleton = true
		ShowDialog("talkingheads/full/soldier","TXT_BLACKKING_CAMPAIGN3_3_1")
		DisableTrigger("trigger1")
		DisableTrigger("trigger2")
	end

end

function trigger2_onTriggerEnter(unit)

	if unit.attacker and skeleton == false then
		skeleton = true
		SpawnUnits("spawn1",Army2)
		AddTimer(1.0, Spawn3Wave)
		PlayVFX("PA_SpawnReinforcement", "fx4")
		PlayVFX("PA_SpawnReinforcement", "fx5")
		DisableTrigger("trigger1")
		DisableTrigger("trigger2")
	end

end

function Spawn3Wave()
	SpawnUnits("spawn3",Army2)
end

function Success()
	AddTimer(1.0, triggercheck)
	if escape == true and victory == false then
		victory = true
		AddTimer(8.0, Victory)
		ShowDialog("talkingheads/full/soldier","TXT_BLACKKING_CAMPAIGN3_3_WIN")
		DisableTrigger("escape")
		FrameCamera("camera")
	    EnableCameraControl(false)
	end

end

function Victory()

	Win()

end

function Reinforce()
	if escape == false then
	ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_3_2")
	PlayVFX("PA_SpawnReinforcement", "fx1")
	PlayVFX("PA_SpawnReinforcement", "fx2")
	PlayVFX("PA_SpawnReinforcement", "fx3")
	PlayVFX("PA_SpawnReinforcement", "fx6")
	AddTimer(1.0, NextWave)
	end
end


function NextWave()
	SpawnUnits("spawn2",Army2)
	SpawnUnits("titan",Army2)
	SetWinnable(true)
end

function Fail()
	ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_3_LOSE")
	AddTimer(5.0, Lose)
end

function Lose()
	Lose()
end

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 13 then			
			Army = 13
			Army1 = 12
			Army2 = 11
			SpellLevel = 11
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("start",Army1)
	SpawnUnits("start1",Army1)
	--RespawnUnits("spawn3",Army2)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
		SpawnUnits("spawn3", Army2)
		SpawnUnits("titan",Army2)
	    SpawnUnits("spawn1",Army2)
		SpawnUnits("spawn2",Army2)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	ShowDialogEternal("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_3_INTRO1")
	AddTimer(8, HideDialog)
	AddTargetCircle("circle")
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(8, ReturnCamera)
	AddTimer(8.5, framecamera1)
end

function framecamera1(seconds)
	ShowDialogEternal("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN3_3_INTRO2")
	AddTimer(7, HideDialog)
	FrameCamera("camera1")
	EnableCameraControl(false)
	AddTimer(7, ReturnCamera)
	AddTimer(7.5, buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end