destroyed = 0
SpellLevel = 0
Rank = 0
Army = 23
Army1 = 23
Army2 = 23

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
    SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(0.2, story)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	PlayVFX("ElderStone_EnergyPropStones", "glow")
	SetAI1() -- allies
end

function story()
    ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10_1_1")
	AddTimer(5, enter)
end

function enter()
	PlayVFX("PA_SpawnReinforcement", "arrival")
	AddTimer(1, enter1)
end
function enter1()
	SpawnUnits("easyarmy",Army2)
	
	StopVFX("ElderStone_EnergyPropStones", "glow")
	AddTimer(2,enter2)
end
function enter2()
    PlayVFX("ElderStone_EnergyPropStones", "glow")
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10_1_2")
    AddTimer(1, enter3)
end
function enter3()
	PlayVFX("PA_SpawnReinforcement", "arrival2")
	PlayVFX("PA_SpawnReinforcement", "arrival3")
	AddTimer(1, enter4)
end
function enter4()
	SpawnUnits("ambush1",Army1)
	StopVFX("ElderStone_EnergyPropStones", "glow")
	AddTimer(2,startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "easyarmy", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			SetAlliedPlayers(2, 0)
	end
end

function onLevelStart()
	SetTriggerCallbacks("trap1", trap1_onTriggerEnter, trap1_onTriggerLeave)
	SetTriggerCallbacks("trap2", trap2_onTriggerEnter, trap2_onTriggerLeave)
	--SetTriggerCallbacks("circletrap", circletrap_onTriggerEnter, circletrap_onTriggerLeave)
	local units = GetUnits("*", "easyarmy", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
		end
end

function trap1_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10_1_3")
		--AddTargetCircle("circle")
		SpawnUnits("ambush2",Army1)
		DisableTrigger("trap1")
	end
end

function trap2_onTriggerEnter(unit)
	if unit.attacker then
		--SpawnUnits("ambush4") -- delete this one
		--SpawnUnits("ambush3")
		--DisableTrigger("trap2")
	end
end

function newWave()
    SpawnUnits("ambush3",Army)
end

function circletrap_onTriggerEnter(unit)
	if unit.attacker then
		SetVictoryBarFill(1)
		DisableTrigger("circletrap")
		AddTimer(3,winner)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			--ShowDialogEternal("talkingheads/full/guard", "TXT_CAMPAIGN10_1_5")
			--AddTargetCircle("circle")
			--AddTimer(5, circleenter)
			SpawnUnits("ambush4",Army)
			SetVictoryBarFill(0.3)
		end
		if destroyed == 6 then
			--SpawnUnits("ambush3")
			newWave()
			SetVictoryBarFill(0.6)
		end
		if destroyed == 10 then
		    SetVictoryBarFill(0.9)
			AddTimer(0.1, circleenter)
			--ShowDialogEternal("talkingheads/full/guard", "TXT_CAMPAIGN10_1_4")
			SetTriggerCallbacks("circletrap", circletrap_onTriggerEnter, circletrap_onTriggerLeave)
		end
	end
end

function circleenter()
    --HideDialog()
	AddTargetCircle("circle")
	ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10_1_4")
end

function winner()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("easyarmy",Army2)
		SpawnUnits("ambush1",Army1)
		SpawnUnits("ambush2",Army1)
		SpawnUnits("ambush3",Army)
		SpawnUnits("ambush4",Army)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("arrival")
	AddTimer(7., ReturnCamera)
	--EnableCameraControl(false)
	--AddTargetCircleWithArrow("capture")
	--AddTimer(6,framecamera1)
end










