
-- Global variables
Army = 0
Rank = 0
destroyed = 0
dead = 0
triggercheck = 0
shown = 0 -- checks on how many times the UIArrow for stand ground is shown (max 3 times)
start = 1 -- this needs to be started on 0, then +1'd when level starts to ensure UIArrow doesnt show before this phase
triggered = 0
talk = 0
ready = false
shouldPlayTapUnitMovie = true

--deploy phase
function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	--SetStandGuardButtonEnabled(false)
	--if HasBattleBeenRestarted() then
		--ShowDialog("talkingheads/full/guard","TXT_BATTLE_RESTARTED")
    --end
	SpawnUnits("start",Army)
	SpawnUnits("wave1l",Army)
	SpawnUnits("wave1r",Army)
	SpawnUnits("wave2l",Army)
	SpawnUnits("wave2r",Army)
	SetTriggerCallbacks("standground", standground_onTriggerEnter)
	--SetTalkingheadForUserTitan("talkingheads/full/brendon","TXT_CAMPAIGN2_1_1","TOP_LEFT")
	--SetUserTitanParticle("ST_RockPrison")
	SetAlliedPlayers(3,0)
	for i,unit in pairs(GetUnits("*", "*", 0)) do
	    if unit.isTitan then 
		TeleportUnit(unit, "titan")
		SwitchSide(unit, 3)
		end
	end

end


-- battle start
function onLevelStart()
	CloseTutorialMovie()  
	SetBattleTimeoutTime(150,0)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("prepare", prepare_onTriggerEnter)
	SetTriggerCallbacks("trigger", trigger_onTriggerEnter)
	--ClearTargetCircles()
	--AddTargetCircle("trigger")
	--SetStandGuardButtonEnabled(false)
end

function trigger_onTriggerEnter(unit)
	if unit.attacker then 
		ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_4")
		ready = true
		DisableTrigger("trigger")
	end
end


function standground_onTriggerEnter(unit)
	if unit.attacker then 
        triggered = triggered +1
		if triggered == 1 then
		    SetUnitStandGuard(unit, true)
			shown = shown+4
		end
		if triggered == 2 then
		    SetUnitStandGuard(unit, true)
		end
		if triggered == 3 then
		    SetUnitStandGuard(unit, true)
			--DisableTrigger("standground")
		end
		if triggered == 4 then
		    SetUnitStandGuard(unit, true)
			DisableTrigger("standground")
		end
		if triggered == 5 then
		end
	end
end

function onUnitSelected(unit)
   CloseTutorialMovie()   
   if unit.attacker and start == 1 then --and ready == true (this can be added but causes issue if unit already selected, the SG button wont show until reselected)
    shown = shown+1
	    if shown <=3 then
		SetStandGuardButtonEnabled(true)
		ShowUIGuideArrow("StandGuardBtn")
	    elseif shown >=4 then	
        SetStandGuardButtonEnabled(true)
        HideUIGuideArrow("StandGuardBtn")		
	    end
	end  
end

function onUnitOrderGiven(unit,orderType)
    if unit.attacker and orderType == "STAND_GROUND" then
	    HideUIGuideArrow("StandGuardBtn")
		AddTimer(0.5,charge1)
		AddTimer(20,charge2)
		AddTimer(35, charge3)
		--DisableTrigger("standground")
		--ClearTargetCircles()
		shown = shown+4
	end
end

function charge1()
    GiveNamedUnitMoveOrder("wave1l", "chargel")
	GiveNamedUnitMoveOrder("wave1r", "charger") 
end
function charge2()
    GiveNamedUnitMoveOrder("wave2l", "charge")
end
function charge3()
    GiveNamedUnitMoveOrder("wave2r", "charge")
end

-- trigger warning THs. where when enemy triggers, a warning message is displayed
function prepare_onTriggerEnter(unit)
	if unit.defender then
        ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_5")
		DisableTrigger("prepare")
	    AddTimer(5,prep1)
	end
end
function prepare1_onTriggerEnter(unit)
	if unit.defender then
        ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_6")
		DisableTrigger("prepare1")
		AddTimer(5,prep2)
	end
end
function prepare2_onTriggerEnter(unit)
	if unit.defender then
        ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_7")
		DisableTrigger("prepare2")
	end
end

-- Additional triggers created here
function prep1()
    SetTriggerCallbacks("prepare1", prepare1_onTriggerEnter)
end
function prep2()
    SetTriggerCallbacks("prepare2", prepare2_onTriggerEnter)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			AddTimer(8,win)
			talk = talk +1
			ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_8")
			--SetTalkingheadForUserTitan("talkingheads/full/brendon","TXT_CAMPAIGN2_2_9","TOP_LEFT")
		end
	end
	if unit.attacker then
		dead = dead + 1
		if dead == 3 then
			Lose()
		end
	end
end

-- Enemy Orders Section
function charge1()
    GiveNamedUnitMoveOrder("wave1l", "chargel")
	GiveNamedUnitMoveOrder("wave1r", "charger") 
end

-- opening level transitions here
function opening()
	ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_1")
	AddTimer(8, HideDialog)
	FrameCamera("titancamera")
	AddTimer(8, ReturnCamera)
	EnableCameraControl(false)
	--AddTimer(6, framecamera)
end
function onTalkingHeadFinish(text)
print("onTalkingHeadFinish", text)

	if text == "TXT_CAMPAIGN2_2_1" then
		framecamera()
	end
	if text == "TXT_CAMPAIGN2_2_2" then
		introtalk()
		--ReturnCamera()
	end
	if text == "TXT_CAMPAIGN2_2_3" then
		introend()
	end
end
function framecamera(seconds)
    ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_2")
	AddTimer(6, HideDialog)
	FrameCamera("camera")
	AddTimer(8, ReturnCamera)
	EnableCameraControl(false)
	--AddTimer(4, ReturnCamera)
	--AddTimer(6,intro1)
end
function introtalk()
    ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN2_2_3")
	AddTimer(6, HideDialog)
	playTapUnitMovie()
	--AddTargetCircleWithArrow("trigger")
	FrameCamera("camera1")
end


function playTapUnitMovie()
  if shouldPlayTapUnitMovie then
    local allies = GetUnits("*", "Pikemen", 0) -- get player spearmen unit
    PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[3])
    shouldPlayTapUnitMovie = false
  end
end


function introend()
    SetFightButtonEnabled(true)
end

function win()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 1 then
			Army = 1
		elseif Rank >= 4 then
			Army = 1
		end
    if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
	    SpawnUnits("start",Army)
	    SpawnUnits("wave1l",Army)
	    SpawnUnits("wave1r",Army)
	    SpawnUnits("wave2l",Army)
	    SpawnUnits("wave2r",Army)
	    SpawnUnits("wave3l",Army)
	    SpawnUnits("wave3r",Army)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1,opening)
		-- add titan disbaility control here
		DisableUserTitan()
	end
end

