Army = 1
Army1 = 1

escortDead = false
escortComplete = false

function onDeployStart()
	SpawnUnits("wave1",Army)
	SpawnUnits("Enemy",Army)
	SetTriggerCallbacks("end", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(4.5, guideUnit)
end

function onLevelStart()
	--ClearTargetCircles()
	SetWinnable(false)
	SetVictoryBarEnabled(true)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
--	AddTimer(3.5, spawnWaveTwo)
end

function spawnWaveTwo()
	SpawnUnits("wave2",Army)
end

function onTriggerEnter_End_Zone(unit)
	if unit.attacker then
		DisableTrigger("end")
		ShowDialog("talkingheads/full/guard","TXT_MISSION2A_3_3")
		Win()
	end
	if unit.defender then
		DisableTrigger("end")
		ShowDialog("talkingheads/full/guard","TXT_MISSION2A_3_4")
		Lose()
	end
end

function removeText()
	HideDialog()
end

function guideUnit()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	FrameCamera("portal_camera")
	AddTargetCircle("end")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2A_3_1")
	AddTimer(5.0, removeText)
	AddTimer(5.0, showPortal)
	--AddTimer(4.0, returnCam)
	--AddTimer(6.5, EnableControls)
end

function showPortal()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	--ClearTargetCircles()
	ReturnCamera()
	AddTimer(0.1, showUnits)
end

function showUnits()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	ReturnCamera()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTimer(0.005, returnCam)
end

function returnCam()
	ClearTargetCircles()
	AddTimer(0.005, showEnemy)
end

function showEnemy()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTargetCircle("enemy")
	FrameCamera("enemy")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2A_3_2")
	AddTimer(7.0, removeText)
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTimer(7.0, returnCam2)
end

function returnCam2()
	ReturnCamera()
	DropSpell("Freeze", 2, "spell_drop")
	DropSpell("Freeze", 2, "spell_drop1")
--	DropSpell("Freeze", 2, "spell_drop2")
	DropSpell("Freeze", 2, "spell_drop2")
	DropSpell("Freeze", 2, "spell_drop3")
	ClearTargetCircles()
	AddTargetCircleWithArrow("end")
	EnableControls()
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("wave1",Army)
--		SpawnUnits("wave2",Army)
	end
end


