Army = 1
Army1 = 1
destroyed = 0

escortDead = false
escortComplete = false

function onDeployStart()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_1_3")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Enemy1",Army1)
	SetTriggerCallbacks("unitPosition", onTriggerEnter_unitPosition, onTriggerLeave_unitPosition)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(5.5, guideUnit)
	AddTimer(4.0, removeText)
end

function onLevelStart()
	--ClearTargetCircles()
	SetWinnable(false)
	SetVictoryBarEnabled(true)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
end

function guideUnit()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTargetCircle("unitPosition")
	FrameCamera("unitPosition")
	ShowDialogEternal("talkingheads/full/guard","TXT_EVENT_BLACKKING1_6_1")
	AddTimer(4.0, returnCam)
	AddTimer(6.5, EnableControls)
	AddTimer(4.0, removeText)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function returnCam()
	ReturnCamera()
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function LevelComplete()
	AddTimer(2, Win)
end

function removeText()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Enemy1",Army1)
	end
end

function onTriggerEnter_unitPosition(unit)
	ClearTargetCircles()
end

function onUnitDestroyed(unit)
        if unit.defender then
			destroyed = destroyed + 1
			if destroyed == 4 then
				Win()
			end
		end
end
