
Army = 1
Army1 = 2
destroyed = 0
--[[
escortDead = false
escortComplete = false
--]]
function onDeployStart()
--[[
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2B_1_1")
	EnableCameraControl(false)
--]]
	EnableSelectionChange(true)
	SpawnUnits("Enemy",Army)
	SpawnUnits("pat2",Army)
	SetTriggerCallbacks("unitPosition", onTriggerEnter_unitPosition, onTriggerLeave_unitPosition)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(true)
	
	ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_DOUBLE_TAP","BOTTOM_LEFT")
	AddTimer(6.5, removeText)
--[[
	AddTimer(5.5, guideUnit)
	AddTimer(5.0, removeText)
--]]
end

function onLevelStart()
--[[
	SetTriggerCallbacks("pikemenLeft_Start", onTriggerEnter_patrolLeftStart)
	SetTriggerCallbacks("pikemenRight_Start", onTriggerEnter_patrolRightStart)
	SetTriggerCallbacks("pikemenLeft_Finish", onTriggerEnter_patrolLeftFinish)
	SetTriggerCallbacks("pikemenRight_Finish", onTriggerEnter_patrolRightFinish)
	SetTriggerCallbacks("enemyNotice1", onTriggerEnter_enemyNotice1)
	SetTriggerCallbacks("enemyNotice2", onTriggerEnter_enemyNotice2)
--]]
	SetWinnable(false)
--	SetVictoryBarEnabled(true)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
	
--	startpatrols()
--	startpatrols2()
end

--[[
function startpatrols()
	GiveNamedUnitMoveOrder("pat1","pikemenLeft_Finish")
	SetCanGrowAwareness("pat1",true)
	startpatrols2()
end

function startpatrols2()
	GiveNamedUnitMoveOrder("pat2","pikemenRight_Finish")
	SetCanGrowAwareness("pat2",true)
end

function onTriggerEnter_patrolLeftStart(unit)
	if unit.spawnId == "pat1" then
		GiveNamedUnitMoveOrder("pat1","pikemenLeft_Finish")
	end
end

function onTriggerEnter_patrolRightStart(unit)
	if unit.spawnId == "pat2" then
		GiveNamedUnitMoveOrder("pat2","pikemenRight_Finish")
	end
end

function onTriggerEnter_patrolLeftFinish(unit)
	if unit.spawnId == "pat1" then
		GiveNamedUnitMoveOrder("pat1","pikemenLeft_Start")
	end
end

function onTriggerEnter_patrolRightFinish(unit)
	if unit.spawnId == "pat2" then
		GiveNamedUnitMoveOrder("pat2","pikemenRight_Start")
	end
end

function onTriggerEnter_enemyNotice1(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard","TXT_MISSION2B_1_4")
		GiveNamedUnitMoveOrder("pat1","enemyNotice1")
		GiveNamedUnitMoveOrder("pat2","enemyNotice2")
		DisableTrigger("enemyNotice1")
		DisableTrigger("enemyNotice2")
		DisableTrigger("pikemenLeft_Start")
		DisableTrigger("pikemenRight_Start")
		DisableTrigger("pikemenLeft_Finish")
		DisableTrigger("pikemenRight_Finish")
	end
end

function onTriggerEnter_enemyNotice2(unit)
	if unit.attacker then
		ShowDialog("talkingheads/full/guard","TXT_MISSION2B_1_4")
		GiveNamedUnitMoveOrder("pat1","enemyNotice1")
		GiveNamedUnitMoveOrder("pat2","enemyNotice2")
		DisableTrigger("enemyNotice1")
		DisableTrigger("enemyNotice2")
		DisableTrigger("pikemenLeft_Start")
		DisableTrigger("pikemenRight_Start")
		DisableTrigger("pikemenLeft_Finish")
		DisableTrigger("pikemenRight_Finish")
	end
end


function guideUnit()
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTargetCircle("highlight1")
	AddTargetCircle("highlight2")
	FrameCamera("highlight1")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2B_1_2")
	AddTimer(4.0, cameraRightSide)
	AddTimer(6.5, EnableControls)
	AddTimer(5.0, removeText)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function cameraRightSide()
	ReturnCamera()
	AddTimer(0.05, cameraRightSideActive)
end

function cameraRightSideActive()
	FrameCamera("highlight2")
	AddTimer(3.0,returnCam)
end

function returnCam()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2B_1_3")
	ReturnCamera()
	AddTimer(4.0, removeText)
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function LevelComplete()
	AddTimer(2, Win)
end


--]]

function removeText()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("pat2",Army)
	end
end

--[[
function onTriggerEnter_unitPosition(unit)
	ClearTargetCircles()
end
--]]

function onUnitDestroyed(unit)
        if unit.defender then
			destroyed = destroyed + 1
			if destroyed == 4 then
				Win()
			end
		end
end
