Army = 1
Army1 = 1
destroyed = 0

escortDead = false
escortComplete = false

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2B_2_1")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	SpawnUnits("Enemy",Army)
	SetTriggerCallbacks("unitPosition", onTriggerEnter_unitPosition, onTriggerLeave_unitPosition)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	AddTimer(4.5, spawnSkeletons)
	AddTimer(4.0, removeText)
end

function onLevelStart()
	SetWinnable(false)
	SetVictoryBarEnabled(true)
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
	AddTimer(6.0, wave1FX)
	DropSpell("Fireball", 5, "SpellDrop")
--	DropSpell("Fireball", 5, "SpellDrop1")
	DropSpell("Fireball", 5, "SpellDrop2")
end

function spawnSkeletons()
	ShowDialogEternal("talkingheads/full/soldier_corrupt","TXT_MISSION2B_2_2")
	FrameCamera("skeletonLeft")
	EnableCameraControl(false)
	EnableSelectionChange(false)
	AddTimer(3.5, cameraRightSide)
	AddTimer(1.0, spawnLeftFX)
	AddTimer(4.0, removeText)
end

function removeText()
	HideDialog()
end

function spawnLeftFX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX_west1")
	AddTimer(1.0, spawnLeft)
end

function spawnLeft()
	SpawnUnits("leftSkeleton",Army)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
	end
end

function cameraRightSide()
	ReturnCamera()
	AddTimer(0.05, cameraRightSideActive)
end

function cameraRightSideActive()
	FrameCamera("skeletonRight")
	AddTimer(1.0, spawnRightFX)
	AddTimer(4.0,returnCam)
end

function spawnRightFX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX_east2")
	AddTimer(1.0, spawnRight)
end

function spawnRight()
	SpawnUnits("rightSkeleton",Army)
end

function returnCam()
	ReturnCamera()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION2B_2_3")
	AddTimer(4.0, EnableControls)
	AddTimer(4.0, removeText)
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function createStartingTroops(forPlinthInspector)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("leftSkeleton",Army)
		SpawnUnits("rightSkeleton",Army)
		SpawnUnits("Skeleton2",Army)
		SpawnUnits("Skeleton4",Army)
		SpawnUnits("Skeleton3",Army)
		SpawnUnits("Skeleton6",Army)
		SpawnUnits("Skeleton7",Army)
		SpawnUnits("Skeleton1",Army)
		SpawnUnits("Skeleton5",Army)
	end
end

function onTriggerEnter_unitPosition(unit)
	ClearTargetCircles()
end

function wave1FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX_north1")
	AddTimer(1.0, wave1)
end

function wave1()
	SpawnUnits("Skeleton2",Army)
	SpawnUnits("Skeleton4",Army)
	AddTimer(7.0, wave2FX)
end

function wave2FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX_north2")
	PlayVFX("PA_SpawnReinforcement", "spawnFX_south1")
	PlayVFX("PA_SpawnReinforcement", "spawnFX_south2")
	AddTimer(1.0, wave2)
end

function wave2()
	SpawnUnits("Skeleton3",Army)
	SpawnUnits("Skeleton6",Army)
	SpawnUnits("Skeleton7",Army)
	AddTimer(9.0, wave3FX)
end

function wave3FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX_west2")
	PlayVFX("PA_SpawnReinforcement", "spawnFX_east1")
	AddTimer(1.0, wave3)
end

function wave3()
	SpawnUnits("Skeleton1",Army)
	SpawnUnits("Skeleton5",Army)
end

function onUnitDestroyed(unit)
        if unit.defender then
			destroyed = destroyed + 1
			if destroyed == 10 then
				Win()
			end
		end
end
