
SpellLevel = 0
Army = 0
Army1 = 0
Army2 = 0
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetTriggerCallbacks("left", left_onTriggerEnter, left_onTriggerLeave)
	SetTriggerCallbacks("right", right_onTriggerEnter, right_onTriggerLeave)
	PlayVFX("ElderStone_EnergyProp", "stone")
	PlayVFX("ElderStone_EnergyProp", "stone1")
	PlayVFX("ElderStone_EnergyProp", "stone2")
	PlayVFX("ElderStone_EnergyProp", "stone3")
end

function onLevelStart()
--	SetWinnable(false)
end

function left_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "start1FX")
		AddTimer(1,start1)
		DisableTrigger("left")
	end
end

function right_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "start2FX")
		AddTimer(1,start2)
		DisableTrigger("right")
	end
end

function start1()
	SpawnUnits("start1",Army1)
end

function start2()
	SpawnUnits("start2",Army2)
end

-- Added new enemy death counters for staggered spawns
function onUnitDestroyed(unit)
	if unit.spawnId == "startleft" then
			PlayVFX("PA_SpawnReinforcement", "start1aFX")
			AddTimer(1,start1a)
		elseif unit.spawnId == "startright" then
--				elseif destroyed == 2 then
			PlayVFX("PA_SpawnReinforcement", "start2aFX")
			AddTimer(1,start2a)
		end
end

function start1a()
	SpawnUnits("start1a",Army1)
end

function start2a()
	SpawnUnits("start2a",Army2)
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("startleft",Army)
	SpawnUnits("startright",Army)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("startleft",Army)
		SpawnUnits("startright",Army)
		SpawnUnits("start1",Army1)
		SpawnUnits("start2",Army2)
		SpawnUnits("start1a",Army1) -- new spawnIDs added for staggered spawn waves
		SpawnUnits("start2a",Army2) -- new spawnIDs added for staggered spawn waves
	end
end

