destroyed = 0
Army = 1
Army1 = 1
Army2 = 2
Titan = 4

function QueueAssets()--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	SetWinnable(false)
	createStartingTroops(False)
	ShowDialog("talkingheads/full/guard","TXT_MISSION3A_4_1")
	AddTargetCircle("loss")
	AddTargetCircle("loss1")
	AddTargetCircle("loss2")
	AddTimer(5.0,removeText)
end

function removeText()
	HideDialog()
end

function onLevelStart()
	
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("loss", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)
	SetTriggerCallbacks("loss1", onTriggerEnter_End_Zone1, onTriggerLeave_End_Zone1)
	SetTriggerCallbacks("loss2", onTriggerEnter_End_Zone2, onTriggerLeave_End_Zone2)
	AddTimer(10.0, spawnWaveOneFX)
end

function spawnWaveOneFX()--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
	PlayVFX("PA_SpawnReinforcement", "Wave1")
	AddTimer(1.0, spawnWaveOne)
end

function spawnWaveOne()
	SpawnUnits("wave1",Army1)
	AddTimer(8.0, spawnWaveTwoFX)--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
end

function spawnWaveTwoFX()--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
	PlayVFX("PA_SpawnReinforcement", "Wave2")
	AddTimer(1.0, spawnWaveTwo)
end

function spawnWaveTwo()
	SpawnUnits("wave2",Army) --Jkung DOT-36504 1/2 of wing defenders moved next to Titan in json file
	AddTimer(8.0, spawnWaveThreeFX)--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
end

function spawnWaveThreeFX()--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
	PlayVFX("PA_SpawnReinforcement", "Wave3Left")
	PlayVFX("PA_SpawnReinforcement", "Wave3Right")
	AddTimer(1.0, spawnWaveThree)
end

function spawnWaveThree()
	SpawnUnits("wave3",Army2)
	AddTimer(8.0, spawnWaveFourFX)--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
end

function spawnWaveFourFX()--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
	PlayVFX("PA_SpawnReinforcement", "Wave4")
	AddTimer(1.0, spawnWaveFour)
end

function spawnWaveFour()
	SpawnUnits("wave4",Army1)
	AddTimer(8.0, spawnTitanFX)--Jkung DOT-36504 adding spawn FX to call attention to Titan and troops coming in waves 
end

function spawnTitanFX()
	PlayVFX("PA_SpawnReinforcement", "TitanSpawn")
	AddTimer(1.0,spawnTitan)--Jkung DOT-36504 Titan moved to center for visibility
end

function spawnTitan()
	SpawnUnits("Titan",Titan)
end

function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("Enemy",Army1)
		SpawnUnits("wave1",Army1)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army2)
		SpawnUnits("wave4",Army1)
		SpawnUnits("Titan",Titan)
	end
end



function onTriggerEnter_End_Zone(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onTriggerEnter_End_Zone1(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onTriggerEnter_End_Zone2(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onUnitDestroyed(unit)
	
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			Win()
		end
	end

end

