destroyed = 0
Army = 2
Army1 = 1
Army2 = 6 -- not used
Titan = 20
Ally = 15

function QueueAssets()
  QueueVFX("Elderstone_EnergyPropStones")
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Pikemen",Army)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Titan",Titan)
	SetWinnable(false)
	createStartingTroops(False)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	EnableSelectionChange(false)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_4_1")
	AddTimer(4.0, removeText)
	AddTimer(4.5, showTitan)
	local units = GetUnits("Titan", "*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onLevelStart()
	Standstill()
	SetVictoryBarEnabled(false)
	AddTimer(10.0, portalStart)
	local units = GetUnits("Titan", "*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onLevelStart()
	SetVictoryBarEnabled(false)
	AddTimer(20.0, portalStart)
	local units = GetUnits("Titan", "*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function portalStart()
	ShowDialogInPosition("talkingheads/full/guard","TXT_MISSION3B_4_2","BOTTOM_LEFT")
	PlayVFX("Elderstone_EnergyPropStones", "portal1")
	PlayVFX("Elderstone_EnergyPropStones", "portal2")
	PlayVFX("Elderstone_EnergyPropStones", "portal3")
	PlayVFX("Elderstone_EnergyPropStones", "portal4")
	AddTimer(15.0, allyArrival)
	GiveNamedUnitMoveOrder("wave2", "run")
end

function allyArrival()
	ShowDialog("talkingheads/full/generictitan","TXT_MISSION3B_4_3")
	PlayVFX("PA_SpawnReinforcement", "ally1")
	PlayVFX("PA_SpawnReinforcement", "ally2")
	PlayVFX("PA_SpawnReinforcement", "ally3")
	PlayVFX("PA_SpawnReinforcement", "ally4")
	AddTimer(1.0, spawnAlly)
	
end

function spawnAlly()
	SpawnUnits("Ally",Ally)
end

function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Titan",Titan)
		SpawnUnits("wave1", Army1)
		SpawnUnits("wave2", Army1)
		SpawnUnits("Pikemen",Army)
	end
	
end

function removeText()
	HideDialog()
end

function showTitan()
	FrameCamera("titan")
	ShowDialogEternal("talkingheads/full/ragnardip","TXT_MISSION3B_4_4")
	--AddTargetCircle("pikemen")
	AddTimer(4.0, removeText)
	AddTimer(4.0, goHome)
end

function goHome()
	ReturnCamera()
	AddTimer(1.5, spawnEnemy)
	AddTimer (3.0, goHome2)
end

function spawnEnemy()
	SpawnUnits("wave1", Army1)
	SpawnUnits("wave2", Army1)
end

function goHome2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MISSION3B_4_5", "BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(4.0, EnableControls)
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.spawnId == "Titan" then
	   AddTimer(0.5,YouWin)
	end
end

function Standstill() -- tells the unit to stand ground
                local units = GetUnits("Titan", "*", 1)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
                SetCanGrowAwareness("Titan",false)
				AddTimer(1.0, Standstill)
end

function YouWin()
   Win()
 end
