destroyed = 0
SpellLevel = 3
Rank = 0
Army = 2
Army1 = 3
Army2 = 2
Titan = 13

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army)
    SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(4.5, story)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function onLevelStart()
--	ShowDialogEternal("talkingheads/full/almarand","TXT_MISSION3C_3_6")
	AddTimer(3.0, fireball)
	AddTimer(4.0, removeText)
	AddTimer(6.0, wave1)
	AddTimer(0.10, EnableControls)
end

function wave1()
	SpawnUnits("wave1", Army1)
end

function story()
    ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_3_1")
	AddTimer(4.0, removeText)
--	AddTimer(4.0, secondaryText)
end

function removeText()
	HideDialog()
	SetFightButtonEnabled(true)
end

--[[
function secondaryText()
	ShowDialogEternal("talkingheads/full/soldier_corrupt","TXT_MISSION3C_3_2")
	AddTimer(4.0, removeText)
	AddTimer(4.0, almaranadappear)
end

function almaranadappear()
	FrameCamera("titan")
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1.0, almaranadappear2)
end

function almaranadappear2()
	SpawnUnits("Titan",Titan)
	AddTimer(1.0, tertiaryText)
end

function tertiaryText()
	ShowDialogEternal("talkingheads/full/almarand","TXT_MISSION3C_3_3")
	AddTimer(4.0, fourthText)
	AddTimer(4.0, removeText)
end

function fourthText()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_3_4")
	AddTimer(4.0, fifthtext)
	AddTimer(4.0, removeText)
end

function fifthtext()
	ShowDialogEternal("talkingheads/full/almarand","TXT_MISSION3C_3_5")
	AddTimer(4.0, EnableControls)
	AddTimer(4.0, removeText)
	AddTimer(4.0, returnCam)
end


function returnCam()
	ReturnCamera()
end
--]]

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
end

function fireball()
	CastSpell("Fireball", 1, "fire1",0)
	CastSpell("Fireball", 1, "fire2",0)
--[[
	CastSpell("Fireball", 1, "fire3",0)
	CastSpell("Fireball", 1, "fire4",0)
	CastSpell("Fireball", 1, "fire5",0)
	CastSpell("Fireball", 1, "fire6",0)
--]]
	CastSpell("Fireball", 1, "fire7",0)
	CastSpell("Fireball", 1, "fire8",0)
--	AddTimer(4.0, almarandDisappear)
end

--[[
function almarandDisappear()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1.0, almarandDisappear2)
end

function almarandDisappear2()
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end
end
--]]

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 9 then
			SetMultipleUnitSelectionButtonEnabled(false)
			SetStandGuardButtonEnabled(false)
			SetAutoOrdersButtonEnabled(false)
			SetFightButtonEnabled(false)
--			Standstill()
--			ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_3_7")
			AddTimer(4.0, removeText)
			AddTimer(1.0, showEnemy)
		end
		
	end
end

function showEnemy()
--	FrameCamera("titan")
--	SpawnUnits("end",Army)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_3_7")
--	AddTimer(2.0, belecOwned)
	AddTimer (2.0, winning)
end

--[[
function belecOwned()
--	SpawnUnits("end",Army)
--	AddTimer(2.0, belecOwned)
--	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_3_8")
	AddTimer (2.0, winning)
end
--]]

function winning()
    Win()
end

--[[
function Standstill() -- tells the unit to stand ground
                local units = GetUnits("*", "*", 0)
                for i,unit in pairs(units) do
                     SetUnitStandGuard(unit, true)
                end
end
--]]

function createStartingTroops(forPlinthInspector)
       
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
        SpawnUnits("wave1",Army1)
		SpawnUnits("Enemy",Army)
	end
end










