destroyed = 0
Army = 5

function QueueAssets()
  QueueVFX("ElderStone_EnergyPropStones")
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("flank",Army)
	SpawnUnits("Enemy",Army)
		
	if forPlinthInspector then
		SpawnUnits("flank",Army)
		SpawnUnits("Enemy",Army)
	end
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
end

function onLevelStart()
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	ClearTargetCircles()
	AddTargetCircle("circle")
end

function trigger1_onTriggerEnter(unit)

	if unit.attacker then
		AddTimer(2.0, Victory)
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN4A_2_VICTORY")
		DisableTrigger("trigger1")
	end

end

function trigger2_onTriggerEnter(unit)

	if unit.attacker then
		DisableTrigger("trigger2")
		local units = GetUnits("flank", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger2")
		end
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			AddTargetCircleWithArrow("circle")
		end
	end
end

function Victory()
	Win()
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
		AddTargetCircleWithArrow("circle")
	end
end

function framecamera(seconds)
	FrameCamera("camera")
	PlayVFX("ElderStone_EnergyPropStones", "fx1")
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN4A_2_INTRO")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6,buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end
