
SpellLevel = 0
Army = 5
Army1 = 5
Army2 = 0
Rank = 0
destroyed = 0

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(False)  -- This part here
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN4C_2_INTRO")
end

function onLevelStart()
	SetTriggerCallbacks("fx1", fx1_onTriggerEnter, fx1_onTriggerLeave)
	SetTriggerCallbacks("fx2", fx2_onTriggerEnter, fx2_onTriggerLeave)
	SetTriggerCallbacks("fx3", fx3_onTriggerEnter, fx3_onTriggerLeave)
	SetTriggerCallbacks("fx4", fx4_onTriggerEnter, fx4_onTriggerLeave)
	SetTriggerCallbacks("fx5", fx5_onTriggerEnter, fx5_onTriggerLeave)
	SetTriggerCallbacks("fx6", fx6_onTriggerEnter, fx6_onTriggerLeave)
	SetTriggerCallbacks("fx7", fx7_onTriggerEnter, fx7_onTriggerLeave)
	SetTriggerCallbacks("re1", re1_onTriggerEnter, re1_onTriggerLeave)
	SetTriggerCallbacks("re2", re2_onTriggerEnter, re2_onTriggerLeave)
	SetTriggerCallbacks("re4", re4_onTriggerEnter, re4_onTriggerLeave)
	SetTriggerCallbacks("re5", re5_onTriggerEnter, re5_onTriggerLeave)
	SetTriggerCallbacks("re6", re6_onTriggerEnter, re6_onTriggerLeave)
	SetTriggerCallbacks("re7", re7_onTriggerEnter, re7_onTriggerLeave)
	SetVictoryBarEnabled(false)
	
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("start",Army)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		RespawnUnits("start",Army)
		RespawnUnits("wave1",Army)
		RespawnUnits("wave2",Army)
		RespawnUnits("wave1",Army)
		RespawnUnits("wave2",Army)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
		    PlayVFX("PA_SpawnReinforcement", "fx1")
			PlayVFX("PA_SpawnReinforcement", "fx2")
			AddTimer(1, SpawnWave) 
		elseif destroyed == 5 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_CAMPAIGN4C_2_WAVE")
			PlayVFX("PA_SpawnReinforcement", "fx6")
			PlayVFX("PA_SpawnReinforcement", "fx7")
			AddTimer(1.0, SpawnWave)
		elseif destroyed == 6 then
		    ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_CAMPAIGN4C_2_REINFORCE")
			PlayVFX("PA_SpawnReinforcement", "re1")
			PlayVFX("PA_SpawnReinforcement", "re2")
			PlayVFX("PA_SpawnReinforcement", "re4")	
			PlayVFX("PA_SpawnReinforcement", "re5")
			AddTimer(1.0, SpawnWave)
		elseif destroyed == 7 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_CAMPAIGN4C_2_WAVE2")
			PlayVFX("PA_SpawnReinforcement", "fx1")
			PlayVFX("PA_SpawnReinforcement", "fx2")
			PlayVFX("PA_SpawnReinforcement", "fx3")
			PlayVFX("PA_SpawnReinforcement", "fx4")	
			PlayVFX("PA_SpawnReinforcement", "fx5")
			PlayVFX("PA_SpawnReinforcement", "fx6")
			PlayVFX("PA_SpawnReinforcement", "fx7")		
			AddTimer(1.0, SpawnWave)
		end
	end
end

function SpawnWave()

	if destroyed == 3 then
		RespawnUnits("wave1",Army)
	elseif destroyed == 5 then
		RespawnUnits("wave2",Army)
	elseif destroyed == 6 then
		SpawnUnits("buddy")
	elseif destroyed == 7 then
		SetVictoryBarEnabled(true)
		SetWinnable(true)
		RespawnUnits("start",Army)
		RespawnUnits("wave1",Army)
		RespawnUnits("wave2",Army)
	end
end


