PlayerUnits = 0
Endpoint = 0
destroyed = 0
dead = 0
defending = 0
killed = 0
SpellLevel = 0
left = 0
winning = 0
Army2 = 5

function QueueAssets()
  
end

function onDeployStart()
    SetWinnable(false)
	createStartingTroops(False)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
end

function onLevelStart()
	--SpawnUnits("spawn1",Army)
	SetVictoryBarFill(0.4)
	ClearTargetCircles()
	SetTriggerCallbacks("bypass", bypass_onTriggerEnter)
	SetTriggerCallbacks("leftside", leftside_onTriggerEnter)
end

function bypass_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("bypass")
		DisableTrigger("leftside")
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_5")
		awake()
		left = 2
	end
end

function leftside_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("bypass")
		DisableTrigger("leftside")
		left = 1
	end
end

function awake()
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4F_1_3")
	SetVictoryBarFill(0.2)
	AddTimer(1,pikeman)
end

function archer()
    SpawnUnits("archer",Army2)
	AddTimer(2.5,pikeman1)
end
function archer1()
    SpawnUnits("archer1",Army2)
end
function pikeman()
    SpawnUnits("pikeman",Army2)
	AddTimer(2.5,archer)
end
function pikeman1()
    SpawnUnits("pikeman1",Army2)
	AddTimer(2.5,archer1)
end

function onUnitDestroyed(unit)
	if unit.defender then
		--destroyed = destroyed + 1
		if left == 0 then
		    killed = killed + 1
			if killed == 1 then
            DisableTrigger("bypass")
		    DisableTrigger("leftside")
			SetVictoryBarFill(0.45)
			end
			if killed == 4 then
			awake()
			end
			if killed == 6 then
			SetVictoryBarFill(0.7)
			end
			if killed == 8 then
			win()
			end
		end
		if left == 2 then
		    destroyed = destroyed + 1
			if destroyed == 4 then
			GiveNamedUnitMoveOrder("leftb", "chargeb") 
            GiveNamedUnitMoveOrder("leftf", "chargef")
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_6")
			SetVictoryBarFill(0.5)
			end
			if destroyed == 6 then
			SetVictoryBarFill(0.7)
			end
			if destroyed == 8 then
			win()
			end
		end
		if left == 1 then
		    dead = dead + 1
			if dead == 3 then
			SetVictoryBarFill(0.5)
			end
			if dead == 4 then
			awake()
			end
			if dead == 6 then
			SetVictoryBarFill(0.7)
			end
			if dead == 8 then
			win()
			end
		end		
	end
end

function win()
    SetVictoryBarFill(1)
    Win()
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 2
	SpellLevel = 0
	Army = 1
	Army1 = 1
	
	SpawnUnits("leftb",Army2)
	SpawnUnits("leftf",Army2)

	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("archer",Army2)
		SpawnUnits("archer1",Army2)
		SpawnUnits("pikeman",Army2)
		SpawnUnits("pikeman1",Army2)
		SpawnUnits("leftb",Army2)
		SpawnUnits("leftf",Army2)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
    ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4F_1_1","TOP_LEFT")
--	FrameCamera("camera")
--	AddTimer(5, ReturnCamera)
	EnableCameraControl(false)
--	AddTargetCircleWithArrow("capture")
	AddTimer(5,framecamera1)
end

function framecamera1(seconds)
    ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4F_1_2","TOP_LEFT")
--	FrameCamera("camera1")
--	EnableCameraControl(false)
--	AddTimer(5, ReturnCamera)
	AddTimer(5,framecamera2)
--	ClearTargetCircles()
--	AddTargetCircle("capture")
end

function framecamera2(seconds)
    ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_4F_3_4","TOP_LEFT")
--	FrameCamera("camera2")
--	EnableCameraControl(false)
--	AddTimer(5, ReturnCamera)
	AddTimer(5,buttonunlock)
--	ClearTargetCircles()
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end





