destroyed = 0
SpellLevel = 0
Army = 20
Rank = 0
Army1 = 20
Army2 = 20
Titan = 30

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	AddTargetCircle("capture")
	
end


function onLevelStart()	
	SetTriggerCallbacks("capture", capture_onTriggerEnter) 
	SetVictoryBarEnabled(false)
	SetVictoryBarFill(0)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8C_6_1")
	end
end

-- Enemy Wave Elements
-- Wave 1
function startWave1()
	PlayVFX("PA_SpawnReinforcement", "teleLeft1")
	PlayVFX("PA_SpawnReinforcement", "teleLeft2")
	PlayVFX("PA_SpawnReinforcement", "teleRight1")
	PlayVFX("PA_SpawnReinforcement", "teleRight2")
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8C_6_3")
	AddTimer(1, spawnWave1)
end
function spawnWave1()
	SpawnUnits("start",Army1)
	SetVictoryBarEnabled(true)
	SetupVictoryBar()
	--AddTimer(5, startMoss0)
end

-- Wave 2
function startWave2()
	PlayVFX("PA_SpawnReinforcement", "teleLeft")
	PlayVFX("PA_SpawnReinforcement", "teleLeft1")
	PlayVFX("PA_SpawnReinforcement", "teleRight")
	PlayVFX("PA_SpawnReinforcement", "teleRight2")
	PlayVFX("PA_SpawnReinforcement", "tele")
	AddTimer(1, spawnWave2)
end
function spawnWave2()
	SpawnUnits("start1",Army1)
	--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN8C_6_4")
end

-- Wave 3
function startWave3()
    PlayVFX("PA_SpawnReinforcement", "teleTitan") 
	AddTimer(1, spawnWave3)
end
function spawnWave3()
	SpawnUnits("startTitan",Titan)
	--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN8C_6_5")
end

-- Wave 5
function startEnding()
	AddTimer(1, spawnEnding)
end
function spawnEnding()
	--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN8C_6_6")
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8C_6_7")
	AddTimer(8, startFireballs)
end

-- Ending fireball sequence
function startFireballs()
    CastSpell("Fireball", 5, "fireball1",1)
	AddTimer(1, startFireball2)
end
function startFireball2()
    CastSpell("Fireball", 5, "fireball2",1)
	AddTimer(0.8, startFireball3)
end
function startFireball3()
    CastSpell("Fireball", 5, "fireball3",1)
	AddTimer(0.6, startFireball4)
end
function startFireball4()
    CastSpell("Fireball", 5, "fireball4",1)
	AddTimer(0.5, startFireball5)
end
function startFireball5()
    CastSpell("Fireball", 5, "fireball5",1)
	AddTimer(0.5, startFireball6)
end
function startFireball6()
    CastSpell("Fireball", 5, "fireball6",1)
	AddTimer(0.5, startFireball7)
end
function startFireball7()
    CastSpell("Fireball", 5, "fireball7",1)
	AddTimer(0.5, startFireball8)
end
function startFireball8()
    CastSpell("Fireball", 5, "fireball8",1)
	AddTimer(0.5, startFireball9)
end
function startFireball9()
    CastSpell("Fireball", 5, "fireball9",1)
	AddTimer(0.5, startFireball10)
end
function startFireball10()
    CastSpell("Fireball", 5, "fireball10",1)
	AddTimer(0.5, startFireball11)
end
function startFireball11()
    CastSpell("Fireball", 5, "fireball11",1)
	AddTimer(0.5, startFireball12)
end
function startFireball12()
    CastSpell("Fireball", 5, "fireball12",1)
	AddTimer(0.5, startFireball13)
end
function startFireball13()
    CastSpell("Fireball", 5, "fireball13",1)
	AddTimer(1, startTerror)
end
function startTerror()
    CastSpell("Terror", 5, "spirit",0)
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8C_6_8")
	AddTimer(6, win)
end

-- win 
function win()
    SetWinnable(true)
end

function capture_onTriggerEnter(unit)
	if unit.attacker then
	   -- ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8C_6_2")
	    AddTimer(6, startWave1)
		DisableTrigger("capture")
	end
end

-- Active battle elements that determine waves
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			startWave2()
			SetVictoryBarFill(0.3)
		end
		if destroyed == 9 then
			startWave3()
			SetVictoryBarFill(0.6)
		end
		if destroyed == 10 then -- not really here normally!
			startEnding()
			SetVictoryBarFill(1)
		end
	end
end

-- Wave victory bar functionality
function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/10)
	AddVictoryBarMarker(6/10)
	AddVictoryBarMarker(1.0)
end

function createStartingTroops(forPlinthInspector)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army1)
		SpawnUnits("start1",Army1)
		SpawnUnits("startTitan",Titan)
	end
end








