destroyed = 0
SpellLevel = 11
Army = 11
Army1 = 11
Rank = 0

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	createStartingTroops(false)
end


function onLevelStart()
    SetBattleTimeoutTime(300, 0) -- set battle timer for 6 minutes
	SetupVictoryBar()	
	SetVictoryBarFill(0)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/guard","TXT_CAMP_ELITHEN_3_5_INTRO")
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			SpawnUnits("spawn1",Army)
			SetVictoryBarFill(0.2)
		elseif destroyed == 7 then
			SpawnUnits("spawn2",Army)
			SetVictoryBarFill(0.4)
		elseif destroyed == 9 then
		    SpawnUnits("spawn3",Army)
			SetVictoryBarFill(0.7)
			SetWinnable(true)
		elseif destroyed == 14 then
			SetVictoryBarFill(1)
			SetWinnable(true)
		end
	end
end

function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 and Rank <= 13 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		elseif Rank >= 14 then
			SpellLevel = 13
			Army = 11
			Army1 = 12
			Army2 = 14
		end
--]]
		SpawnUnits("start",Army)
	
--		SpawnUnits("spawn1",Army) 
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("start",Army)
		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn3",Army)
	end
end



function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(0.2)
	AddVictoryBarMarker(0.4)
	AddVictoryBarMarker(0.7)
	AddVictoryBarMarker(1.0)
end













