destroyed = 0
SpellLevel = 7
Army = 9
Army1 = 9
Army2 = 7
Army3 = 4 -- Jkung DOT-35259 - added for ally elithen as they were too op once invulnerability turns off
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetTriggerCallbacks("opening", opening_onTriggerEnter, opening_onTriggerLeave)
	SetMultipleUnitSelectionButtonEnabled(false)-- Jkung DOT-35259 - Added to be consistent with rest of game
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)-- Jkung DOT-35259 - Added to be consistent with rest of game
end

function onLevelStart()
    SetBattleTimeoutTime(300, 0) -- set battle timer for 6 minutes
    SetAI1() -- allies
	SetAI2() -- enemy attacking allies
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_6_1")
		--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_6_2")
		ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_ELITHEN_6_3")
--		AddTimer(1.0, framecamera1)
		FrameCamera("camera")
		AddTimer(3.5,startgame) -- Jkung DOT-35259 - reduced amount of time camera is in cutscene
		AddTimer(3.0, ReturnCamera) -- Jkung DOT-35259 - reduced amount of time camera is in cutscene
	end
end

--[[							-- Jkung DOT-35259 - moved scripts up to above script
function framecamera1(seconds)
	FrameCamera("camera")
	AddTimer(3.0, ReturnCamera) 
end
--]]


--[[                                            -- Jkung DOT-35259 - redundent scripts
function onTalkingHeadFinish(text)
	if text == "TXT_CAMPAIGN_ELITHEN_6_3" then
		HideDialog()
		SetFightButtonEnabled(true)
		SetAutoOrdersButtonEnabled(true)
		SetStandGuardButtonEnabled(true)
		SetMultipleUnitSelectionButtonEnabled(true)
		AddTimer(1.0, SpawnOneEnemyUnit)
		PlayVFX("PA_SpawnReinforcement", "lefttrap")
		PlayVFX("PA_SpawnReinforcement", "righttrap")
		PlayVFX("PA_SpawnReinforcement", "middletrap")
		--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_6_4")
	end
end
--]]

function startgame()
	HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	AddTimer(1.0, SpawnOneEnemyUnit)
	--PlayVFX("PA_SpawnReinforcement", "elithenright1")
	--PlayVFX("PA_SpawnReinforcement", "elithenright2")
	--PlayVFX("PA_SpawnReinforcement", "archerright")
	PlayVFX("PA_SpawnReinforcement", "lefttrap")
	PlayVFX("PA_SpawnReinforcement", "righttrap")
	PlayVFX("PA_SpawnReinforcement", "middletrap")
	--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_6_4")
end

function SpawnOneEnemyUnit()
	SpawnUnits("start1",Army)
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
			SetAlliedPlayers(2, 0)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
		    --ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_ELITHEN_6_5")
			PlayVFX("PA_SpawnReinforcement", "backtrap")
			PlayVFX("PA_SpawnReinforcement", "backtrap1")
			PlayVFX("PA_SpawnReinforcement", "backtrap2")
			AddTimer(1, SpawnTwoEnemyUnit) 
		end
		if destroyed == 6 then
		--ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_6_6")
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		    	
		end
		if destroyed == 8 then
			--ShowDialogEternal("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_6_7")
			AddTimer(1.0,endgame)
            			
		end
	end
end

function SpawnTwoEnemyUnit()
	SpawnUnits("start2",Army1)
	SpawnUnits("start3",Army2) -- Jkung DOT-35259 - added for more control over when this Archer is spawned and it's level
end

function endgame()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 and Rank <= 11 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		elseif Rank >= 12 then
			SpellLevel = 12
			Army = 10
			Army1 = 11
			Army2 = 12
		end
--]]		
		SpawnUnits("ally", Army3)
		SpawnUnits("enemy", Army2)

	--SpawnUnits("start",Army1)
	
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("start1", Army)
		SpawnUnits("start2", Army1)
		SpawnUnits("start3", Army2)
--		SpawnUnits("skeleton",5)
	end
end

