destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 18
Army = 14

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
    --ShowDialog("talkingheads/full/Kobar", "TXT_CAMPAIGN_RAGNAR_2_6_1")
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	AddTimer(4.5,startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)

end



function onLevelStart()
	DisableAiSpells()
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 then
		wave()
		PlayVFX("ElderStone_EnergyPropStones", "p")
	    PlayVFX("ElderStone_EnergyPropStones", "p1")
		end
		if destroyed == 8 then
		    SetWinnable(true)
		end
	end
end

function wave()
    PlayVFX("PA_SpawnReinforcement", "portal")
    PlayVFX("PA_SpawnReinforcement", "portal1")
	--ShowDialog("talkingheads/full/Kobar", "TXT_CAMPAIGN_RAGNAR_2_6_2")
	AddTimer(1,wavespawn)
end
function wavespawn()
    SpawnUnits("start1",Army)
	AddTimer(5,wave1)
	StopVFX("ElderStone_EnergyPropStones", "p")
	StopVFX("ElderStone_EnergyPropStones", "p1")
end

function wave1()
    PlayVFX("PA_SpawnReinforcement", "portal")
    PlayVFX("PA_SpawnReinforcement", "portal1")
	PlayVFX("ElderStone_EnergyPropStones", "p")
	PlayVFX("ElderStone_EnergyPropStones", "p1")
	AddTimer(1,wavespawn1)
end
function wavespawn1()
    SpawnUnits("start2",Army)
	StopVFX("ElderStone_EnergyPropStones", "p")
	StopVFX("ElderStone_EnergyPropStones", "p1")
end

function ending()
    HideDialog()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("titan",Titan)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("titan",Titan)
	end
end










