destroyed = 0
SpellLevel = 11
Rank = 0
Titan = 22
Army = 15
Army1 = 15

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	AddTimer(0.5, story)	
end

function story()
	SpawnUnits("Leader")
	--ShowDialog("talkingheads/full/unakdip","TXT_CAMPAIGN_RAGNAR_3_3_1") -- needs to be unak!
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR_3_3_2")
	--ShowDialog("talkingheads/full/unakdip","TXT_CAMPAIGN_RAGNAR_3_3_3") -- needs to be unak!
	AddTimer(3.8, startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	GiveNamedUnitMoveOrder("titan", "move3")  -- tells the unit to run away
	Standstill()
end

function onLevelStart()
	SetTriggerCallbacks("trap", trap_onTriggerEnter)
	SetBattleTimeoutTime(240,0)
    SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "titan*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state.
	end	
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start1",Army)
		DisableTrigger("trap")
	end
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			--GiveNamedUnitMoveOrder("titan", "move2")  -- tells the unit to run away
			--Standstill()
		end
		if destroyed == 6 then
			--GiveNamedUnitMoveOrder("titan", "move3")  -- tells the unit to run away
			--Standstill1()
			AddTimer(2, hero)
		end
		if destroyed == 10 then
		   -- ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR_3_3_6")
			AddTimer(6, finish)
		end
	end
end

function finish()
    SetWinnable(true)
end

function hero()
    SpawnUnits("hero1",Army)
	SpawnUnits("hero2",Army)
	--ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN_RAGNAR_3_3_4") -- needs to be Ragnar!
	AddTimer(2, defend)
end

function defend()
    SpawnUnits("start2",Army)
	--ShowDialog("talkingheads/full/unakdip","TXT_CAMPAIGN_RAGNAR_3_3_5") -- needs to be unak!
end

function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("titan",false)	
end

function Standstill1() -- tells the unit to stand ground
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("titan",false)	
	AddTimer(10,awarenesson)
end

function awarenesson()
	SetCanGrowAwareness("titan",true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("titan",Titan)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("titan",Titan)
	end
end










