SpellLevel = 11
Army = 6
Rank = 0
Army1 = 6




function onDeployStart()

	ShowDialog("talkingheads/full/guard", "TXT_CAMP_UNAK3_4_INTRO")
	SetTriggerCallbacks("freeslaves1", freeslaves1_onTriggerEnter, freeslaves1_onTriggerLeave)
	SetTriggerCallbacks("freeslaves2", freeslaves2_onTriggerEnter, freeslaves2_onTriggerLeave)
	SetTriggerCallbacks("ambushspawn", ambushspawn_onTriggerEnter, ambushspawn_onTriggerLeave)
	AddTargetCircle("capture1")
	SetWinnable(false)
	createStartingTroops(False)
	
end

function createStartingTroops(forPlinthInspector)

	SpawnUnits("start",Army)
	SpawnUnits("unak1",Army)
	SpawnUnits("ragnarslave1",Army)
	SpawnUnits("unak2",Army)
	SpawnUnits("ragnarslave2",Army)
	
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("ambush1",Army)
		SpawnUnits("unak1",Army)
		SpawnUnits("unak2",Army)

	end
	
end

--Slaves Freed 1 - Start

function freeslaves1_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("flip") 
		fireball1()
--[[		local units = GetUnits("unak1", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			EnableAttackDamage(unit)
			SwitchSide(unit, 1)
		end --]]
		local units = GetUnits("ragnarslave1", "*", 2)
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
		end
		ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_4_FREE1")
		DisableTrigger("freeslaves1")
		ClearTargetCircles("capture1")
		AddTargetCircle("capture2")
	end
end

function fireball1()
	CastSpell("Fireball", 1, "fb1_1",.1)
	CastSpell("Fireball", 1, "fb1_2",.25)
end

--Slaves Freed 1 - End

--Slaves Freed 1 - Start

function freeslaves2_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("flip") 
		fireball2()
--[[		local units = GetUnits("unak2", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			EnableAttackDamage(unit)
			SwitchSide(unit, 1)
		end --]]
		local units = GetUnits("ragnarslave2", "*", 2)
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
		end
		--ShowDialog("talkingheads/full/Kobar", "TXT_CAMP_UNAK3_4_FREE2")
		DisableTrigger("freeslaves2")
		ClearTargetCircles("capture2")
		SetWinnable(true)
	end
end

function fireball2()
	CastSpell("Fireball", 1, "fb2_1",.1)
	CastSpell("Fireball", 1, "fb2_2",.25)
end

--Slaves Freed 1 - End

-- Spawn Final Battle START

-- Spawn Final Battle END
--]]

function ambushspawn_onTriggerEnter(unit)
	
	if unit.attacker then
		
		SpawnUnits("ambush1")
		
	end
end
