

AttackersZone1 = false
AttackersZone2 = false
DefendersZone1 = true
DefendersZone2 = true
Captured1 = false
Captured2 = false
respawner = 0
killcount = 0
SpellLevel = 0
Army = 0
Rank = 0

function onDeployStart()
	AddTargetCircle("Capture1")
	createStartingTroops(False)
	ShowDialog("talkingheads/full/guard","TXT_KOH_1")
	AddTimer(5.0,removeText) -- JKung (DOT-33092) - add for polish, removing talking head pop up automatically. June 30, 2017
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 8
	--SpellLevel = 6
	--Army = 6

	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn2")
		SpawnUnits("spawn2")
		SpawnUnits("spawn2")
		SpawnUnits("spawn1")
		SpawnUnits("spawn1")
	end
end

function onLevelStart()
	SetTriggerCallbacks("Capture1", Capture1_onTriggerEnter, Capture1_onTriggerLeave) -- Player approaches the capture point
	triggercheck()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	ShowDialog("talkingheads/full/guard","TXT_KOH_2")
	AddTimer(5.0,removeText)-- JKung (DOT-33092)  - add for polish, removing talking head pop up automatically. June 30, 2017
	AddTimer(60.0,Victory)		--|
	SetBattleTimeoutTime(64.0,0) -- JKung (DOT-33092) - added 4 seconds to allow time for Win() function and victory camera to play out. June 30, 2017
	AddTimer(10.0,Spawnloop)	--|
end

function removeText() -- JKung (DOT-33092) - add for polish, removing talking head pop up automatically. June 30, 2017
	HideDialog()
end

function triggercheck()
	local var1 = CountDefendersInTrigger("Capture1")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true	
	end 
		
	local var3 = CountAttackersInTrigger("Capture1")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	Success()
	
end


function Success()
	AddTimer(3.0, triggercheck)
	if AttackersZone1 == true then 
		Captured1 = true
	else
		Captured1 = false 			
	end
	
	if Captured1 == false then
		AddTimer(10.0, enemywave)
	end
	
	if Captured1 == true then
		wincondition()
	end
end

function Capture1_onTriggerLeave(unit)
	if unit.attacker and Captured1==false then
	AddTimer(3.0, triggercheck)	
	end
end

function enemywave()
	SpawnUnits("spawn1")
end

function wincondition()
		CancelTimer(triggercheck)
--		ShowDialog("talkingheads/full/guard","TXT_KOH_2")
		SpawnUnits("spawn1")
--		AddTimer(60.0,Victory)		--|
--		SetBattleTimeoutTime(60.0,0.0)	--|-- These functions were moved up to onLevelStart() -(jkung) DoT-27262
--		AddTimer(10.0,Spawnloop)	--|
end

--(jkung) DoT-27262 - Added this function to pause the timer as soon as the player loses so they can see how much time was left
function onAttackerDestroyed()
	PauseDisplayTimer(true)
end

function Spawnloop()
	RespawnUnits("spawn2")
	AddTimer(20.0,Spawnloop)
end

function Victory()
	AddTimer(3.0, timeoutWin) -- JKung (DOT-33092) - added AddTimer with 3 seconds to allow for victory camera to play out. June 30, 2017
end

function timeoutWin()-- JKung (DOT-33092) - new Win() condition function, allows for the victory camera to play out. June 30, 2017
	Win()
end






































