destroyed = 0
SpellLevel = 0
Rank = 0
Army = 25
Titan = 60

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MOSSMANEADVENTURELEVEL10_1","BOTTOM_LEFT")
		AddTimer(4.0, removeText)
		AddTimer(5.0, talkingHead2)
	end
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_MOSSMANEADVENTURELEVEL10_2","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(5.0, revealUI)
end

function removeText()
	HideDialog()
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_177_10")
	GiveDefenderSpoil("H_424_10")
	GiveDefenderSpoil("EV_68_10")
	GiveDefenderSpoil("EV_69_10")
	GiveDefenderSpoil("EV_429_10")
	GiveDefenderSpoil("EV_256_10")
	
	AddTimer(10.0,spawnVfx1)
	AddTimer(11.0,spawnVfx2)
	AddTimer(12.0,spawnVfx3)
	AddTimer(13.0,spawnVfx4)
	AddTimer(14.0,spawnVfx5)
	AddTimer(15.0,spawnVfx6)
	AddTimer(16.0,spawnVfx7)
	AddTimer(17.0,spawnVfx8)
	AddTimer(18.0,spawnVfx9)
	AddTimer(19.0,spawnVfx10)
	AddTimer(20.0,spawnVfx11)
	AddTimer(21.0,spawnVfx12)
	AddTimer(22.0,spawnVfx13)
	AddTimer(23.0,spawnVfx14)
	AddTimer(24.0,spawnVfx15)
	AddTimer(25.0,spawnVfx16)
	AddTimer(26.0,spawnVfx17)
	AddTimer(27.0,spawnVfx18)
	
end

function spawnVfx1()
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	AddTimer(1.0, spawnwave1)
end

function spawnVfx2()
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	AddTimer(1.0, spawnwave2)
end

function spawnVfx3()
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	AddTimer(1.0, spawnwave3)
end

function spawnVfx4()
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	AddTimer(1.0, spawnwave4)
end

function spawnVfx5()
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	AddTimer(1.0, spawnwave5)
end

function spawnVfx6()
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	AddTimer(1.0, spawnwave6)
end

function spawnVfx7()
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	AddTimer(1.0, spawnwave7)
end

function spawnVfx8()
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	AddTimer(1.0, spawnwave8)
end

function spawnVfx9()
	PlayVFX("PA_SpawnReinforcement", "vfx9")
	AddTimer(1.0, spawnwave9)
end

function spawnVfx10()
	PlayVFX("PA_SpawnReinforcement", "vfx10")
	AddTimer(1.0, spawnwave10)
end

function spawnVfx11()
	PlayVFX("PA_SpawnReinforcement", "vfx11")
	AddTimer(1.0, spawnwave11)
end

function spawnVfx12()
	PlayVFX("PA_SpawnReinforcement", "vfx12")
	AddTimer(1.0, spawnwave12)
end

function spawnVfx13()
	PlayVFX("PA_SpawnReinforcement", "vfx13")
	AddTimer(1.0, spawnwave13)
end

function spawnVfx14()
	PlayVFX("PA_SpawnReinforcement", "vfx14")
	AddTimer(1.0, spawnwave14)
end

function spawnVfx15()
	PlayVFX("PA_SpawnReinforcement", "vfx15")
	AddTimer(1.0, spawnwave15)
end

function spawnVfx16()
	PlayVFX("PA_SpawnReinforcement", "vfx16")
	AddTimer(1.0, spawnwave16)
end

function spawnVfx17()
	PlayVFX("PA_SpawnReinforcement", "vfx17")
	AddTimer(1.0, spawnwave17)
end

function spawnVfx18()
	PlayVFX("PA_SpawnReinforcement", "vfx18")
	AddTimer(1.0, spawnwave18)
end

function spawnwave1()
	SpawnUnits("wave1",Army)
end

function spawnwave2()
	SpawnUnits("wave2",Army)
end

function spawnwave3()
	SpawnUnits("wave3",Army)
end

function spawnwave4()
	SpawnUnits("wave4",Army)
end

function spawnwave5()
	SpawnUnits("wave5",Army)
end

function spawnwave6()
	SpawnUnits("wave6",Army)
end

function spawnwave7()
	SpawnUnits("wave7",Army)
end

function spawnwave8()
	SpawnUnits("wave8",Army)
end

function spawnwave9()
	SpawnUnits("wave9",Army)
end

function spawnwave10()
	SpawnUnits("wave10",Army)
end

function spawnwave11()
	SpawnUnits("wave11",Army)
end

function spawnwave12()
	SpawnUnits("wave12",Army)
end

function spawnwave13()
	SpawnUnits("wave13",Army)
end

function spawnwave14()
	SpawnUnits("wave14",Army)
end

function spawnwave15()
	SpawnUnits("wave15",Army)
end

function spawnwave16()
	SpawnUnits("wave16",Army)
end

function spawnwave17()
	SpawnUnits("wave17",Army)
end

function spawnwave18()
	SpawnUnits("Titan",Titan)
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 27 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
		SpawnUnits("wave5",Army)
		SpawnUnits("wave6",Army)
		SpawnUnits("wave7",Army)
		SpawnUnits("wave8",Army)
		SpawnUnits("wave9",Army)
		SpawnUnits("wave10",Army)
		SpawnUnits("wave11",Army)
		SpawnUnits("wave12",Army)
		SpawnUnits("wave13",Army)
		SpawnUnits("wave14",Army)
		SpawnUnits("wave15",Army)
		SpawnUnits("wave16",Army)
		SpawnUnits("wave17",Army)
		SpawnUnits("Titan",Titan)
	end
	
end










