destroyed = 0
SpellLevel = 0
Rank = 0
Army = 18
Titan = 50

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_UNAKADVENTURELEVEL5_1","BOTTOM_LEFT")
		AddTimer(4.0, removeText)
		AddTimer(5.0, talkingHead2)
	end
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_UNAKADVENTURELEVEL5_2","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(5.0, revealUI)
end

function removeText()
	HideDialog()
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_6_10")
	GiveDefenderSpoil("H_448_10")
	GiveDefenderSpoil("H_18_10")
	GiveDefenderSpoil("EV_24_10")
	
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	AddTimer(1.0, spawnwave2)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
			SpawnUnits("wave1",Army)
		end
		if destroyed == 11 then
			
			SpawnUnits("wave2",Army)
			SpawnUnits("Titan",Titan)
		end
		if destroyed == 19 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
		SpawnUnits("Titan",Titan)
	end
	
end








