destroyed = 0
SpellLevel = 0
Rank = 0
Army = 22
Titan = 50

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL7_1","BOTTOM_LEFT")
		AddTimer(4.0, removeText)
		AddTimer(5.0, talkingHead2)
	end
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL7_2","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(5.0, revealUI)
end

function removeText()
	HideDialog()
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_380_10")
	GiveDefenderSpoil("H_381_10")
	GiveDefenderSpoil("EV_185_10")
	GiveDefenderSpoil("H_382_10")
	GiveDefenderSpoil("H_383_10")
	GiveDefenderSpoil("H_384_10")
	
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	AddTimer(1.0, spawnwave1)
	
end

function spawnVfx2()

	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	PlayVFX("PA_SpawnReinforcement", "vfx8")
	AddTimer(1.0, spawnwave2)
	
end

function spawnwave1()

	SpawnUnits("wave1",Army)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	SpawnUnits("Titan",Titan)
	
end

function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			AddTimer(1.0, spawnVfx1)
		end
		if destroyed == 14 then
			AddTimer(1.0, spawnVfx2)
		end
		if destroyed == 23 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("Titan",Titan)
	end
	
end