destroyed = 0
SpellLevel = 0
Rank = 0
Army = 24
Titan = 60

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	createStartingTroops(False)
	SetWinnable(false)
	SpawnUnits("start",Army)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL8_1","BOTTOM_LEFT")
		AddTimer(4.0, removeText)
		AddTimer(5.0, talkingHead2)
	end
end

function talkingHead2()
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_VIKINGADVENTURELEVEL8_2","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
	AddTimer(5.0, revealUI)
end

function removeText()
	HideDialog()
end

function revealUI()
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onLevelStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	SetWinnable(false)
	
	GiveDefenderSpoil("H_385_10")
	GiveDefenderSpoil("H_515_10")
	GiveDefenderSpoil("H_391_10")
	GiveDefenderSpoil("H_393_10")
	GiveDefenderSpoil("EV_255_10")
	GiveDefenderSpoil("EV_276_10")
	AddTimer(3.0, spawnVfx1)
	AddTimer(6.0, spawnVfx2)
	AddTimer(9.0, spawnVfx3)
	AddTimer(12.0, spawnVfx4)
	AddTimer(15.0, spawnVfx5)
	
end

function spawnVfx1()

	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	AddTimer(1.0, spawnwave1)
	
end

function spawnVfx2()

	PlayVFX("PA_SpawnReinforcement", "vfx5")
	PlayVFX("PA_SpawnReinforcement", "vfx6")
	PlayVFX("PA_SpawnReinforcement", "vfx7")
	AddTimer(1.0, spawnwave2)
	
end

function spawnVfx3()

	PlayVFX("PA_SpawnReinforcement", "vfx8")
	PlayVFX("PA_SpawnReinforcement", "vfx9")
	PlayVFX("PA_SpawnReinforcement", "vfx10")
	PlayVFX("PA_SpawnReinforcement", "vfx11")
	PlayVFX("PA_SpawnReinforcement", "vfx12")
	AddTimer(1.0, spawnwave3)
	
end

function spawnVfx4()

	PlayVFX("PA_SpawnReinforcement", "vfx14")
	PlayVFX("PA_SpawnReinforcement", "vfx15")
	PlayVFX("PA_SpawnReinforcement", "vfx16")
	PlayVFX("PA_SpawnReinforcement", "vfx17")
	PlayVFX("PA_SpawnReinforcement", "vfx18")
	AddTimer(1.0, spawnwave4)
	
end

function spawnVfx5()

	PlayVFX("PA_SpawnReinforcement", "vfx19")
	PlayVFX("PA_SpawnReinforcement", "vfx20")
	PlayVFX("PA_SpawnReinforcement", "vfx21")
	AddTimer(1.0, spawnwave5)
	
end

function spawnwave1()

	SpawnUnits("wave1",Army)
	
end

function spawnwave2()

	SpawnUnits("wave2",Army)
	
end

function spawnwave3()

	SpawnUnits("wave3",Army)
	
end

function spawnwave4()

	SpawnUnits("wave4",Army)
	
end

function spawnwave5()

	SpawnUnits("wave5",Army)
	SpawnUnits("Titan",Titan)
	
end


function onUnitDestroyed(unit)

	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 25 then
			SetWinnable(true)
		end
	end
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army)
		SpawnUnits("wave4",Army)
		SpawnUnits("wave5",Army)
		SpawnUnits("Titan",Titan)
	end
	
end









