--after kill 3 skeletons auto end with titan effect
handler = 0
phase = 0
destroyed = 0
freyaspawned = 0
playonce = 0
finish = 0
dragonce = 0
heroarrived = 0
shouldPlayGiveOrderMovie = true
shouldPlayGiveOrderMovie2 = true
shouldPlayTapUnitMovie = true
shouldPlayTapUnitMovie2 = true
queuedKills = {}
singleanalytic = 0
CallMeOnce = 0
Army = 1
Army1 = 30
Army2 = 5
titanselect = 0
preText = 0
almarand = nil

function QueueAssets()
	QueueVFX("PA_FTUEHeroSwordEnergize")
	QueueVFX("SpawnPaladinFX")
	QueueVFX("PA_TutorialFireball")
	QueueVFX("Apocalypse_BuildUp")
end

function onLevelStart()
	PlaySwfMovie("Media/UI/StorySetUp.swf")
	PlayCameraAnimation("camera_intro")		-- This is a bit of a hack.  This camera is a full black screen that covers the time needed for the "StorySetUp.swf" movie to load
	SetMusicScriptID ("FTUE")
	--PlaySFX("FTUE_CS_01")
	--PlayMusicCue("FTUE_CS_01")

	local units = GetUnits("*", "SK_Special_AlmarandFTUE_01_Game", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	almarand = units[1]
  for i,unit in pairs(units) do
		EnableInvincibility(unit)
	end

	SetMinimalUI()		-- disable UI display as level starts
	SetWinnable(false)	-- level cannot be completed even if no enemy units are alive
	DisableNecromancer()	-- no ability to ressurect dead units after mission fail
	SetTriggerCallbacks("wrongway", wrongway_onTriggerEnter) -- heading backwards from start line warning triggerzone
	SetTriggerCallbacks("wrongway2", wrongway2_onTriggerEnter) -- heading backwards from start line warning triggerzone
	EnableSelectionChange(false)
	SetTroopAndSpellSelectorEnabled(false)

	AddTimer(0.2, startMusic)
	--AddTimer(2.5, titan1Spell1)
	AddTimer(2.5, titanOne)
	AddTimer(2.5, enemyOne)

	local units = GetUnits("Wave1", "*", 2)
	for i,unit in pairs(units) do
		SwitchSide(unit, 2)
	end

	local units = GetUnits("Wave2", "*", 2)
	for i,unit in pairs(units) do
		SwitchSide(unit, 2)
	end

	local units = GetUnits("[START]Almarand", "*", 2)
	for i,unit in pairs(units) do
		SwitchSide(unit, 2)
	end

	LogMetricsMilestoneEvent("ftue", "ftue_1000_epicbattle") -- analytic callback "an epic battle rages" starts
	SetAlliedPlayers(0, 2)
end

function startMusic()
	PlayMusicCue("FTUE", "FTUE_CS_01")
end

function StartCameraIntro()
end

function deactivateSkip()
	SetCutsceneSkipperEnabled(false)
end

function onSwfMovieEnd(movie)
	print("onSwfMovieEnd", movie)
	if movie=="Media/UI/StorySetUp.swf" then
		SetCutsceneSkipperEnabled(true)
	end

	if movie == "Media/UI/Tutorial_SpellCommands.swf" then
	end
end

function onCutsceneSkip()
	print("onCutsceneSkip phase=",phase)
	LogMetricsMilestoneEvent("ftue", "ftue_1200_button_skipped")
	SetCutsceneSkipperEnabled(false) -- disable 'skip' button - the player is in control now
	CancelAllTimers() -- Make sure nothing unexpected is queued up...
	--SetPanningCamera(-76.7, 205, 10, 0.1, -0.25)
	--AddTimer(8.0, spawnendarmy)			-- (RE)START THE SPAWN FOR FAR ENEMY UNITS TO ADVANCE TOWARDS 300 STYLE PIKE WALL
	winLevel();
	--PlaySwfMovie("Media/UI/StorySetUp2.swf")
	--nextText()
end

function nextText()
	--PlaySwfMovie("Media/UI/StorySetUp2.swf")
	--AddTimer(4.0, nextMessage)
end

function titanOne()
	SpawnUnits("Army1",Army)
	SpawnUnits("Army2",Army)
	AddTimer(0.5, titanOneReveal)
	PlaySwfMovie("Media/UI/StorySetUp5.swf")
end

function titanOneReveal()
	SpawnUnits("titanOne",Army)
	SetCutsceneSkipperEnabled(true)
	PlayCameraAnimation("CAMERA_TITAN1")
	AddTimer(0.0, titanOneAnim)
end

function titanOneAnim()
	local allies = GetUnits("*", "SK_ChampionUnakMaleFTUE_SuperRare_01_Game", 2)
	PlayUnitAnimation(allies[1], "FTUE_Look")

	--Add titan animation here
	AddTimer(3.2, titanTwo)
	AddTimer(1.0, enemyTwo)
end

function titanTwo()
	SpawnUnits("Army3",Army)
	AddTimer(0.4, titanTwoReveal)
	PlaySwfMovie("Media/UI/StorySetUp5.swf")
end

function titanTwoReveal()


	local units = GetUnits("titanOne", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	local units = GetUnits("Army1", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	SpawnUnits("titanTwo",Army)
	PlayCameraAnimation("CAMERA_TITAN2")
	--SetCamera(-1143.5, 775.2, 575.0, 0.04, -0.25) -- focusX, focusY, zoom, heading, pitch
	AddTimer(0.0, titanTwoAnim)
end

function titanTwoAnim()
	local allies = GetUnits("*", "SK_BezerkerMossmaneFemaleFTUE_SuperRare_01_Game", 2)
	PlayUnitAnimation(allies[1], "FTUE_Look")
	--Add titan animation here
	AddTimer(2.5, titanThree)
	--AddTimer(1.0, titan3Spell1)
	--AddTimer(1.5, titan3Spell2)
	AddTimer(1.0, enemyThree)
end

function enemyOne()
	SpawnUnits("enemyOne", Army)
end

function enemyTwo()
	SpawnUnits("enemyTwo", Army)
end

function enemyThree()
	SpawnUnits("enemyThree", Army)
end

function titanThree()
	--AddTimer(0.0, titan3Spell3)

	AddTimer(0.3, titanThreeReveal)
	PlaySwfMovie("Media/UI/StorySetUp5.swf")
end

function titanThreeReveal()
	---This kills off the titan and hides it from the battlefield
	local units = GetUnits("titanTwo", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	local units = GetUnits("Army2", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	SpawnUnits("titanThree",Army)
	PlayCameraAnimation("CAMERA_TITAN3")
	--SetCamera(-1143.5, 775.2, 575.0, 0.04, -0.25) -- focusX, focusY, zoom, heading, pitch
	AddTimer(0.0, titanThreeAnim)
end

function titanThreeAnim()
	--Add titan animation here
	local allies = GetUnits("*", "SK_GuardianRagnarMaleFTUE_SuperRare_01_Game", 2)
	PlayUnitAnimation(allies[1], "FTUE_Look")

	AddTimer(2.5, nextMessage)
end

function nextMessage()
	---This line plays a swf file
	PlaySwfMovie("Media/UI/StorySetUp2.swf")
	LogMetricsMilestoneEvent("ftue", "ftue_1100_almarandgates")

	AddTimer (3.4, startMusic2)

	AddTimer(3.7, almarandCam)
	AddTimer(0.3, almarandCamStart)
	--PlayCameraAnimation("CAMERA_KILL")
end

function nextMessage2()
	---This line plays a swf file
	PlaySwfMovie("Media/UI/StorySetUp2.swf")
	LogMetricsMilestoneEvent("ftue", "ftue_1100_almarandgates")
	SetCutsceneSkipperEnabled(false)
	AddTimer (3.4, startMusic2)

	AddTimer(0.0, almarandCam)
	AddTimer(0.0, almarandCamStart)
end

function almarandCamStart()
	PlayCameraAnimation("CAMERA_KILL")
end

function startMusic2()
	PlayMusicCue("FTUE","FTUE_CS_02_Interactive")
end

function almarandCam()
	local units = GetUnits("titanThree", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	local units = GetUnits("Army3", "*", 2)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end

	SpawnUnits("[START]Almarand",Army)
	SpawnUnits("dyingTitan", Army)
	SpawnUnits("Wave1", Army)
	SpawnUnits("Wave2", Army)
	SpawnUnits("Ally",Army2)
	AddTimer(1.5, spawnOthers)
	AddTimer(8.0, moveCamera)
	AddTimer(7.0, spawnUnits)
	--PlayMusicCue("FTUE","FTUE_CS_02_Interactive")

	AddTimer(4.5, deactivateSkip)
	AddTimer(9.0, Wave3)
	AddTimer(13.0, Wave4)

	SetUnitInert(almarand, true)
	PlayUnitAnimation(almarand, "FTUE_Look")
	EnableInvincibility(almarand)

	local allies = GetUnits("*", "SK_GuardianHumanMaleFTUE_Common_01_Game*", 2) -- get player Militia unit
	SetUnitInert(allies[1], true)
	PlayUnitAnimation(allies[1], "FTUE_Look")

	local units = GetUnits("*", "Archer", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Militia", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Pikemen", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Unak", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Elithen", 3) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Archer", 2) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Militia", 2) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Pikemen", 2) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Unak", 2) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end

	local units = GetUnits("*", "Elithen", 2) -- ALMARAND DAMAGE TURNED OFF AS SOON AS TAP TO SELECT IS SHOWN
	for i,unit in pairs(units) do
		EnableInvincibility(unit)
		DisableAttackDamage(unit)
	end
end

function spawnOthers()

	SpawnUnits("Ally10", Army)
	SpawnUnits("Wave10", Army)

end

function onCameraAnimationFinish(cameraName)
end

function Wave3()
	SpawnUnits("Wave3", Army)
end

function Wave4()
	SpawnUnits("Wave4", Army)
end

function moveCamera()
	AddTimer(2.5, tutorialText)
end

function spawnUnits()
	PlayUnitAnimation(almarand, "FTUE_Idle")

	SpawnUnits("Hero", Army1)
	SpawnUnits("skeleton",Army)
end

function tutorialText()
	EnableSelectionChange(false)
	--shouldPlayTapUnitMovie = true
	ShowDialogEternalInPosition("talkingheads/full/fallenking", "TXT_INTRO_TEXT_1","BOTTOM_LEFT")
	--AddTimer(3.3, removeText)
	AddTimer(2.3, extraText)
	--PlaySFX("FTUE_CS_03")
	--PlayMusicCue("FTUE_CS_03")
end

function removeText()
	HideDialog()
end

function extraText ()

	--ShowDialogEternalInPosition("talkingheads/full/fallenking", "TXT_INTRO_TEXT_2","BOTTOM_LEFT")
	EnableSelectionChange(true)
	playTapUnitMovie()
	LogMetricsMilestoneEvent("ftue", "ftue_1300_showselecttap")

end

function playTapUnitMovie()
	if shouldPlayTapUnitMovie == true then
		local allies = GetUnits("Hero", "*", 0) -- get player Militia unit
		PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])
		shouldPlayTapUnitMovie = false
	end
end

-- ------------------------------			GENERIC FUNCTIONS USED THROUGHOUT MISSION 		-------------------

function onUnitSelected(unit)
	if unit.attacker and not orderGiven then
		shouldPlayTapUnitMovie = false
		HideDialog()
		CloseTutorialMovie()
		--HideDialog()
		--ShowDialogInPosition("talkingheads/full/fallenking","TXT_FTUE_STORY_INFO2","BOTTOM_LEFT")

		--AddTimer(0.1, PlayTutorialMovieOnUnit, "Media/UI/Tutorial_UnitCommands02.swf", unit)
		EnableSelectionChange(false)
		waitingForOrder = true
		titanselect = 1
		AddTimer(1.0, tapEnemy)
		AddTimer(15.0, moveTitan)
	end
end

function tapEnemy ()

	ShowDialogInPosition("talkingheads/full/fallenking","TXT_INTRO_TEXT_3","BOTTOM_LEFT")
	FrameCamera("cam")
	AddTargetCircleWithArrow("vfx1")
	AddTimer(7.0, removeText)

	--local allies = GetUnits("skeleton", "*", 1) -- get player Militia unit
	--PlayTutorialMovieOnUnit ("Media/UI/Tutorial_UnitCommands.swf", allies[1])

end

function moveTitan()
	GiveNamedUnitMoveOrder("Hero","vfx1")
	AddTimer(3.0, keepMovingTitan)
end

function keepMovingTitan()
	if titanselect == 1 then
		moveTitan()
	elseif titanselect == 2 then
	end
end

function onUnitOrderGiven(unit, orderType)
	if heroarrived == 0 then
		shouldPlayGiveOrderMovie = false
		CloseTutorialMovie()
		--HideDialog()
		EnableCameraControl(true)
		if singleanalytic == 0 then
			LogMetricsMilestoneEvent("ftue", "ftue_1800_movefrontlines") -- analytic call for first move order with militia unit
			singleanalytic = 1
		end
	end
	if heroarrived == 2 then
		shouldPlayGiveOrderMovie2 = false
		CloseTutorialMovie()
		ClearTargetCircles() -- Cancels effect of ForceSelectAlly
		EnableCameraControl(true)
		EnableSelectionChange(true)
		heroarrived = 4
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		titanselect = 2
		local units = GetUnits("*", "SK_PaladinHumanMaleFTUE_ShadowKing_01_Game", 0)
		for i,unit in pairs(units) do
			SetUnitStandGuard(unit, true)
		end
		AddTimer(1.0, playCharge)
	end
end

function playCharge()
	PlaySwfMovie("Media/UI/StorySetUp3.swf")
	LogMetricsMilestoneEvent("ftue", "ftue_1500_titan_sacrifice_text")
	AddTimer(0.3, titanMove)
	AddTimer(2.5, removeHeroTitan)
	AddTimer(2.0, startTitanCollideAnim)
	AddTimer(3.0, finalTitanScene)

	local units = GetUnits("skeleton", "*", 1)
		for i,unit in pairs(units) do
		HideDeadUnit(unit)
	end
end

function titanMove()

	GiveNamedUnitMoveOrder("Hero","wrongway")

end

function startTitanCollideAnim ()
	SpawnUnits("playerUnitModel",Army)

	local allies = GetUnits("*", "SK_PaladinHumanMaleFTUE_ShadowKing_01_Game*", 2)
	PlayUnitAnimation(allies[1], "Collide")

	PlayUnitAnimation(almarand, "Collide")
end

function removeHeroTitan()
	SpawnUnits("backUp", Army)

	local units = GetUnits("Hero", "*", 0)
	for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
	end
end

function finalTitanScene()
	PlayMusicCue("FTUE","FTUE_CS_03")
	--SpawnUnits("playerUnitModel",Army)

	AddTimer(1.65, vfxPlay)
	AddTimer(0.6, chargeShoulder)
end

function vfxPlay()
	--local allies = GetUnits("*", "SK_PaladinHumanMaleFTUE_ShadowKing_01_Game*", 2)
		--PlayUnitAnimation(allies[1], "Collide")

	--local allies = GetUnits("*", "SK_Special_AlmarandFTUE_01_Game", 3)
		--PlayUnitAnimation(allies[1], "Collide")

	PlayVFX("PA_FTUEHeroSwordEnergize", "vfx_SwordEnergize")
	PlayVFX("Apocalypse_BuildUp", "vfx_SwordEnergize")
	LogMetricsMilestoneEvent("ftue", "ftue_1600_titan_power_up")
end

function chargeShoulder()
	PlaySFX("sfx_ftue_spell_weaponcharge")
	PlayCameraAnimation("CAMERA_RUN_01")
	AddTimer(5.2, run02)
end

function run02()
	PlayCameraAnimation("CAMERA_RUN_02") --CAMERA_CHARGE
	LogMetricsMilestoneEvent("ftue", "ftue_1700_titan_charge")
	AddTimer(2.3, run03)
end

function run03()
	PlayCameraAnimation("CAMERA_RUN_03") --CAMERA_CHARGE
	AddTimer(1.5, run04)
	AddTimer(0.9, castApocalypse)
end

function run04()
	PlayCameraAnimation("CAMERA_RUN_04") --CAMERA_CHARGE
	AddTimer(2.0, apocalypseCamera)
end

function apocalypseCamera()
	PlayCameraAnimation("CAMERA_APOCALYPSE") --CAMERA_CHARGE
end

function castApocalypse()
	--AddTimer(5.0, playFinalCard)

	finish = 1
	if finish == 1 then
		AddTimer(3.5, winLevel)

		local units = GetUnits("*", "*", 2)
		for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end

		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			EnableAttackDamage(unit)
		end

		local change = GetUnits("*", "*", 0)
		for i,unit in pairs(change) do
			--SwitchSide(unit , 3)
			-- Kill player's units because apocalypse won't, and want to stop their SFX
			--KillUnit(unit)
			--HideDeadUnit(unit)
		end

		LogMetricsMilestoneEvent("ftue", "ftue_1900_showapocalypse") -- analytic call back for displaying apocalypse spell
		CastSpell("Apocalypse", 1, "Apocalypsepos", 0)
		CloseTutorialMovie()
		--AddTimer(4.0,gameover)
		AddTimer(1.9, playExplosionSound)
	end
end

function playExplosionSound()
	PlaySFX("sfx_ftue_spell_apocolypse_explosion")
end

function playFinalCard()
	--PlaySwfMovie("Media/UI/StorySetUp4.swf")
end

function winLevel()
	--Win()
	WinSilently()
	SetWinnable(true)
	WinSilently()
	--Win()
end

function gameover()
	LogMetricsMilestoneEvent("ftue", "ftue_2100_splashscreenload") -- analytic call for end of ftue battle
	WinSilently()
end

function stophandswipe()
	CloseTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end

function wrongway_onTriggerEnter(unit)
	if unit.attacker then
		GiveNamedUnitMoveOrder("Hero","vfx1")
	end
end

function wrongway2_onTriggerEnter(unit)
	if unit.attacker then
		GiveNamedUnitMoveOrder("Hero","vfx1")
	end
end
