SpellLevel = 0
Army25 = 25
Army24 = 24
Army23 = 23
Army22 = 22
Army21 = 21
Army20 = 20
Army19 = 19
Army18 = 18
Army17 = 17
Army16 = 16
Army15 = 15
Army14 = 14
Army13 = 13
Army12 = 12
Army11 = 11
Army10 = 10
Army9 = 9
Army8 = 8
Army7 = 7
Army6 = 6
Army5 = 5
Army4 = 4
Army3 = 3
Rank = 0
destroyed = 0
Titan1 = 10
Titan2 = 20
Titan3 = 30
Titan4 = 40
Titan5 = 50
Titan6 = 55
Titan7 = 60

math.randomseed(os.time())
local randomIntroText1 = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end


function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	-- 6 units 1 raid, 7 total LVL 22
	
	RespawnUnits("RagnarRaidMiddleA1", Army22)
	RespawnUnits("Skeleton4", Army22)
	RespawnUnits("Skeleton1", Army22)
	RespawnUnits("RagnarMiddleA1", Army22)
	RespawnUnits("RagnarMiddleB1", Army22)
	RespawnUnits("ArcherMiddleB1", Army22)
	RespawnUnits("MilitiaBottomLeft1", Army22)
	
	
	SetStandGuardButtonEnabled(false)
	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)

	AddTimer(1.0,introText)
	AddTimer(3.0,turnOnHUD)
end

function onLevelStart()

	GiveDefenderSpoil("H_284_5")
	GiveDefenderSpoil("H_108_5")
	GiveDefenderSpoil("H_285_10")
	GiveDefenderSpoil("H_109_10")
	GiveDefenderSpoil("H_368_10")
	GiveDefenderSpoil("H_364_10")
	GiveDefenderSpoil("D_1")
	GiveDefenderSpoil("D_2")
	GiveDefenderSpoil("D_3")
	GiveDefenderSpoil("D_4")
	GiveDefenderSpoil("D_5")
	AddTimer(0.3, waveMultiplier)

	FadeDeadUnits()
	AddTimer(300,Win)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
end

function waveMultiplier()
	UseContestWaveMultiplier(6)

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			AddTimer(0.5, vfxWave2)
			AddTimer(1.5, spawnWave2)
		end
		if destroyed == 14 then
			AddTimer(0.5, vfxWave3)
			AddTimer(1.5, spawnWave3)
		end
		if destroyed == 22 then
			AddTimer(0.5, vfxWave4)
			AddTimer(1.5, spawnWave4)
		end
		if destroyed == 32 then
			AddTimer(0.5, vfxWave5)
			AddTimer(1.5, spawnWave5)
		end
		if destroyed == 43 then
			AddTimer(0.5, vfxWave6)
			AddTimer(1.5, spawnWave6)
		end
		if destroyed == 53 then
			AddTimer(0.5, vfxWave7)
			AddTimer(1.5, spawnWave7)
		end
		if destroyed == 63 then
		SetWinnable(true)
		end
	end
end

function vfxWave2()
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
	PlayVFX("PA_SpawnReinforcement", "9")
	PlayVFX("PA_SpawnReinforcement", "10")
end

function vfxWave3()
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
	PlayVFX("PA_SpawnReinforcement", "9")
	PlayVFX("PA_SpawnReinforcement", "10")
end

function vfxWave4()
	PlayVFX("PA_SpawnReinforcement", "1")
	PlayVFX("PA_SpawnReinforcement", "2")
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
	PlayVFX("PA_SpawnReinforcement", "9")
	PlayVFX("PA_SpawnReinforcement", "10")
	PlayVFX("PA_SpawnReinforcement", "11")
	PlayVFX("PA_SpawnReinforcement", "12")
end

function vfxWave5()
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
end

function vfxWave6()
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
	PlayVFX("PA_SpawnReinforcement", "9")
	PlayVFX("PA_SpawnReinforcement", "10")
	PlayVFX("PA_SpawnReinforcement", "11")
	PlayVFX("PA_SpawnReinforcement", "12")
end

function vfxWave7()
	PlayVFX("PA_SpawnReinforcement", "1")
	PlayVFX("PA_SpawnReinforcement", "2")
	PlayVFX("PA_SpawnReinforcement", "3")
	PlayVFX("PA_SpawnReinforcement", "4")
	PlayVFX("PA_SpawnReinforcement", "5")
	PlayVFX("PA_SpawnReinforcement", "6")
	PlayVFX("PA_SpawnReinforcement", "7")
	PlayVFX("PA_SpawnReinforcement", "8")
	PlayVFX("PA_SpawnReinforcement", "9")
	PlayVFX("PA_SpawnReinforcement", "10")
	PlayVFX("PA_SpawnReinforcement", "11")
	PlayVFX("PA_SpawnReinforcement", "12")
end

function spawnWave2()
	-- 6 units 1 raid, 7 total LVL 23
	RespawnUnits("RagnarRaidMiddleB1", Army23)
	RespawnUnits("ArcherMiddleB1", Army23)
	RespawnUnits("UnakMiddleA1", Army23)
	RespawnUnits("RagnarTopLeft1", Army23)
	RespawnUnits("RagnarTopRight1", Army23)
	RespawnUnits("MilitiaMiddleA1", Army23)
	RespawnUnits("SpearmenTopRight1", Army23)
end


function spawnWave3()
	-- 6 units 2 raid, 8 total LVL 24
	RespawnUnits("RagnarRaidTopLeft1", Army24)
	RespawnUnits("RagnarRaidTopRight1", Army24)
	RespawnUnits("RagnarMiddleA1", Army24)
	RespawnUnits("RagnarMiddleB1", Army24)
	RespawnUnits("MossmaneTopRight1", Army24)
	RespawnUnits("MossmaneTopLeft1", Army24)
	RespawnUnits("Skeleton1", Army24)
	RespawnUnits("Skeleton4", Army24)
end

function spawnWave4()
	-- 8 units 2 raid, 10 total LVL 25
	RespawnUnits("RagnarRaidBottomLeft1", Army25)
	RespawnUnits("RagnarRaidBottomRight1", Army25)
	RespawnUnits("ElithenBottomRight1", Army25)
	RespawnUnits("ElithenBottomLeft1", Army25)
	RespawnUnits("RagnarBottomLeft1", Army25)
	RespawnUnits("RagnarBottomRight1", Army25)
	RespawnUnits("UnakMiddleA1", Army25)
	RespawnUnits("ArcherMiddleB1", Army25)
	RespawnUnits("MilitiaTopLeft1", Army25)
	RespawnUnits("MilitiaTopRight1", Army25)
end


function spawnWave5()
	-- 8 units 3 raid, 11 total LVL 25
	RespawnUnits("ElithenRaidMiddleB1", Army25)
	RespawnUnits("MossmaneRaidMiddleA1", Army25)
	RespawnUnits("RagnarRaidTopLeft1", Army25)
	RespawnUnits("RagnarMiddleB1", Army25)
	RespawnUnits("RagnarMiddleA1", Army25)
	RespawnUnits("RagnarTopLeft1", Army25)
	RespawnUnits("UnakMiddleA1", Army25)
	RespawnUnits("ArcherMiddleB1", Army25)
	RespawnUnits("MilitiaTopLeft1", Army25)
	RespawnUnits("MilitiaMiddleA1", Army25)
	RespawnUnits("RagnarMiddleA2", Army25)
end


function spawnWave6()
	-- 6 units 3 raid 1 titan, 10 total LVL 25
	RespawnUnits("Titan1", Titan3)
	RespawnUnits("SkeletonRaidMiddle1", Army25)
	RespawnUnits("RagnarRaidTopLeft1", Army25)
	RespawnUnits("RagnarRaidTopRight1", Army25)
	RespawnUnits("RagnarBottomRight1", Army25)
	RespawnUnits("RagnarBottomRight2", Army25)
	RespawnUnits("RagnarTopRight1", Army25)
	RespawnUnits("ArcherMiddleB1", Army25)
	RespawnUnits("MossmaneTopRight1", Army25)
	RespawnUnits("ElithenBottomRight1", Army25)
end


function spawnWave7()
	-- 7 units 3 raid 1 titan, 11 total LVL 25
	RespawnUnits("Titan2", Titan4)
	RespawnUnits("MossmaneRaidMiddleA1", Army25)
	RespawnUnits("RagnarRaidMiddleA1", Army25)
	RespawnUnits("RagnarRaidMiddleB1", Army25)
	RespawnUnits("ElithenBottomLeft1", Army25)
	RespawnUnits("Skeleton1", Army25)
	RespawnUnits("Skeleton4", Army25)
	RespawnUnits("RagnarTopRight1", Army25)
	RespawnUnits("RagnarTopLeft1", Army25)
	RespawnUnits("MossmaneTopLeft1", Army25)
	RespawnUnits("MossmaneTopRight1", Army25)
end


function introText()
	randomIntroText1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (randomIntroText1 == 1) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_6_TALKING_HEAD_V1","BOTTOM_LEFT")
	elseif (randomIntroText1 == 2) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_6_TALKING_HEAD_V2","BOTTOM_LEFT")
	elseif (randomIntroText1 == 3) then
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_6_TALKING_HEAD_V3","BOTTOM_LEFT")
	else
		ShowDialogInPosition("talkingheads/full/guard","TXT_EPIC_RAID_LEVEL_6_TALKING_HEAD_V4","BOTTOM_LEFT")
	end
end


function turnOnHUD(unit)
	SetStandGuardButtonEnabled(true)
	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

