Titan = 20
Army = 10
destroyed = 0
SpellLevel = 8

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("Titan1", Titan)
	SpawnUnits("Titan2", Titan)
	SpawnUnits("Titan3", Titan)
	SpawnUnits("Titan4", Titan)
	SpawnUnits("Titan5", Titan)
	SpawnUnits("start", Army)
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
		
	AddTimer(2.0, playGodsVFX)
	
	AddTimer(30.0, spawnRandomTroop1)
	AddTimer(50.0, spawnRandomTroop2)
	AddTimer(70.0, spawnRandomTroop3)
	AddTimer(90.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	AddTimer(0.3, waveMultiplier)
	
	AddTimer(20.0, autoCast)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose
	
end

function autoCast()
	GiveDefenderAutocastSkill("REvent_Earth1")
end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
end

function waveMultiplier()
	UseContestWaveMultiplier(1)
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop4)
	
end


function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_EARTH_LVL1","BOTTOM_LEFT")
		FrameCamera("camera")
		AddTimer(4.0, ReturnCamera)
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
	end
end

function removeText()
	HideDialog()
end

function playGodsVFX()

	PlayVFX("PA_SpawnReinforcement", "Titan1")
	PlayVFX("PA_SpawnReinforcement", "Titan2")
	PlayVFX("PA_SpawnReinforcement", "Titan3")
	PlayVFX("PA_SpawnReinforcement", "Titan4")
	PlayVFX("PA_SpawnReinforcement", "Titan5")
	
	AddTimer(1.0, playGodDeath)

end

function playGodDeath()

	local units = GetUnits("Titan1", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan2", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan3", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan4", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan5", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
		
	
	AddTimer(4.0, summonBossVFX)

end

function summonBossVFX()

	AddTimer(0.9, summonBossVFX2)
	AddTimer(0.95, summonBossVFX2)
	AddTimer(1.0, summonBossVFX2)
	AddTimer(1.025, summonBossVFX2)
	AddTimer(1.1, summonBossVFX2)
	AddTimer(1.125, summonBossVFX2)
	AddTimer(2.0, summonBoss)

end

function summonBossVFX2()

	PlayVFX("PA_SpawnReinforcement", "Boss")

end


function summonBoss()

	SpawnUnits("Boss", Titan)

end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function onUnitDestroyed(unit)
			if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
			end
end
