Titan = 50
Titan2 = 30
Army = 20
destroyed = 0
SpellLevel = 15

math.randomseed(os.time())
local lightning1 = 0

math.randomseed(os.time())
local lightning2 = 0

math.randomseed(os.time())
local lightning3 = 0

math.randomseed(os.time())
local lightning4 = 0

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("start", Army)
	SpawnUnits("Boss", Titan)
	SpawnUnits("Titan", Titan2)
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
			
	AddTimer(20.0, spawnRandomTroop1)
	AddTimer(40.0, spawnRandomTroop2)
	AddTimer(60.0, spawnRandomTroop3)
	AddTimer(80.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	AddTimer(15.0, beginLightning1)
	AddTimer(25.0, beginLightning2)
	AddTimer(35.0, beginLightning3)
	AddTimer(45.0, beginLightning4)
	
	GiveDefenderSpoil("H_6_10")
	GiveDefenderSpoil("H_452_10")
	GiveDefenderSpoil("EV_24_10")
	GiveDefenderSpoil("EV_25_10")
	
	AddTimer(0.3, waveMultiplier)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose

end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
end

function waveMultiplier()
	UseContestWaveMultiplier(3)
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop4)
	
end

function beginLightning1()

	lightning1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning1 == 1) then
		CastSpell("Fireball", SpellLevel, "spell4",1)
	elseif (lightning1 == 2) then
		CastSpell("Fireball", SpellLevel, "spell5",1)
	elseif (lightning1 == 3) then
		CastSpell("Fireball", SpellLevel, "spell6",1)
	else
		CastSpell("Fireball", SpellLevel, "spell7",1)
	end
	
	AddTimer(5.0, beginLightning1)

end

function beginLightning2()

	lightning2 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning2 == 1) then
		CastSpell("Fireball", SpellLevel, "spell8",1)
	elseif (lightning2 == 2) then
		CastSpell("Fireball", SpellLevel, "spell9",1)
	elseif (lightning2 == 3) then
		CastSpell("Fireball", SpellLevel, "spell10",1)
	else
		CastSpell("Fireball", SpellLevel, "spell11",1)
	end
	
	AddTimer(5.0, beginLightning2)

end

function beginLightning3()
	
	lightning3 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (lightning3 == 1) then
		CastSpell("Fireball", SpellLevel, "spell12",1)
	elseif (lightning3 == 2) then
		CastSpell("Fireball", SpellLevel, "spell13",1)
	elseif (lightning3 == 3) then
		CastSpell("Fireball", SpellLevel, "spell14",1)
	else
		CastSpell("Fireball", SpellLevel, "spell15",1)
	end
	
	AddTimer(5.0, beginLightning3)

end

function beginLightning4()
	
	lightning3 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (lightning4 == 1) then
		CastSpell("Fireball", SpellLevel, "spell16",1)
	elseif (lightning4 == 2) then
		CastSpell("Fireball", SpellLevel, "spell17",1)
	elseif (lightning4 == 3) then
		CastSpell("Fireball", SpellLevel, "spell18",1)
	else
		CastSpell("Fireball", SpellLevel, "spell19",1)
	end
	
	AddTimer(5.0, beginLightning4)

end

function onCameraAnimationFinish(cameraName)

	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_FIRE_LVL3","BOTTOM_LEFT")
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
	end
	
end

function removeText()

	HideDialog()
	
end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function respawnTitanVFX()

	PlayVFX("PA_SpawnReinforcement", "Titan1")
	
end

function respawnTitan()

	RespawnUnits("Titan", Titan2)
	
end

function onUnitDestroyed(unit)

	if unit.spawnId == "Titan" then
		AddTimer(9.0, respawnTitanVFX)
		AddTimer(10.0, respawnTitan)
	end
	if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
	end
	
end
