Titan = 50
Titan2 = 30
Army = 20
destroyed = 0
SpellLevel = 15

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("start", Army)
	SpawnUnits("Boss", Titan)
	SpawnUnits("Titan", Titan2)
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
			
	AddTimer(20.0, spawnRandomTroop1)
	AddTimer(40.0, spawnRandomTroop2)
	AddTimer(60.0, spawnRandomTroop3)
	AddTimer(80.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	GiveDefenderSpoil("H_361_10")
	GiveDefenderSpoil("H_362_10")
	GiveDefenderSpoil("H_363_10")
	GiveDefenderSpoil("H_289_10")
	GiveDefenderSpoil("H_433_10")
	GiveDefenderSpoil("H_301_10")
	GiveDefenderSpoil("H_438_10")
	GiveDefenderSpoil("H_309_10")
	GiveDefenderSpoil("H_443_10")
	GiveDefenderSpoil("EV_345_10")
	
	AddTimer(0.3, waveMultiplier)
	
	AddTimer(20.0, autoCast)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose

end

function autoCast()
	GiveDefenderAutocastSkill("REvent_Physical3")
end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
end

function waveMultiplier()
	UseContestWaveMultiplier(3)
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(25.0, spawnRandomTroop4)
	
end

function onCameraAnimationFinish(cameraName)

	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_PHYSICAL_LVL3","BOTTOM_LEFT")
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
	end
	
end

function removeText()

	HideDialog()
	
end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function respawnTitanVFX()

	PlayVFX("PA_SpawnReinforcement", "Titan1")
	
end

function respawnTitan()

	RespawnUnits("Titan", Titan2)
	
end

function onUnitDestroyed(unit)

	if unit.spawnId == "Titan" then
		AddTimer(9.0, respawnTitanVFX)
		AddTimer(10.0, respawnTitan)
	end
	if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
	end
	
end
