Titan = 60
Titan2 = 40
Army = 25
destroyed = 0
AllyArmy = 25
SpellLevel = 17

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0

math.randomseed(os.time())
local allytoop1 = 0

math.randomseed(os.time())
local allytoop2 = 0

math.randomseed(os.time())
local allytoop3 = 0

math.randomseed(os.time())
local allytoop4 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("start", Army)
	SpawnUnits("Boss", Titan)
	SpawnUnits("Titan", Titan2)
	
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
			
	AddTimer(20.0, spawnRandomTroop1)
	AddTimer(40.0, spawnRandomTroop2)
	AddTimer(55.0, spawnRandomTroop3)
	AddTimer(70.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	GiveDefenderSpoil("H_361_10")
	GiveDefenderSpoil("H_362_10")
	GiveDefenderSpoil("H_363_10")
	GiveDefenderSpoil("H_290_5")
	GiveDefenderSpoil("H_186_5")
	GiveDefenderSpoil("H_302_5")
	GiveDefenderSpoil("H_246_5")
	GiveDefenderSpoil("H_310_5")
	GiveDefenderSpoil("H_175_5")
	GiveDefenderSpoil("EV_411_5")
	GiveDefenderSpoil("EV_412_5")
	GiveDefenderSpoil("EV_413_5")
	
	AddTimer(0.3, waveMultiplier)
	
	AddTimer(20.0, autoCast)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose

end

function autoCast()
	GiveDefenderAutocastSkill("REvent_Physical4")
end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
end

function waveMultiplier()
	UseContestWaveMultiplier(4)
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(20.0, spawnRandomTroop4)
	
end

function onCameraAnimationFinish(cameraName)

	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_PHYSICAL_LVL4","BOTTOM_LEFT")
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
		AddTimer(2.0, spawnAlliesVFX)
	end
	
end

function spawnAlliesVFX()

	PlayVFX("PA_SpawnReinforcement", "spawn1")
	PlayVFX("PA_SpawnReinforcement", "spawn2")
	PlayVFX("PA_SpawnReinforcement", "spawn3")
	PlayVFX("PA_SpawnReinforcement", "spawn4")
	
	AddTimer(1.0,spawnAllies)
	
end

function spawnAllies()

	allytoop1 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop2 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop3 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	allytoop4 = math.random(1,3) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (allytoop1 == 1) then
		SpawnUnits("MilitiaAlly1", AllyArmy)
	elseif (allytoop1 == 2) then
		SpawnUnits("ArcherAlly1", AllyArmy)
	else
		SpawnUnits("SpearmenAlly1", AllyArmy)
	end
	
	if (allytoop2 == 1) then
		SpawnUnits("MilitiaAlly2", AllyArmy)
	elseif (allytoop2 == 2) then
		SpawnUnits("ArcherAlly2", AllyArmy)
	else
		SpawnUnits("SpearmenAlly2", AllyArmy)
	end
	
	if (allytoop3 == 1) then
		SpawnUnits("MilitiaAlly3", AllyArmy)
	elseif (allytoop3 == 2) then
		SpawnUnits("ArcherAlly3", AllyArmy)
	else
		SpawnUnits("SpearmenAlly3", AllyArmy)
	end
	
	if (allytoop4 == 1) then
		SpawnUnits("MilitiaAlly4", AllyArmy)
	elseif (allytoop4 == 2) then
		SpawnUnits("ArcherAlly4", AllyArmy)
	else
		SpawnUnits("SpearmenAlly4", AllyArmy)
	end
	
end

function removeText()

	HideDialog()
	
end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function respawnTitanVFX()

	PlayVFX("PA_SpawnReinforcement", "Titan1")
	
end

function respawnTitan()

	RespawnUnits("Titan", Titan2)
	
end

function onUnitDestroyed(unit)

	if unit.spawnId == "Titan" then
		AddTimer(9.0, respawnTitanVFX)
		AddTimer(10.0, respawnTitan)
	end
	if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
	end
	
end
