Titan = 20
Army = 10
destroyed = 0
SpellLevel = 8

math.randomseed(os.time())
local lightning1 = 0

math.randomseed(os.time())
local lightning2 = 0

math.randomseed(os.time())
local lightning3 = 0

math.randomseed(os.time())
local randomtroop1 = 0

math.randomseed(os.time())
local randomtroop2 = 0

math.randomseed(os.time())
local randomtroop3 = 0

math.randomseed(os.time())
local randomtroop4 = 0


function QueueAssets()

  QueueVFX("PA_SpawnReinforcement")
  
end

function onDeployStart()

	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes

	EnableSelectionChange(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	
	SpawnUnits("Titan1", Titan)
	SpawnUnits("Titan2", Titan)
	SpawnUnits("Titan3", Titan)
	SpawnUnits("Titan4", Titan)
	SpawnUnits("Titan5", Titan)
	SpawnUnits("start", Army)
	
end


function onLevelStart()

	SetBattleTimeoutTime(180, 0) -- set battle timer for 3 minutes
	AddTimer(180,Win)
		
	AddTimer(2.0, playGodsVFX)
	
	AddTimer(30.0, spawnRandomTroop1)
	AddTimer(50.0, spawnRandomTroop2)
	AddTimer(70.0, spawnRandomTroop3)
	AddTimer(90.0, spawnRandomTroop4)
	
	SetWinnable(false)
	
	AddTimer(30.0, beginLightning1)
	AddTimer(50.0, beginLightning2)
	AddTimer(70.0, beginLightning3)
	
	AddTimer(0.3, waveMultiplier)
	AddTimer(0.1, autoCastResist)
	SetVictoryBarEnabled(false)
	WinIfLose(true)		-- This will make the battle a victory even if you lose

end

function waveMultiplier()
	UseContestWaveMultiplier(1)
end

function autoCastResist()
	GiveDefenderAutocastSkill("REvent_ResistFreezeTerror")
end

function spawnRandomTroop1()

	randomtroop1 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop1 == 1) then
		RespawnUnits("SM1", Army)
	else
		RespawnUnits("SM6", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop1)
	
end

function spawnRandomTroop2()

	randomtroop2 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop2 == 1) then
		RespawnUnits("SM3", Army)
	else
		RespawnUnits("SM7", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop2)
	
end

function spawnRandomTroop3()

	randomtroop3 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop3 == 1) then
		RespawnUnits("SM2", Army)
	else
		RespawnUnits("SM4", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop3)
	
end

function spawnRandomTroop4()

	randomtroop4 = math.random(1,2) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (randomtroop4 == 1) then
		RespawnUnits("SM5", Army)
	else
		RespawnUnits("SM8", Army)
	end
	
	AddTimer(40.0, spawnRandomTroop4)
	
end

function beginLightning1()

	lightning1 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning1 == 1) then
		CastSpell("PoisonCloud", SpellLevel, "spell4",1)
	elseif (lightning1 == 2) then
		CastSpell("PoisonCloud", SpellLevel, "spell5",1)
	elseif (lightning1 == 3) then
		CastSpell("PoisonCloud", SpellLevel, "spell6",1)
	else
		CastSpell("PoisonCloud", SpellLevel, "spell7",1)
	end
	
	AddTimer(10.0, beginLightning1)

end

function beginLightning2()

	lightning2 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 

	if (lightning2 == 1) then
		CastSpell("PoisonCloud", SpellLevel, "spell8",1)
	elseif (lightning2 == 2) then
		CastSpell("PoisonCloud", SpellLevel, "spell9",1)
	elseif (lightning2 == 3) then
		CastSpell("PoisonCloud", SpellLevel, "spell10",1)
	else
		CastSpell("PoisonCloud", SpellLevel, "spell11",1)
	end
	
	AddTimer(10.0, beginLightning2)

end

function beginLightning3()
	
	lightning3 = math.random(1,4) -- We randomise the 'randSpawn' variable here rather than at the start because the number of entries in the 'List(X)' list varies. 
	
	if (lightning3 == 1) then
		CastSpell("PoisonCloud", SpellLevel, "spell12",1)
	elseif (lightning3 == 2) then
		CastSpell("PoisonCloud", SpellLevel, "spell13",1)
	elseif (lightning3 == 3) then
		CastSpell("PoisonCloud", SpellLevel, "spell14",1)
	else
		CastSpell("PoisonCloud", SpellLevel, "spell15",1)
	end
	
	AddTimer(10.0, beginLightning3)

end


function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogEternalInPosition("talkingheads/full/guard","TXT_RAIDBOSS_POISON_LVL1","BOTTOM_LEFT")
		FrameCamera("camera")
		AddTimer(4.0, ReturnCamera)
		AddTimer(5.0, revealUI)
		AddTimer(4.0, removeText)
	end
end

function removeText()
	HideDialog()
end

function playGodsVFX()

	PlayVFX("PA_SpawnReinforcement", "Titan1")
	PlayVFX("PA_SpawnReinforcement", "Titan2")
	PlayVFX("PA_SpawnReinforcement", "Titan3")
	PlayVFX("PA_SpawnReinforcement", "Titan4")
	PlayVFX("PA_SpawnReinforcement", "Titan5")
	
	AddTimer(1.0, playGodDeath)

end

function playGodDeath()

	local units = GetUnits("Titan1", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan2", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan3", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan4", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
	
	local units = GetUnits("Titan5", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
	end
		
	
	AddTimer(0.5, preBossVFX1)
	AddTimer(4.0, summonBossVFX)

end

function summonBossVFX()

	AddTimer(0.9, summonBossVFX2)
	AddTimer(0.95, summonBossVFX2)
	AddTimer(1.0, summonBossVFX2)
	AddTimer(1.025, summonBossVFX2)
	AddTimer(1.1, summonBossVFX2)
	AddTimer(1.125, summonBossVFX2)
	AddTimer(2.0, summonBoss)

end

function summonBossVFX2()

	PlayVFX("PA_SpawnReinforcement", "Boss")

end


function preBossVFX1()

	CastSpell("PoisonCloud", SpellLevel, "spell1",1)
	CastSpell("PoisonCloud", SpellLevel, "spell2",1)
	CastSpell("PoisonCloud", SpellLevel, "spell3",1)
		
end

function summonBoss()

	SpawnUnits("Boss", Titan)

end

function revealUI()

	EnableSelectionChange(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetStandGuardButtonEnabled(true)

end

function onUnitDestroyed(unit)
			if unit.spawnId == "Boss" then
				SetWinnable(true)
				Win()
			end
end
