-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Titan = 0
Army = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	
end

function enableControls()
	
end

-- called at before the deploy phase
function onDeployStart()
	SpawnUnits("Militia1", Army)
	SpawnUnits("Militia4", Army)
	SpawnUnits("Militia5", Army)
end



-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("lose", lose_onTriggerEnterWave1)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
	AddTimer(1.0, moveUnits)
	AddTimer(7.0, SpawnWave2)
	SpawnUnits("Militia1", Army)
end

function lose_onTriggerEnterWave1(unit)
	if unit.defender then
		Lose()
		ShowDialogInPosition("talkingheads/full/guard","The enemy has reached the portal... all is lost.*","BOTTOM_LEFT")
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 20 then
			Win()
		end
	end
end

function spawnFinalWave()
	SpawnUnits("FinalWave",Army)
end

function moveUnits()

	AddTimer(7.0, moveUnits)
	
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
	
		if unit.spawnId == "Militia1" then
			GiveNamedUnitMoveOrder("Militia1", "target")
		end
		
		if unit.spawnId == "Militia2" then
			GiveNamedUnitMoveOrder("Militia2", "target")
		end
		
		if unit.spawnId == "Militia3" then
			GiveNamedUnitMoveOrder("Militia3", "target")
		end
		
		if unit.spawnId == "Militia4" then
			GiveNamedUnitMoveOrder("Militia4", "target")
		end
		
		if unit.spawnId == "Militia5" then
			GiveNamedUnitMoveOrder("Militia5", "target")
		end
		
		if unit.spawnId == "Archer1" then
			GiveNamedUnitMoveOrder("Archer1", "target")
		end
		
		if unit.spawnId == "Archer2" then
			GiveNamedUnitMoveOrder("Archer2", "target")
		end
		
		if unit.spawnId == "Archer3" then
			GiveNamedUnitMoveOrder("Archer3", "target")
		end
		
		if unit.spawnId == "Pikemen1" then
			GiveNamedUnitMoveOrder("Pikemen1", "target")
		end
		
		if unit.spawnId == "Pikemen2" then
			GiveNamedUnitMoveOrder("Pikemen2", "target")
		end
		
		if unit.spawnId == "Pikemen3" then
			GiveNamedUnitMoveOrder("Pikemen3", "target")
		end
		
		if unit.spawnId == "Mossmane1" then
			GiveNamedUnitMoveOrder("Mossmane1", "target")
		end
		
		if unit.spawnId == "Mossmane2" then
			GiveNamedUnitMoveOrder("Mossmane2", "target")
		end
		
		if unit.spawnId == "Mossmane3" then
			GiveNamedUnitMoveOrder("Mossmane3", "target")
		end
		
		if unit.spawnId == "Unak1" then
			GiveNamedUnitMoveOrder("Unak1", "target")
		end
		
		if unit.spawnId == "Unak2" then
			GiveNamedUnitMoveOrder("Unak2", "target")
		end
		
		if unit.spawnId == "Elithen1" then
			GiveNamedUnitMoveOrder("Elithen1", "target")
		end
		
		if unit.spawnId == "Elithen2" then
			GiveNamedUnitMoveOrder("Elithen2", "target")
		end
		
		if unit.spawnId == "Ragnar1" then
			GiveNamedUnitMoveOrder("Ragnar1", "target")
		end
		
		if unit.spawnId == "Ragnar2" then
			GiveNamedUnitMoveOrder("Ragnar2", "target")
		end
		
		if unit.spawnId == "Ragnar3" then
			GiveNamedUnitMoveOrder("Ragnar3", "target")
		end
		
		if unit.spawnId == "RockMaw1" then
			GiveNamedUnitMoveOrder("RockMaw1", "target")
		end
		
	end
	
	
	
end


function createStartingTroops(forPlinthInspector)
	--SpawnUnits("Wall")
	if forPlinthInspector then
		
	end
end
