SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0
rescue = false

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	AddTimer(2.0, framecamera1)
	createStartingTroops(False)  -- This establishes the scaling and what shows on the plinth inspector
end

function onLevelStart()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("fx1", fx1_onTriggerEnter, fx1_onTriggerLeave)
	SetTriggerCallbacks("fx2", fx2_onTriggerEnter, fx2_onTriggerLeave)
	SetTriggerCallbacks("fx3", fx3_onTriggerEnter, fx3_onTriggerLeave)
	SetTriggerCallbacks("fx4", fx4_onTriggerEnter, fx4_onTriggerLeave)
	SetTriggerCallbacks("fx5", fx5_onTriggerEnter, fx5_onTriggerLeave)
	SetTriggerCallbacks("fx6", fx6_onTriggerEnter, fx6_onTriggerLeave)
	SetTriggerCallbacks("elder1", elder1_onTriggerEnter, elder1_onTriggerLeave)
	SetTriggerCallbacks("elder2", elder2_onTriggerEnter, elder2_onTriggerLeave)
	SetTriggerCallbacks("elder3", elder3_onTriggerEnter, elder3_onTriggerLeave)
	SetTriggerCallbacks("elder4", elder4_onTriggerEnter, elder4_onTriggerLeave)
	SetAI()
	AddTimer(60.0, RescueCheck)
end

function framecamera1(seconds)

	ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_5_INTRO")
	FrameCamera("trigger1")
	AddTimer(4.0, ReturnCamera)

end

function SetAI()
		local units = GetUnits("defender", "*", 1)
	for i,unit in pairs(units) do
			DisableAttackDamage(unit)
			SwitchSide(unit, 2)
	end
	
	local units = GetUnits("attacker", "*", 0)
	for i,unit in pairs(units) do
			DisableAttackDamage(unit)
			SwitchSide(unit, 3)
	end
end

function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		saved = true
		ShowDialogEternal("talkingheads/full/soldier","TXT_BLACKKING_CAMPAIGN2_5_RESCUE")
		AddTimer(6, HideDialog)
		DisableTrigger("trigger1")
		local units = GetUnits("defender", "*", 2)
		for i,unit in pairs(units) do
				SwitchSide(unit, 1)
				EnableAttackDamage(unit)
		end

		local units = GetUnits("attacker", "*", 3)
		for i,unit in pairs(units) do
				SwitchSide(unit, 0)
				EnableAttackDamage(unit)
		end
	end
end

function RescueCheck()

	if rescue == false then
		ShowDialog("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_5_LOSE")
		local units = GetUnits("attacker", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
		end
		AddTimer(3.0, Fail)
	end
end

function Fail()

	Lose()

end
	
function onUnitDestroyed(unit)
	if unit.spawnId == "defender" then
		rescue = true
		AddTimer(10.0, SpawnFX)
		ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_5_PREP")
		PlayVFX("ElderStone_EnergyPropStones", "elder1") 
		PlayVFX("ElderStone_EnergyPropStones", "elder2") 
		PlayVFX("ElderStone_EnergyPropStones", "elder3") 
		PlayVFX("ElderStone_EnergyPropStones", "elder4") 
	end
end

function SpawnFX()

		PlayVFX("PA_SpawnReinforcement", "fx1")
		PlayVFX("PA_SpawnReinforcement", "fx2")
		PlayVFX("PA_SpawnReinforcement", "fx3")
		PlayVFX("PA_SpawnReinforcement", "fx4")
		PlayVFX("PA_SpawnReinforcement", "fx5")
		PlayVFX("PA_SpawnReinforcement", "fx6")
		AddTimer(1.0, Attack)

end

function Attack()
		
		ShowDialogEternal("talkingheads/full/almarand", "TXT_BLACKKING_CAMPAIGN2_5_ATTACK")
		AddTimer(6, HideDialog)
		SpawnUnits("titan",Army2)
	    SpawnUnits("spawn",Army)
	    SpawnUnits("spawn1",Army1)
		SpawnUnits("spawn2",Army2)
		AddTimer(2.0, AllowVictory)
		StopVFX("ElderStone_EnergyPropStones", "elder1") 
		StopVFX("ElderStone_EnergyPropStones", "elder2") 
		StopVFX("ElderStone_EnergyPropStones", "elder3") 
		StopVFX("ElderStone_EnergyPropStones", "elder4") 
end

function AllowVictory()
	SetVictoryBarEnabled(true)
	SetWinnable(true)
end	
	

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 12 then			
			Army = 12
			Army1 = 11
			Army2 = 10
			SpellLevel = 10
		elseif Rank == 13 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("attacker",Army2)   
	SpawnUnits("defender",Army2)   
	SpawnUnits("start",Army2)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
		SpawnUnits("attacker",Army2) 
		SpawnUnits("titan",Army2)
	    SpawnUnits("spawn",Army2)
	    SpawnUnits("spawn1",Army1)
		SpawnUnits("spawn2",Army2)
	end
end