SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This establishes the scaling and what shows on the plinth inspector
	ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_7_INTRO")
end

function onLevelStart()
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetWinnable(false)	
	SetupVictoryBar()
	SetVictoryBarFill(0)
	AddTimer(3.0, MoveArcher1)
end

function MoveArcher1()

		local units = GetUnits("start1", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger1")
		end

end


function MoveArcher2()

		local units = GetUnits("spawn1a", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger2")
		end

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			PlayVFX("PA_SpawnReinforcement", "fx2")
			PlayVFX("PA_SpawnReinforcement", "fx3")
			PlayVFX("PA_SpawnReinforcement", "fx4")
			PlayVFX("PA_SpawnReinforcement", "fx5")
			AddTimer(1.0, wave1)
			ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_7_WAVE1")
			SetVictoryBarFill(0.33)
		elseif destroyed == 8 then
			PlayVFX("PA_SpawnReinforcement", "fx1")
			AddTimer(1.0, wave2)
			ShowDialog ("talkingheads/full/guard", "TXT_BLACKKING_CAMPAIGN2_7_WAVE2")
			SetVictoryBarFill(0.66)
		elseif destroyed ==	12 then
			SetVictoryBarFill(1.0)
		end
	end
end

function wave1()
	SpawnUnits("spawn1", Army2)
	SpawnUnits("spawn1a", Army2)
	AddTimer(1.0, MoveArcher2)
end

function wave2()
	SpawnUnits("titan", Army2)
	SpawnUnits("spawn2", Army2)
	SpawnUnits("spawn2a",Army2)
	SetWinnable(true)	
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(4/12)
	AddVictoryBarMarker(8/12)
	AddVictoryBarMarker(1.0)
end

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 12 then			
			Army = 12
			Army1 = 11
			Army2 = 10
			SpellLevel = 10
		elseif Rank == 13 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("start",Army2)   
	SpawnUnits("start1",Army2)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
	    SpawnUnits("start",Army2)
	    SpawnUnits("start1",Army2)
	    --SpawnUnits("start2",Army2)
	    SpawnUnits("titan",Army2)
	    SpawnUnits("spawn",Army2)
	    SpawnUnits("spawn1",Army2)
		SpawnUnits("spawn1a",Army2)
		SpawnUnits("spawn2",Army2)
		SpawnUnits("spawn2a",Army2)
	end
end