SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	createStartingTroops(false)  -- This establishes the scaling and what shows on the plinth inspector
	--SpawnUnits("titan",Army2)
	SpawnUnits("start",Army1)
	PlayVFX("ElderStone_EnergyPropStones", "portalglow")
	PlayVFX("ElderStone_EnergyPropStones", "portalglow1")
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
end

function onLevelStart()
	SetWinnable(false)
	SetTriggerCallbacks("fail", fail_onTriggerEnter)
	DisableAiSpells()
	--SetTriggerCallbacks("secondwave", secondwave_onTriggerEnter, secondwave_onTriggerLeave)
end


function fail_onTriggerEnter(unit)
	if unit.defender then
		SpawnUnits("spawn1",Army1)
		ShowDialog("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_LOSE")
		StopVFX("ElderStone_EnergyPropStones", "portalglow")
		StopVFX("ElderStone_EnergyPropStones", "portalglow1")
		DisableTrigger("fail")
		AddTimer(5, defeat)
	end
end

function defeat()
    Lose()
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
	end
	if destroyed == 2 then
		SpawnUnits("spawn",Army1)
		ShowDialog("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_3")
	end
	if destroyed == 4 then
		ShowDialog("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_4")
		SpawnUnits("spawn2",Army1)
	end
	if destroyed == 6 then
		ShowDialog("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_5")
		SpawnUnits("spawn",Army1)
		SpawnUnits("spawn3",Army1)
		AddTimer(5.0,dialogtitan)
		AddTimer(5.5,spawntitan)
	end
	if destroyed == 9 then
		ShowDialogEternal("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_WIN")
		AddTimer(7.5, HideDialog)
		AddTimer(8, Win)
	end
end

function dialogtitan()
	ShowDialog("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_6")
end
function spawntitan()
	SpawnUnits("titan",Army2)
end

--[[
function protect_onTriggerEnter(unit)
	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_SP21_2")
		AddTimer(3.0, gameover)
		
	end
end
]]

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 14 then			
			Army = 14
			Army1 = 13
			Army2 = 12
			SpellLevel = 12
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
		RespawnUnits("start",Army1)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
	    SpawnUnits("start",Army1)
	    SpawnUnits("spawn",Army1)
	 	SpawnUnits("spawn1",Army1)
		SpawnUnits("spawn2",Army1)
		SpawnUnits("spawn3",Army1)
	 	SpawnUnits("titan",Army2)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	ShowDialogEternal("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_1")
	AddTimer(7, HideDialog)
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(7, ReturnCamera)
	AddTimer(7.5, framecamera1)
end

function framecamera1(seconds)
	ShowDialogEternal("talkingheads/full/guard","TXT_BLACKKING_CAMPAIGN3_5_2")
	AddTimer(7, HideDialog)
	FrameCamera("camera1")
	EnableCameraControl(false)
	AddTimer(7, ReturnCamera)
	AddTimer(7.5, buttonunlock)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end