SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
captured = false
wave_count = 0
destroyed = 0
callarmy = false
armycalled = 0
messageshown = 0
spawntotal = 0
titanfeeding = 0
leftspawn = 0
rightspawn = 0
playvfx = 0
playvfx1 = 0
leftcircle = 0
rightcircle = 0
awaken = 0
-- counts for all the enemy titan reincarnations


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("PoisonGround")
  QueueVFX("SpawnRage")
end

function onDeployStart()
	createStartingTroops(false)  -- This establishes the scaling and what shows on the plinth inspector
	DisableNecromancer()
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetWinnable(false)
end

function onLevelStart()
	SetBattleTimeoutTime(360, 0) -- set battle timer for 6 minutes
	AddTimer(360,Lose)
	--trick()
	SetTriggerCallbacks("enter", enter_onTriggerEnter)
	SetTriggerCallbacks("retreat", retreat_onTriggerEnter)
	SetTriggerCallbacks("run", run_onTriggerEnter)
	DisableAiSpells() -- Disabling fallen kign titan from casting spells currently
	king0safety()
	SetupVictoryBar()
	SetVictoryBarFill(0)
end

function king0safety() -- sets allies to not do damage
	local units = GetUnits("fallenking0", "*", 1)
	for i,unit in pairs(units) do
			EnableInvincibility(unit)
	end
end
function kingsafety() -- sets allies to not do damage
	local units = GetUnits("fallenking", "*", 1)
	for i,unit in pairs(units) do
			EnableInvincibility(unit)
	end
end
function king1safety() -- sets allies to not do damage
	local units = GetUnits("fallenking1", "*", 1)
	for i,unit in pairs(units) do
			EnableInvincibility(unit)
	end
end
function king1kill() -- sets allies to not do damage
	local units = GetUnits("fallenking", "*", 1)
	for i,unit in pairs(units) do
			DisableInvincibility(unit)
	end
end

function enter_onTriggerEnter(unit)
	if unit.attacker then
		titanretreat()
		DisableTrigger("enter")
		ShowDialog("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKRETREAT")
	end
end
function titanretreat()
    GiveNamedUnitMoveOrder("fallenking0", "run")
end
function run_onTriggerEnter(unit)
    if unit.defender then
	    DisableTrigger("run")
		SetTriggerCallbacks("titan", titan_onTriggerEnter)
	    Standstill()
		AddTimer(0.5,titanremove)
	end
end
function titanremove()
    GiveNamedUnitMoveOrder("fallenking0", "titan")
end
function titan_onTriggerEnter(unit)
	if unit.defender then
		Standstill()
		DisableTrigger("titan")
        --PlayVFX("TerrorSkull", "titan")
	end
end

function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "fallenking0", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("fallenking0",false)
end
function Standstill1() -- tells the unit to stand ground
	local units = GetUnits("*", "fallenking", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("fallenking",false)
end
function Standstill2() -- tells the unit to stand ground
	local units = GetUnits("*", "fallenking", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
	end
	SetCanGrowAwareness("fallenking",true)
end

function retreat_onTriggerEnter(unit)
	if unit.defender then
		DisableTrigger("retreat")
		titanfeeding = titanfeeding+1
		AddTimer(0.1, cloudwallcheck)
		SetTriggerCallbacks("death", death_onTriggerEnter)
		--AddTimer(3.5, framecameragasintro)
		--AddTimer(40, titandone)
	end
end

function death_onTriggerEnter(unit)
	if unit.attacker then
		KillUnit(unit)
	end
end

function left_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("left")
		leftcircle = leftcircle +1
		StopVFX("SpawnRage","bottomleft")
        --PlayVFX("TerrorSkull", "titan")
	end
end

function right_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("right")
		rightcircle = rightcircle +1
		StopVFX("SpawnRage","bottomright")
        --PlayVFX("TerrorSkull", "titan")
	end
end



function cloudwallcheck()
    if titanfeeding == 1 then
	cloudwall()
	--ShowDialog("talkingheads/full/guard","spell started")
	end
	if titanfeeding >= 2 then
	--ShowDialog("talkingheads/full/guard","spell over")
	    --StopVFX("PoisonGround", "poison")
	    --StopVFX("PoisonGround", "poison1")
	    --StopVFX("PoisonGround", "poison2")
	end
end
function cloudwall()
	--PlayVFX("PoisonGround", "poison")
	--PlayVFX("PoisonGround", "poison1")
	--PlayVFX("PoisonGround", "poison2")
	CastSpell("PoisonCloud", 5, "poison", 1)
	CastSpell("PoisonCloud", 5, "poison1", 1) 
	CastSpell("PoisonCloud", 5, "poison2", 1) 
	AddTimer(15, cloudwallcheck)
end

function titandone()
    titanfeeding = titanfeeding+2
	--local units = GetUnits("*", "PaladinHumanMale_ShadowKing*", 1)
	--for i,unit in pairs(units) do
		--IntroCamFrameUnit(unit)
		--AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	--end
	AddTimer(10,Standstill2)
	king1kill()
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			--callarmy = true
            --armymarch()
            framecameratitanspell()
            SetVictoryBarFill(0.2)			
		end
		if destroyed == 9 then
			--callarmy = true
            AddTimer(2,framecameratitanevolve)	
            gonetrick()
            SetVictoryBarFill(0.4)				
		end
		if destroyed == 13 then
			--callarmy = true
		    callcircles()
			AddTimer(1,framecameraartifcats1)
            circlecapturedcheck()	
            SetVictoryBarFill(0.6)			
		end
	end
	if unit.spawnId == "fallenking" then
	   AddTimer(0.5, victory)
	   SetVictoryBarFill(1.0)
	   	local units = GetUnits("skeleton", "*", 1)
		for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
		end
	end
end

-- Dialog after initial wave of enemies are destroyed
function framecameratitanspell(seconds)
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKSPELLCAST") 
	AddTimer(7, HideDialog)
	unitsstandground()
	FrameCamera("camera1")
	EnableCameraControl(false)
	playvfx = playvfx +1
	fallenkingregen()
	AddTimer(21, ReturnCamera)
	AddTimer(7, BelecTalk)
	--AddTimer(7, armymarchright)
	--AddTimer(8, framecameratitanreinforcements1)
end
function BelecTalk()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_GASWARNING") 
	AddTimer(7, HideDialog)
	AddTimer(7, kingtalk)
end
function kingtalk()
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKINSULT") 
	AddTimer(7, HideDialog)
	AddTimer(6.5, armymarchright)
	AddTimer(8, framecameratitanreinforcements1)
end

function framecameratitanreinforcements1(seconds)
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_REINFORCEMENTS1")
	AddTimer(8, HideDialog)
	FrameCamera("camera2")
	EnableCameraControl(false)
	AddTimer(8, ReturnCamera)
end

-- camera messaging after 1st wave of reinforcements
function framecameratitanevolve(seconds)
    --ShowDialogEternal("talkingheads/full/fallenking","Ignorant fool! you brave, young leader, sharing in my triumphs!")
	ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKEVOLVE")
	AddTimer(7, HideDialog)
	unitsstandground() 
	FrameCamera("camera1")
	EnableCameraControl(false)
	playvfx = playvfx +1
	playvfx1 = playvfx1 +1
	AddTimer(2,fallenkingregen1)
	AddTimer(21, ReturnCamera)
	AddTimer(7, BelecTalk1)
	--AddTimer(7, armymarchleft)
	--AddTimer(8, framecameratitanreinforcements2)
end
function BelecTalk1()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_WARNING") 
	AddTimer(7, HideDialog)
	AddTimer(7 ,kingtalk1)
end
function kingtalk1()
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKINSULT1") 
	AddTimer(7, HideDialog)
	AddTimer(6.5, armymarchleft)
	AddTimer(8, framecameratitanreinforcements2)
end

function framecameratitanreinforcements2(seconds)
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_REINFORCEMENTS2")
	AddTimer(8, HideDialog)
	FrameCamera("camera3")
	EnableCameraControl(false)
	AddTimer(8, ReturnCamera)
end

function framecameraartifcats1(seconds)
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_SWITCHES")
	AddTimer(10, HideDialog)
	unitsstandground() 
	FrameCamera("circleleft")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6,  framecameraartifcats2)
end

function framecameraartifcats2(seconds)
	FrameCamera("circleright")
	EnableCameraControl(false)
	unitsstandground()
	AddTimer(5, ReturnCamera)
end

function framecameratitanready(seconds)
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKCOMPLETE")
	AddTimer(7, HideDialog)
	FrameCamera("camera1")
	EnableCameraControl(false)
	unitsstandground()
	AddTimer(7, BelecTalk2)
	AddTimer(21, ReturnCamera)
	AddTimer(30, EnableAiSpells)
	--AddTimer(8, skeletons)
end
function BelecTalk2()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_SURRENDER") 
	AddTimer(7, HideDialog)
	AddTimer(7 ,kingtalk2)
	AddTimer(8, skeletons)
end

function kingtalk2()
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKTHREAT")
	AddTimer(7, HideDialog)
end

function fallenkingregen()
	if playvfx == 1 then
    PlayVFX("SpawnRage","titan")
	PlayVFX("SpawnRage","statue1")
	PlayVFX("SpawnRage","statue2")
	PlayVFX("SpawnRage","bottomleft")
	PlayVFX("SpawnRage","bottomright")
	end
	if playvfx == 2 then
	StopVFX("SpawnRage","titan")
	StopVFX("SpawnRage","statue1")
	StopVFX("SpawnRage","statue2")
	StopVFX("SpawnRage","bottomleft")
	StopVFX("SpawnRage","bottomright")
	end
	AddTimer(2,fallenkingregen)
end
function fallenkingregen1()
	if playvfx1 == 1 then
    PlayVFX("SpawnRage","titan")
	PlayVFX("SpawnRage","statue1")
	PlayVFX("SpawnRage","statue2")
	PlayVFX("SpawnRage","bottomleft")
	PlayVFX("SpawnRage","bottomright")
	end
	if playvfx1 == 2 then
	StopVFX("SpawnRage","titan")
	StopVFX("SpawnRage","statue1")
	StopVFX("SpawnRage","statue2")
	end
	AddTimer(2,fallenkingregen1)
end

function armymarchright()
    rightspawn = rightspawn +1
	if rightspawn == 1 then
    RespawnUnits("rightmilitia", Army2)
	end
	if rightspawn == 2 then
    RespawnUnits("rightmilitia", Army2)
	end
	if rightspawn == 3 then
    RespawnUnits("rightmilitia", Army2)
	end
	if rightspawn >= 4 then
	end
	AddTimer(4,armymarchright)
end

function armymarchleft()
    leftspawn = leftspawn +1
	if leftspawn == 1 then
    RespawnUnits("leftmilitia", Army2)
	end
	if leftspawn == 2 then
    RespawnUnits("leftmilitia", Army2)
	end
	if leftspawn == 3 then
    RespawnUnits("leftmilitia", Army2)
	end
	if leftspawn >= 4 then
	end
	AddTimer(4,armymarchleft)
end

function skeletons()
    RespawnUnits("skeleton", Army2)
end

function callcircles()
    AddTargetCircle("circleleft")
	AddTargetCircle("circleright")
	SetTriggerCallbacks("left", left_onTriggerEnter)
	SetTriggerCallbacks("right", right_onTriggerEnter)
end

function gonetrick()
    PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1,gone)
	AddTimer(1, spawnnewtitan)
end
function gone()
	local units = GetUnits("fallenking0", "*", 1)
	for i,unit in pairs(units) do
	KillUnit(unit)
	HideDeadUnit(unit)
	end
end
function spawnnewtitan()
    SpawnUnits("fallenking", Army)
	Standstill1()
	kingsafety()
end

function unitsstandground()
    local units = GetUnits("*", "*", 0)
    for i,unit in pairs(units) do
    SetUnitStandGuard(unit, true)
    end
end

function circlecapturedcheck()
    if leftcircle == 1 and rightcircle == 1 then
	    AddTimer(1, titandone)
		ClearTargetCircles()
		playvfx1 = playvfx1 +2
		framecameratitanready()
		DisableTrigger("death")
		leftcircle = leftcircle+1
		rightcircle = rightcircle+1
		SetVictoryBarFill(0.8)
	end
	if leftcircle == 1 and rightcircle == 0 then
		SetVictoryBarFill(0.7)
	end
	if leftcircle == 0 and rightcircle == 1 then
		SetVictoryBarFill(0.7)
	end
	AddTimer(1,circlecapturedcheck)
end

function victory()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_BKDEATH")
	AddTimer(10, HideDialog)
	local defenders = GetUnits("fallenking1", "*", 1)
	FrameCamera("fallenking1")
	EnableCameraControl(false)
	AddTimer(10,ReturnCamera)
	AddTimer(12, awakening)
	AddTimer(13, awakeningstory)
	--AddTimer(10,Win)
end

function awakening()
    if awaken == 0 then
	PlayVFX("PA_SpawnReinforcement","titan")
	AddTimer(1, awakening)
	end
	if awaken == 1 then
	end
end

function awakeningstory()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_BLACKKING3_7_BKAWAKEN")
	AddTimer(10, HideDialog)
	FrameCamera("titan")
	EnableCameraControl(false) 
	AddTimer(11, awakentitan)
end

function awakentitan()
    awaken = awaken+1
	PlayVFX("PA_SpawnReinforcement","titan")
	AddTimer(1, titanincoming)
end

function titanincoming()
    SpawnUnits("FriendlyTitan")
	ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_BKRETURN")
	EnableCameraControl(false) 
	AddTimer(9, HideDialog)
	AddTimer(11,Win)
end

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 15 then			
			Army = 15
			Army1 = 14
			Army2 = 13
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	SpawnUnits("army", Army2)
	SpawnUnits("fallenking0", 10)
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.

		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
    SpawnUnits("leftmilitia",Army2)
	SpawnUnits("rightmilitia",Army2)
	end
end

-- intro camera sequence that occurs after intitial fly by camera
function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(1,framecameraintro)
	end
end
function framecameraintro(seconds)
    ShowDialogEternal("talkingheads/full/fallenking","TXT_CAMPAIGN_BLACKKING3_7_OPENING")
	AddTimer(7, HideDialog)
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(7,ReturnCamera)
	--AddTimer(7,intro) -- this will be when we introduce the npc battles on left and right. (Use cams for this too!) for now we skip as not been built yet!
	AddTimer(7.1, introend)
end
-- here is where all the buttons become available to use / select
function introend()
    SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end
--
-- camera section after initial battle that showcases whats to come!
function framecameragasintro(seconds)
    FrameCamera("gascamera")
	ShowDialogEternal("talkingheads/full/guard","Utrecht has formed a magic wall blocking us entry. Walking into the gas will result in instant death, tread carefully Sire!")
	AddTimer(8,HideDialog)
	--AddTimer(1.5, pause)
	EnableCameraControl(false)
	AddTimer(6,ReturnCamera)
end
--
-- pause game
function pause()
    SetPaused(true)
	AddTimer(5.9, unpause)
end
-- unpause game
function unpause()
    SetPaused(false)
end
--

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(0.2)
	AddVictoryBarMarker(0.4)
	AddVictoryBarMarker(0.6)
	AddVictoryBarMarker(0.8)
	AddVictoryBarMarker(1.0)
end
