destroyed = 0
SpellLevel = 0
Rank = 0
encountered = 0
Army = 23
Army1 = 23
Army2 = 23

function onDeployStart()
    SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(0.2, story)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function story()
    ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_10_2_1")
	AddTimer(7, startgame)
end

function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	SetTriggerCallbacks("walka", walka_onTriggerEnter)
	SetTriggerCallbacks("walkb", walkb_onTriggerEnter)
	SetTriggerCallbacks("start", start_onTriggerEnter)
	SetTriggerCallbacks("trap", trap_onTriggerEnter)
	SetTriggerCallbacks("trap1", trap1_onTriggerEnter)
end

function start_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1,patrol1)
		--if encountered == 0 then
		    --AddTimer(20,patrol2)
		--end
		--if encountered == 1 thenddd
		    --AddTimer(2,attacktarget)
		--end
	end
end

function patrol1()
	GiveNamedUnitMoveOrder("walk", "walka")
	GiveNamedUnitMoveOrder("walk1", "walkb")
	GiveNamedUnitMoveOrder("start", "walkc")
	GiveNamedUnitMoveOrder("start1", "walke")
	AddTimer(15,patrol2)
end
function patrol2()
	GiveNamedUnitMoveOrder("walk1", "walka")
	GiveNamedUnitMoveOrder("start", "walkd")
	GiveNamedUnitMoveOrder("start1", "walkf")
	AddTimer(15,patrol3)
end
function patrol3()
	GiveNamedUnitMoveOrder("start", "walkc")
	GiveNamedUnitMoveOrder("start1", "walke")
	AddTimer(15,patrol4)
end
function patrol4()
	GiveNamedUnitMoveOrder("start", "walkd")
	GiveNamedUnitMoveOrder("start1", "walkf")
	AddTimer(15,patrol3)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10_2_2")
            SpawnUnits("ambush",Army)
		end
		if destroyed == 5 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10_2_3")
            SpawnUnits("ambush1",Army1)
		end
		if destroyed == 9 then
			--ShowDialogEternal("talkingheads/full/soldier","TXT_CAMPAIGN_10_2_4")
            SpawnUnits("friend",Army2)
		    AddTimer(8,winner)
		end
	end
end

function winner()
    HideDialog()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
        SpawnUnits("walk",Army)
		SpawnUnits("walk1",Army1)
		SpawnUnits("start",Army2)
		SpawnUnits("start1",Army1)
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("walk",Army)
		SpawnUnits("walk1",Army1)
		SpawnUnits("ambush",Army)
		SpawnUnits("ambush1",Army1)
		SpawnUnits("start",Army2)
		SpawnUnits("start1",Army1)
	end
end










