
SpellLevel = 0
Army = 0
Rank = 0
destroyed = 0
Army1 = 24
Army2 = 24
Army3 = 24
Leader = 38

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("Enemy",Army3)
	createStartingTroops(False)  -- This part here
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_5_1")
end

function onLevelStart()
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetTriggerCallbacks("titandie", titandie_onTriggerEnter, titandie_onTriggerLeave)
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("Leader",false)
	end
end

function trigger2_onTriggerEnter(unit)
	if unit.spawnId == "Leader" then
		SpawnUnits("party",Army2)
	end
end

function trigger2_onTriggerLeave(unit)
	DisableTrigger("trigger2")
	if unit.spawnId == "Leader" then
		SpawnUnits("party2",Army1)
	end
end
	

function trigger1_onTriggerLeave(unit)
	if unit.attacker then
		DisableTrigger("trigger1")
		GiveNamedUnitMoveOrder("Leader", "titandie")
		AddTimer(2.5,backambush)
		--ShowDialog("talkingheads/full/rouge","TXT_CAMPAIGN10B_5_2")
	end
end
 
function backambush()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_5_3")
	SpawnUnits("behind",Army2)
end
 
function titandie_onTriggerEnter(unit)
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B_5_4")
	if unit.spawnId == "Leader" then
		--local units = GetUnits("Leader","*", 1)
			--for i,unit in pairs(units) do
				--KillUnit(unit, true)
				--HideDeadUnit(unit)
			--end
			AddTimer(1,titandies)
			PlayVFX("PA_SpawnReinforcement", "death")
			DisableTrigger("titandie")
	end
end

function titandies()
    local units = GetUnits("Leader","*", 1)
		for i,unit in pairs(units) do
				KillUnit(unit, true)
				HideDeadUnit(unit)
		end
end



function createStartingTroops(forPlinthInspector)
	-- Balanced for castle level 10-11
	
	SpawnUnits("Leader",Leader)
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Leader",Leader)
		SpawnUnits("behind",Army2)
		SpawnUnits("party",Army2)
		SpawnUnits("party2",Army1)
		SpawnUnits("Enemy",Army3)
	end
end