destroyed = 0
castcount = 0
Army = 25
Army1 = 25
Army2 = 25
Leader = 38

function onDeployStart()
	createStartingTroops(False)
	SpawnUnits("Leader",Leader)
	SpawnUnits("Crew",Army)
	SpawnUnits("defend",Army1)
	SpawnUnits("Enemy",Army2)
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/rouge","TXT_CAMPAIGN10B5_INTRO")
		--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B5_REPLY")
	end
end

function onLevelStart()
	
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN10B5_TARGET")
	SetTriggerCallbacks("react", fire1_onTriggerEnter, fire1_onTriggerLeave)
	SetTriggerCallbacks("fire1", fire1_onTriggerEnter, fire1_onTriggerLeave)
	SetTriggerCallbacks("fire2", fire2_onTriggerEnter, fire2_onTriggerLeave)
	SetTriggerCallbacks("fire3", fire3_onTriggerEnter, fire3_onTriggerLeave)
	SetTriggerCallbacks("fire4", fire3_onTriggerEnter, fire3_onTriggerLeave)
	SetTriggerCallbacks("fire5", fire3_onTriggerEnter, fire3_onTriggerLeave)
	SetBattleTimeoutTime(300)
	AddTimer(1.0, Standstillleader)
	SetVictoryBarType("ASSASSINATION")
	SetWinnable(false)
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state.
	end
end

 function Standstillleader() -- tells the titan and his Crew to stand ground
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("Leader",false)
	end
	
	local units = GetUnits("Crew","*", 1)
		for i,unit in pairs(units) do
		 SetUnitStandGuard(unit, true)
		 SetCanGrowAwareness("Leader",false)
	end
end

 function Standstillleaderonly() -- tells the titan to stand ground
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, true)
		SetCanGrowAwareness("Leader",false)
	end
end
	
function onUnitDestroyed(unit)
	
	print("triggered")
	
	if unit.spawnId == "Leader" then
	AddTimer(4.0, YouWon)	
	endeffect()
	end
		
	if unit.spawnId == "defend" then
	destroyed = destroyed + 1
		if destroyed == 2 then
			react()
		end
	end	
end

function endeffect()

	--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10B6_WIN")
	CastSpell("Fireball", 10, "fire1", 3)
	CastSpell("Fireball", 10, "fire2", 3)
	CastSpell("Fireball", 10, "fire3", 3)
	CastSpell("Fireball", 10, "fire4", 3)
	CastSpell("Fireball", 10, "fire5", 3)

end



function react_onTriggerEnter(unit)
	
	if unit.attacker then
	react()
	DisableTrigger("react")
	end
	
end

function react()
	
	--ShowDialog("talkingheads/full/rouge", "TXT_CAMPAIGN10B6_REACT")
	awarenessleader()
	awarenesscrew()
end

function awarenessleader()
	local units = GetUnits("Leader", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
		SetCanGrowAwareness("Leader",true)
	end
end

function awarenesscrew()
	local units = GetUnits("Crew", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit, false)
		SetCanGrowAwareness("Crew",true)
	end
end

function YouWon()

	Win()

end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("Leader",Leader)
	SpawnUnits("Crew",Army)
	SpawnUnits("defend",Army1)
	
	if forPlinthInspector then
	
		SpawnUnits("Leader",Leader)
		SpawnUnits("Crew",Army)
		SpawnUnits("defend",Army1)
		SpawnUnits("Enemy",Army2)
		
	end
end