destroyed = 0
Army = 1
Army1 = 1
Army2 = 2
Titan = 4

function onDeployStart()
	SpawnUnits("Enemy",Army)
	SetWinnable(false)
	createStartingTroops(False)
	ShowDialog("talkingheads/full/guard","TXT_MISSION3A_4_1")
	AddTargetCircle("loss")
	AddTargetCircle("loss1")
	AddTargetCircle("loss2")
	
end

function onLevelStart()
	
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("loss", onTriggerEnter_End_Zone, onTriggerLeave_End_Zone)
	SetTriggerCallbacks("loss1", onTriggerEnter_End_Zone1, onTriggerLeave_End_Zone1)
	SetTriggerCallbacks("loss2", onTriggerEnter_End_Zone2, onTriggerLeave_End_Zone2)
	AddTimer(10.0, spawnWaveOne)
end

function spawnWaveOne()
	SpawnUnits("wave1",Army)
	AddTimer(8.0, spawnWaveTwo)
end

function spawnWaveTwo()
	SpawnUnits("wave2",Army)
	AddTimer(8.0, spawnWaveThree)
end

function spawnWaveThree()
	SpawnUnits("wave3",Army2)
	AddTimer(8.0, spawnWaveFour)
end

function spawnWaveFour()
	SpawnUnits("wave4",Army)
	AddTimer(8.0, spawnTitan)
end

function spawnTitan()
	SpawnUnits("Titan",Titan)
	AddTimer(10.0, spawnTitan)
end

function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("wave1",Army)
		SpawnUnits("wave2",Army)
		SpawnUnits("wave3",Army2)
		SpawnUnits("wave4",Army)
		SpawnUnits("Titan",Titan)
	end
end



function onTriggerEnter_End_Zone(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onTriggerEnter_End_Zone1(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onTriggerEnter_End_Zone2(unit)

	if unit.defender then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3A_2_4")
		Lose()
		DisableTrigger("loss")
		DisableTrigger("loss1")
		DisableTrigger("loss2")
	end
end

function onUnitDestroyed(unit)
	
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			Win()
		end
	end

end

