destroyed = 0
Army = 2
Army1 = 1
Army2 = 4 --Jkung DOT-36504 - Reduced level from 6 to 4 to make killing these guys easier to reduce number of failed attempts
Army3 = 3

function onDeployStart()
	SpawnUnits("Enemy",Army1)
	SpawnUnits("Enemy2",Army3)
	SpawnUnits("Pikemen",Army2)
	SpawnUnits("Militia1",Army)
	SpawnUnits("Militia2",Army)
	SpawnUnits("Militia3",Army)
	SpawnUnits("Militia4",Army)
	SetWinnable(false)
	createStartingTroops(False)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	EnableSelectionChange(false)
	SetAutoOrdersButtonEnabled(false)
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_3_1")
	AddTimer(4.0, removeText)
	AddTimer(4.5, showPikemen)
	local units = GetUnits("Pikemen", "*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end

function onLevelStart()
	SetTriggerCallbacks("militia1Left", onTriggerEnter_militia1Left, onTriggerLeave_militia1Left)
	SetTriggerCallbacks("militia1Right", onTriggerEnter_militia1Right, onTriggerLeave_militia1Right)
	SetTriggerCallbacks("militia2Left", onTriggerEnter_militia2Left, onTriggerLeave_militia2Left)
	SetTriggerCallbacks("militia2Right", onTriggerEnter_militia2Right, onTriggerLeave_militia2Right)
	SetTriggerCallbacks("militia3Left", onTriggerEnter_militia3Left, onTriggerLeave_militia3Left)
	SetTriggerCallbacks("militia3Right", onTriggerEnter_militia3Right, onTriggerLeave_militia3Right)
	SetTriggerCallbacks("militia4Left", onTriggerEnter_militia4Left, onTriggerLeave_militia4Left)
	SetTriggerCallbacks("militia4Right", onTriggerEnter_militia4Right, onTriggerLeave_militia4Right)
	SetTriggerCallbacks("end", onTriggerEnter_end, onTriggerLeave_end)
	SetVictoryBarEnabled(false)
	GiveNamedUnitMoveOrder("Pikemen", "end")
	--GiveNamedUnitMoveOrder("Enemy", "enemy1Left")
	--GiveNamedUnitMoveOrder("Enemy1", "enemy2Left")
	--GiveNamedUnitMoveOrder("Enemy2", "enemy3Left")
	ClearTargetCircles()
	local units = GetUnits("Pikemen", "*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onTriggerEnter_end(unit)
	if unit.spawnId == "Pikemen" then
		ShowDialog("talkingheads/full/guard","TXT_MISSION3B_3_2")
		Lose()
	end
end

function onTriggerEnter_militia1Left(unit)
	if unit.spawnId == "Militia1" then
		GiveNamedUnitMoveOrder("Militia1", "militia1Right")
	end
end

function onTriggerEnter_militia1Right(unit)
	if unit.spawnId == "Militia1" then
		GiveNamedUnitMoveOrder("Militia1", "militia1Left")
	end
end

function onTriggerEnter_militia2Left(unit)
	if unit.spawnId == "Militia2" then
		GiveNamedUnitMoveOrder("Militia2", "militia2Right")
	end
end

function onTriggerEnter_militia2Right(unit)
	if unit.spawnId == "Militia2" then
		GiveNamedUnitMoveOrder("Militia2", "militia2Left")
	end
end

function onTriggerEnter_militia3Left(unit)
	if unit.spawnId == "Militia3" then
		GiveNamedUnitMoveOrder("Militia3", "militia3Right")
	end
end

function onTriggerEnter_militia3Right(unit)
	if unit.spawnId == "Militia3" then
		GiveNamedUnitMoveOrder("Militia3", "militia3Left")
	end
end

function onTriggerEnter_militia4Left(unit)
	if unit.spawnId == "Militia4" then
		GiveNamedUnitMoveOrder("Militia4", "militia4Right")
	end
end

function onTriggerEnter_militia4Right(unit)
	if unit.spawnId == "Militia4" then
		GiveNamedUnitMoveOrder("Militia4", "militia4Left")
	end
end


function createStartingTroops(forPlinthInspector)
		
	if forPlinthInspector then
		SpawnUnits("Enemy",Army1)
		SpawnUnits("Enemy2",Army3)
		SpawnUnits("Pikemen",Army2)
		SpawnUnits("Militia1",Army)
		SpawnUnits("Militia2",Army)
		SpawnUnits("Militia3",Army)
		SpawnUnits("Militia4",Army)
	end
	
end

function removeText()
	HideDialog()
end

function showPikemen()
	FrameCamera("pikemen")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_3_3")
	AddTargetCircle("pikemen")
	AddTimer(4.0, removeText)
	AddTimer(4.0, goHome)
end

function goHome()
	ReturnCamera()
	FrameCamera("end")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_3_4")
	AddTimer (4.0, goHome2)
	AddTimer(4.0, removeText)
end

function goHome2()
	ReturnCamera()
	DropSpell("Freeze", 3, "freeze1")
	DropSpell("Freeze", 3, "freeze2")
	DropSpell("Freeze", 3, "freeze3")
	DropSpell("Freeze", 3, "freeze4")
	DropSpell("Fireball", 3, "fireball1")
	DropSpell("Fireball", 3, "fireball2")
	DropSpell("Fireball", 3, "fireball3")
	DropSpell("Fireball", 3, "fireball4")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3B_3_5")
	AddTimer(4.0, removeText)
	AddTimer(4.0, EnableControls)
end

function EnableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

function onUnitDestroyed(unit)
	if unit.spawnId == "Pikemen" then
	   AddTimer(0.5,YouWin)
	end
end

function YouWin()
   Win()
 end
