destroyed = 0
SpellLevel = 0
Rank = 0
Army = 2
Army1 = 4
Army2 = 1

function onDeployStart()
    SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(0.2, story)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function story()
    ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_1_1")
	AddTimer(4.0, removeText)
	AddTimer(4.0, secondaryText)
	AddTimer(7, startgame)
end

function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

function removeText()
	HideDialog()
end

function secondaryText()
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_1_2")
	AddTimer(4.0, removeText)
end

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
    SetupVictoryBar()
    AddTimer(0.2,wave1)
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C_1_3")
	AddTimer(4.0, removeText)
end

--fireball wave calls
function fireballwave1()
	CastSpell("Fireball", 1, "fire1",0)
	CastSpell("Fireball", 1, "fire9",0)
	AddTimer(8,wave1order)
end
function fireballwave2()
	CastSpell("Fireball", 1, "fire2",0)
	CastSpell("Fireball", 1, "fire10",0)
	AddTimer(7,wave2order)
end
function fireballwave3()
	CastSpell("Fireball", 1, "fire5",0)
	CastSpell("Fireball", 1, "fire6",0)
	CastSpell("Fireball", 1, "fire7",0)
	CastSpell("Fireball", 1, "fire8",0)
	AddTimer(9,wave3order)
end

--[[
function fireballwave4()
	CastSpell("Fireball", 1, "fire3",0)
	CastSpell("Fireball", 1, "fire4",0)
	CastSpell("Fireball", 1, "fire11",0)
	CastSpell("Fireball", 1, "fire12",0)
	AddTimer(4,wave4order)
end
--]]

--enemy wave calls
function wave1()
	SpawnUnits("left",Army2)
	AddTimer(10,fireballwave1)
end
function wave2()
    SpawnUnits("right",Army)
	AddTimer(7,fireballwave2)
end
function wave3()
	SpawnUnits("midleft",Army1)
	SpawnUnits("midright",Army1)
	AddTimer(10,fireballwave3)
end

--[[
function wave4()
    SpawnUnits("ambush",Army)
	SpawnUnits("ambush1",Army1)
	AddTimer(2,fireballwave4)
end
--]]

--enemy wave order
function wave1order()
	GiveNamedUnitMoveOrder("left", "attack1")
end
function wave2order()
    GiveNamedUnitMoveOrder("right", "attack2")
end
function wave3order()
    GiveNamedUnitMoveOrder("midright", "attackright")
    GiveNamedUnitMoveOrder("midleft", "attackleft")
end
function wave4order()
    GiveNamedUnitMoveOrder("ambush", "attack3")
	GiveNamedUnitMoveOrder("ambush1", "attack4")
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			SetVictoryBarFill(0.1)
		end
		if destroyed == 2 then
			SetVictoryBarFill(0.2)
			AddTimer(0.1,wave2)
		end
		if destroyed == 3 then
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C_1_2")
			AddTimer(4.0, removeText)
			SetVictoryBarFill(0.3)
		end
		if destroyed == 4 then
			SetVictoryBarFill(0.4)
		end
		if destroyed == 5 then
		    AddTimer(0.1,wave3)
			ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C_1_4")
			AddTimer(4.0, removeText)
			SetVictoryBarFill(0.5)
		end
		if destroyed == 6 then
			SetVictoryBarFill(0.6)
		end
		if destroyed == 7 then
			SetVictoryBarFill(0.7)
	--		AddTimer(0.1,wave4)
		end
		if destroyed == 8 then
	--		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_10C_1_5") --removed "watch our flanks" talking head
			AddTimer(4.0, removeText)
			SetVictoryBarFill(0.8)
		end
		if destroyed == 9 then
			SetVictoryBarFill(0.9)
		end
	--[[
		if destroyed == 10 then
			SetVictoryBarFill(0.8)
		end
		if destroyed == 11 then
			SetVictoryBarFill(0.9)
		end
	--]]	
		if destroyed == 10 then
			ShowDialogEternal("talkingheads/full/guard","TXT_MISSION3C_1_3")
		    AddTimer(5,winner)
			SetVictoryBarFill(1)
		end
	end
end

function winner()
    SetWinnable(true)
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(0.25)
	AddVictoryBarMarker(0.5)
	AddVictoryBarMarker(0.75)
	AddVictoryBarMarker(1.0)
end

function createStartingTroops(forPlinthInspector)
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
        SpawnUnits("left",Army2)
		SpawnUnits("right",Army)
		SpawnUnits("midleft",Army1)
		SpawnUnits("midright",Army1)
	--	SpawnUnits("ambush",Army)
	--	SpawnUnits("ambush1",Army1)
	end
end










