destroyed = 0
SpellLevel = 0
Army = 5
Army1 = 6
Army2 = 0
Rank = 0
function QueueAssets()
	QueueVFX("ElderStone_EnergyProp")
	QueueVFX("ElderStone_EnergyPropStones")
	
end


function onDeployStart()
	SetWinnable(false)
	ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN4B_2_INTRO")	
	createStartingTroops(False)  -- This part here
	PlayVFX("ElderStone_EnergyPropStones", "stone")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyProp", "stone3")
end

function onLevelStart()
	SetVictoryBarEnabled(false)
	SetAI()
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	AddTargetCircle("trigger2")
	SetBattleTimeoutTime(240, 0) -- set battle timer for 6 minutes
	AddTimer(240,Lose)
end

function SetAI() -- sets allies to not move
	local units = GetUnits("defend1", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,true)
	end
	
	local units = GetUnits("defend", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,true)
	end
end

function trigger1_onTriggerEnter(unit)

	if unit.attacker then
		SetAI2()
		DisableTrigger("trigger1")
	end

end

function SetAI2()
	local units = GetUnits("defend1", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,false)
		GiveUnitMoveOrder(unit, "trigger1")
	end
	
	local units = GetUnits("defend", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,false)
	end
end

function trigger2_onTriggerEnter(unit)

	if unit.attacker then
		ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN4B_2_ESCAPE")	
		AddTimer(2.0, Win)
		DisableTrigger("trigger2")
	end

end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			AddTargetCircleWithArrow("trigger2")
		end
	end
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("spawn1", Army)
	SpawnUnits("defend1", Army)
	SpawnUnits("defend", Army)
	SpawnUnits("defend2", Army1)
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn1", Army)
		SpawnUnits("defend1", Army)
		SpawnUnits("defend2", Army1)
		SpawnUnits("defend", Army)
	end
end

