free = false
SpellLevel = 0
Titan = 9
Army = 4
Army1 = 0
Army2 = 0
Rank = 0
destroyed = 0
alerted = 0
freed = 0

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_4_INTRO")
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	createStartingTroops(False)  -- This part here
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SpawnUnits("captive")
end

function onLevelStart()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetTriggerCallbacks("trigger3", trigger3_onTriggerEnter, trigger3_onTriggerLeave)
	SetTriggerCallbacks("trigger4", trigger4_onTriggerEnter, trigger4_onTriggerLeave)
	SetTriggerCallbacks("trigger5", trigger5_onTriggerEnter, trigger5_onTriggerLeave)
	SetTriggerCallbacks("trigger6", trigger6_onTriggerEnter, trigger6_onTriggerLeave)
	SetTriggerCallbacks("trigger7", trigger7_onTriggerEnter, trigger7_onTriggerLeave)
	SetTriggerCallbacks("trap", trap_onTriggerEnter)
	SetTriggerCallbacks("trap1", trap_onTriggerEnter)
	SetTriggerCallbacks("trap2", trap_onTriggerEnter)
	SetTriggerCallbacks("trap3", trap_onTriggerEnter)
	Patrol1()
	Patrol2()
	SetAI()
	SetFriendly()
	SetBattleTimeoutTime(180, 0) -- set battle timer for 6 minutes
	AddTimer(180,Lose)
end

function SetFriendly() -- sets allies to not do damage
	local units = GetUnits("captive", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			EnableInvincibility(unit)
	end
end

function SetAI()
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,true)
	end
end

function Patrol1()
	local units = GetUnits("start2", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit,"trigger5")
	end
end

function Patrol2()
	local units = GetUnits("start1", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit,"trigger4")
	end
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end
function trap1_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end
function trap2_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end
function trap3_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end

function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end

function trigger7_onTriggerEnter(unit)
	if unit.attacker then
		LeashOff()
	end
end

function alert()
    if alerted == 1 and freed == 0 then
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_4_ALERT_2")
	gone()
	end
	if alerted == 1 and freed == 1 then
	ShowDialog("talkingheads/full/soldier","TXT_CAMPAIGN_4C_4_ALERT")
	end
	
end

function LeashOff()
	free = true
	ClearTargetCircles()
	DisableTrigger("trigger2")
	alerted = alerted +1
	alert()
		local units = GetUnits("spawn1", "*", 1)
		for i,unit in pairs(units) do
		SetUnitStandGuard(unit,false)
		end
end

function trigger3_onTriggerEnter(unit)
	if unit.spawnId == "start2" and free == false then
		local units = GetUnits("start2", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit,"trigger5")
		end
	end
end

function trigger5_onTriggerEnter(unit)
	if unit.spawnId == "start2" and free == false then
		local units = GetUnits("start2", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit,"trigger3")
		end
	end
end

function trigger6_onTriggerEnter(unit)
	if unit.spawnId == "start1" and free == false then
		local units = GetUnits("start1", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit,"trigger4")
		end
	end
end

function trigger4_onTriggerEnter(unit)
	if unit.spawnId == "start1" and free == false then
		local units = GetUnits("start1", "*", 1)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit,"trigger6")
		end
	end
end

function trigger2_onTriggerEnter(unit)
	if unit.attacker and free == false then
		free = true
		freed = freed +1
		ShowDialog("talkingheads/full/ragnarwar","TXT_CAMPAIGN_4C_4_FREE")
		AddTimer(1.0, SpawnCaptives)
		DisableTrigger("trigger2")
		ClearTargetCircles()
		AddTimer(2.0, LeashOff)
		SpawnUnits("spawn1",Army)	
		--SetWinnable(true)
		SetVictoryBarEnabled(true)
	end
end

function SpawnCaptives()
	-- switch friendlies from ai to player controlled
	local units = GetUnits("captive", "*", 2)
	for i,unit in pairs(units) do
    SwitchSide(unit, 0)
	EnableAttackDamage(unit)
	DisableInvincibility(unit)
	end
end

function onUnitDestroyed(unit)
	
	if unit.defender and free == false then
		destroyed = destroyed + 1
		if destroyed == 1 then
		--free = true
		--LeashOff()
		--ClearTargetCircles()
		--DisableTrigger("trigger2")
		--ClearTargetCircles()
		--SetWinnable(true)
		SetVictoryBarEnabled(true)
		end
	elseif unit.defender and free == true then
		destroyed = destroyed + 1
		if destroyed == 4 then
			PlayVFX("PA_SpawnReinforcement", "trigger2")
			--ShowDialog("talkingheads/full/almarand","TXT_CAMPAIGN_4C_4_TITAN")
			AddTimer(1.0, TitanSpawn)
		end
		if destroyed == 9 then
		--reappear()
		SetWinnable(true)
		end
	end
end

function TitanSpawn()
	SpawnUnits("titan",Titan)
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("start2",Army)
	SpawnUnits("start1",Army)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("spawn1",Army)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
	FrameCamera("trigger2")
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_4_INTRO")
	--AddTargetCircleWithArrow("trigger2")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6, framecamera1)
end

function gone()
	PlayVFX("PA_SpawnReinforcement", "fx1")
	PlayVFX("PA_SpawnReinforcement", "fx2")
	PlayVFX("PA_SpawnReinforcement", "fx3")
	AddTimer(1,gonegone)
end

function gonegone()
	local units = GetUnits("captive", "*", 2)
	for i,unit in pairs(units) do
	KillUnit(unit)
	HideDeadUnit(unit)
	end
end

function reappear()
    PlayVFX("PA_SpawnReinforcement", "fx1")
	PlayVFX("PA_SpawnReinforcement", "fx2")
	PlayVFX("PA_SpawnReinforcement", "fx3")
	AddTimer(1,arrival)
end

function arrival()
    RespawnUnits("captive")
end

function framecamera1(seconds)
	FrameCamera("camera")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_4C_4_INTRO_2")
	AddTimer(6,buttonunlock)
end


function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	AddTargetCircle("trigger2")
end

