destroyed = 0
SpellLevel = 0
Army = 8
Army1 = 8
Army2 = 8
Army3 = 8
Army4 = 8
Rank = 0
armyDestroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetTriggerCallbacks("opening", opening_onTriggerEnter, opening_onTriggerLeave)
	SpawnUnits("Ally",Army4)
	SpawnUnits("skeleton",Army)
end

function startfight()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
end

function onLevelStart()
    SetAI1() -- allies
	SetAI2() -- enemy attacking allies
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialogDismiss("talkingheads/full/guard", "TXT_CAMPAIGN6E_4_1")
		AddTimer(5.0,startgame)
	end
end

function startgame()
	HideDialog()
	AddTimer(1.0, SpawnOneEnemyUnit)
	PlayVFX("PA_SpawnReinforcement", "lefttrap")
	PlayVFX("PA_SpawnReinforcement", "righttrap")
	PlayVFX("PA_SpawnReinforcement", "middletrap")
	PlayVFX("PA_SpawnReinforcement", "backtrap")
	AddTimer(2, startfight)
end

function SpawnOneEnemyUnit()
	SpawnUnits("start1",Army)
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGuard(unit,true)
			DisableAttackDamage(unit)
			EnableInvincibility(unit)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			AddTimer(1, SpawnTwoEnemyUnit) 
		   -- ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN6E_4_2")
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
			DisableInvincibility(unit)
		end
		    	
		end
		if destroyed == 10 then
			--ShowDialogEternal("talkingheads/full/elithendip","TXT_CAMPAIGN6E_4_3")
			AddTimer(4.0,endgame)
            			
		end
	end
	
	if unit.spawnId == "Ally" then
		armyDestroyed = armyDestroyed + 1
		if armyDestroyed == 3 then
			Lose()
		end
	end
end

function SpawnTwoEnemyUnit()
	SpawnUnits("start2",Army)
end

function endgame()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 4
	SpellLevel = 10

	--SpawnUnits("start",Army1)
	
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("start1", Army)
		SpawnUnits("start2", Army1)
		SpawnUnits("skeleton",Army)
	end
end

