SpellLevel = 0
Army = 15

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	--AddTargetCircle("moveto2")   -- move to targets for player 
	--AddTargetCircle("moveto1")	-- move to targets for player
	PlayVFX("ElderStone_EnergyPropStones", "stone1")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyPropStones", "stone3")
	PlayVFX("ElderStone_EnergyProp", "elderstone")
	ShowDialog("talkingheads/full/guard","TXT_POPDES_PATROL_1")
	
end



function onLevelStart()
	SetBattleTimeoutTime(300, 0) -- set battle timer for 6 minutes
	AddTimer(300,Lose)
	SetVictoryBarEnabled(false)
	--AddTimer(240, outoftime) -- set lose condition to kick in after 4 minutes
	SetWinnable(false)	-- level cannot be completed even if no enemy units are alive
	SetTriggerCallbacks("patrol2", patrol2_onTriggerEnter, patrol2_onTriggerLeave)
	SetTriggerCallbacks("patrol3", patrol3_onTriggerEnter, patrol3_onTriggerLeave)
	SetTriggerCallbacks("patrol4", patrol4_onTriggerEnter, patrol4_onTriggerLeave)
	SetTriggerCallbacks("exit", exit_onTriggerEnter, exit_onTriggerLeave)
	--GiveNamedUnitMoveOrder("spawn1", "gohere")

end

function patrol2_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol2")
		ShowDialog("talkingheads/full/guard","TXT_POPDES_PATROL_3")
	end	
end

function patrol3_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol3")
		ShowDialog("talkingheads/full/guard","TXT_POPDES_PATROL_2")
		SpawnUnits("spawn1", Army) -- 5 units
	end	
end

function patrol4_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("patrol4")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_PATROL_4")
		SpawnUnits("spawn2", Army) -- 5 units
		SpawnUnits("spawn4", Army) -- 3 units -- DOT-31328 JKung: spawn4 group was a respawn group of 3 units and respawned 2x, neither of which were counted in the plinth inspector. Turned them into regular spawners and so added 6 more units to the plinth inspector.
	end
end

function exit_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("exit")	
		SpawnUnits("spawn3", Army)
		SpawnUnits("spawn5", Army) -- DOT-31328 JKung: spawn4 group was a respawn group of 3 units and respawned 2x, neither of which were counted in the plinth inspector. Turned them into regular spawners and so added 6 more units to the plinth inspector.
		PlayVFX("PA_SpawnReinforcement", "impact1")
		PlayVFX("PA_SpawnReinforcement", "impact2")
		PlayVFX("PA_SpawnReinforcement", "impact3")
		AddTimer(2.0, spawnme)
		SetWinnable(true)
	end	
end

function spawnme()
	SpawnUnits("reinforce1",Army)
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 5
	SpellLevel = 12
	
	
	
--		SpawnUnits("spawn1",Army) 
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("spawn1",Army)
--		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn3",Army)
		SpawnUnits("spawn4",Army)
		SpawnUnits("spawn5",Army) -- DOT-31328 JKung: spawn4 group was a respawn group of 3 units and respawned 2x, neither of which were counted in the plinth inspector. Turned them into regular spawners and so added 6 more units to the plinth inspector. 
	end
end

