destroyed = 0
SpellLevel = 0
Rank = 0
Army = 18
Army1 = 18
Army2 = 18
Titan = 28

function onDeployStart()
	SpawnUnits("Titan",Titan)
	SpawnUnits("Enemy",Army1)
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
    AddTargetCircle("capture")
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	AddTimer(5, text)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
	end
end

function onLevelStart()
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave) 
	SetTriggerCallbacks("capture", capture_onTriggerEnter) 
end

function text()
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8A_6_1")
	--ShowDialog("talkingheads/full/hero","TXT_CAMPAIGN8A_6_2")
	AddTimer(4, startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
	   -- ShowDialog("talkingheads/full/hero","TXT_CAMPAIGN8A_6_3")
		SpawnUnits("startTrap",Army)
		DisableTrigger("trap")
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 10 then
		--ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN8A_6_4")
		AddTimer(6,Final)	
		end
	end
end

function Final()
    HideDialog()
    SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("start",Army1)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Titan",Titan)
		SpawnUnits("Enemy",Army1)
		SpawnUnits("start",Army1)
		SpawnUnits("startTrap",Army)
	end
end










