AttackersZone1 = false
AttackersZone2 = false
DefendersZone1 = true
DefendersZone2 = true
Captured1 = false
Captured2 = false
respawner = 0
killcount = 0
SpellLevel = 0
Army = 20
Rank = 0

function onDeployStart()
	--AddTargetCircle("Capture1")
	createStartingTroops(False)
	SpawnUnits("start", Army)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN8E_5_1")

	end
end

function onLevelStart()
	SetTriggerCallbacks("Capture1", Capture1_onTriggerEnter, Capture1_onTriggerLeave) -- Player approaches the capture point
	triggercheck()
	SetWinnable(false)
	SetVictoryBarEnabled(false)
	AddTargetCircle("Capture1")
end

function triggercheck()
	local var1 = CountDefendersInTrigger("Capture1")
	if var1 == 0 then 
		DefendersZone1 = false
	elseif var1 > 0 then
		DefendersZone1 = true	
	end 
		
	local var3 = CountAttackersInTrigger("Capture1")
	if var3 == 0 then 
		AttackersZone1 = false
	elseif var3 > 0 then
		AttackersZone1 = true
	end 
	Success()
	
end


function Success()
	AddTimer(3.0, triggercheck)
	if AttackersZone1 == true then 
		Captured1 = true
	else
		Captured1 = false 			
	end
	
	if Captured1 == false then
		AddTimer(12.0, enemywave)
	end
	
	if Captured1 == true then
		wincondition()
	end
end

function Capture1_onTriggerLeave(unit)
	if unit.attacker and Captured1==false then
	AddTimer(3.0, triggercheck)	
	end
end

function enemywave()
	SpawnUnits("spawn1",Army)
end

function wincondition()
		CancelTimer(triggercheck)
		SpawnUnits("spawn1",Army)
		AddTimer(59.5,Victory)
		SetBattleTimeoutTime(60.0,0)
		AddTimer(12.0,Spawnloop)
end


function Spawnloop()
	RespawnUnits("spawn2",Army)
	AddTimer(12.0,Spawnloop)
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 8
	--SpellLevel = 5
	--Army = 4

	-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("spawn1",Army)
		RespawnUnits("spawn2",Army)
		RespawnUnits("spawn2",Army)
		RespawnUnits("spawn2",Army)
		RespawnUnits("spawn2",Army)
		SpawnUnits("start", Army)
	end
end


function Victory()
	Win()
end






































