SpellLevel = 17
Army = 21
destroyed = 0
--entered = 0
--entered1 = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP9B1_1")
		
end

function onLevelStart()
	SetBattleTimeoutTime(300, 0) -- DOT-30943 JKung Replaced SetDisplayTime with SetBattleTimeoutTime 
	SetTriggerCallbacks("alert1", alert1_onTriggerEnter, alert1_onTriggerLeave)
	SetTriggerCallbacks("ambush1", ambush1_onTriggerEnter, ambush1_onTriggerLeave)
	SetTriggerCallbacks("ambush2", ambush2_onTriggerEnter, ambush2_onTriggerLeave)
	SetTriggerCallbacks("objective", objective_onTriggerEnter, objective_onTriggerLeave)
	SetWinnable(false)
	SetVictoryBarEnabled(true)
	SetVictoryBarFill(0)
end

function alert1_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("alert1")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP9B1_ALERT")
	end	
end

function ambush1_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("ambush1")
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP9B1_2")
		SpawnUnits("spawn1",Army)
	end	
end

function ambush2_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("ambush2")
	--	ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP9B1_3")
		SpawnUnits("spawn2",Army)
		ClearTargetCircles()
	end	
end

function objective_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("objective")	
		PlayVFX("PA_SpawnReinforcement", "impact1")
		PlayVFX("PA_SpawnReinforcement", "impact2")
		PlayVFX("PA_SpawnReinforcement", "impact3")
		PlayVFX("Elderstone_EnergypropStones", "portal")
		AddTimer(1.0, spawnme)
		--ShowDialog("talkingheads/full/guard","TXT_POPDES_CAMP9B1_4")
		ClearTargetCircles()
	end	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn3",Army)
	end
end

function spawnme()
	SpawnUnits("spawn3",Army)
	StopVFX("Elderstone_EnergypropStones", "portal")
		SetWinnable(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			-- arrow here
			AddTargetCircleWithArrow("circle1")
			--entered = entered + 1
			SetVictoryBarFill(0.3)
			ShowDialog("talkingheads/full/guard","TXT_SP13_1")	
		end
		if destroyed == 11 then
			-- arrow here
			AddTargetCircleWithArrow("circle2")
			--entered1 = entered1 +1
			SetVictoryBarFill(0.6)
		end
		if destroyed == 15 then -- not really here normally!
			SetVictoryBarFill(1)
		end
	end
end

function QueueAssets()

   QueueVFX("PA_SpawnReinforcement")
   QueueVFX("Elderstone_EnergyPropStones")

end


