destroyed = 0
SpellLevel = 7
Army = 9
Army1 = 9
Army2 = 9
Rank = 0

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_2_1")
		--ShowDialogDismiss("talkingheads/full/guard", "TXT_CAMPAIGN_ELITHEN_2_2")
		--ShowDialog("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_2_3")
		AddTimer(3.0,startgame)
	end
end

function startgame()
	HideDialog()
end

function trap_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("start2",Army1)
		DisableTrigger("trap")
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 5 then
		    SpawnUnits("start3")
		    --ShowDialogEternal("talkingheads/full/elithendip","TXT_CAMPAIGN_ELITHEN_2_4")
			AddTimer(7.0,endgame)
		end
	end
end

function endgame()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 and Rank <= 11 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		elseif Rank >= 12 then
			SpellLevel = 12
			Army = 10
			Army1 = 11
			Army2 = 12
		end
--]]
	SpawnUnits("start",Army)
	SpawnUnits("start1",Army1)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army1)
		SpawnUnits("start2",Army1)
	end
end

