destroyed = 0
SpellLevel = 9
Rank = 0
Titan = 18
Army = 10

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetupVictoryBar()
end

function onLevelStart()
	
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			wave0()
			--ShowDialog("talkingheads/full/guard", "TXT_SP9_2")
		end
		if destroyed == 7 then
			wave3()
			ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN10C_6_2")
		end
		if destroyed == 8 then
			SetWinnable(true)
		end
	end
end

function wave0()
    SpawnUnits("start1",Army)
end
function wave3()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1, titanspawn)
end
function titanspawn()
    SpawnUnits("titan", Titan)
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/10)
	AddVictoryBarMarker(7/10)
	AddVictoryBarMarker(1.0)
end

function createStartingTroops(forPlinthInspector)
--[[
		Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("start",Army)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("titan",Titan)
	end
end










