killcount = 0
SpellLevel = 0
Army = 13
Army1 = 13
Army2 = 13
Army3 = 13
Rank = 0
destroyed = 0
Titan = 14

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)
	SetWinnable(false)
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR10_1")
	--ShowDialogEternal("Portraits/dip_introtitan_top","TXT_CAMPAIGN_RAGNAR10_2")
	local units = GetUnits("*", "RagnarHeroVerB*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function SpawnTitan()
    --HideDialog()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1, SpawnTitanUnit)
end

function SpawnTitanUnit()
	SpawnUnits("startTitan",Titan)
	--ShowDialogEternal("Portraits/dip_introtitan_top","TXT_CAMPAIGN_RAGNAR10_2")
	AddTimer(2, startgametext)
end

function onLevelStart()
    SetAI1() -- allies
	SetBattleTimeoutTime(360,0)
	AddTimer(360, Lose)
	SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "RagnarHeroVerB*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function startgametext()
	--ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN_RAGNAR10_2")
	AddTimer(6, startgame)
end

function startgame()
	HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			DisableAttackDamage(unit)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if unit.spawnId == "startTitan" then
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
        for i,unit in pairs(units) do
		    SwitchSide(unit, 0)
		    EnableAttackDamage(unit)
	    end
		SetVictoryBarType("NORMAL")
		RespawnUnits("start1",Army) --Spawn enemy flanking skeletons
      --  ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR10_3" )
	   -- ShowDialog("talkingheads/full/Kobar","TXT_CAMPAIGN_RAGNAR10_4" )
	    end
		if destroyed == 10 then
		RespawnUnits("start2",Army)   
		end
		if destroyed == 17 then
		   -- ShowDialogEternal("talkingheads/full/Kobar","TXT_CAMPAIGN_RAGNAR10_5")
			AddTimer(4.0,endgame)
		end
	end
end

function endgame()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 5 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 8
		elseif Rank == 6 then			
			Army = Rank -2
			Army1 = Rank -1
			Titan = 10
		elseif Rank == 7 then			
			Army =  5
			Army1 = 7
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank >= 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		end
--]]
	SpawnUnits("start",Army)
	

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("start1",Army)
		SpawnUnits("start2",Army)
		SpawnUnits("startTitan",Titan)
	end
end

--Intro
function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		AddTimer(0.1, framecamera)
	end
end

function framecamera(seconds)
    --ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_2B_4_1","TOP_LEFT")
	--ShowDialog("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR10_1")
	FrameCamera("cam1")
	EnableCameraControl(false)
	AddTimer(5, ReturnCamera)
	AddTimer(6,framecamera1)
end

function framecamera1(seconds)
    --ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_2B_4_1","TOP_LEFT")
	FrameCamera("titan")
	EnableCameraControl(false)
	SpawnTitan()
	AddTimer(7, ReturnCamera)
end

function buttonunlock()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end

