destroyed = 0
SpellLevel = 0
Army = 7
Army1 = 5
Army2 = 4

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	SpawnUnits("start",Army2)
	SpawnUnits("startpikes",Army)
end

function onLevelStart()
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 7 then
			AddTimer(1,portalFX) -- spawns second wave of enemies
		end
		if destroyed == 8 then
			SpawnUnits("militia",Army) -- spawns thrid wave of militia from the trees
		end
		if destroyed == 14 then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end

-- second wave fx and spawns, pikemen, Ragnar, and archers
function portalFX()
	PlayVFX("Elderstone_EnergyPropStones", "portal1FX")
	PlayVFX("Elderstone_EnergyPropStones", "portal2FX")
	AddTimer(1,spawn2FX)
end

function spawn2FX()
	PlayVFX("PA_SpawnReinforcement", "wave21FX")
	PlayVFX("PA_SpawnReinforcement", "wave22FX")
	PlayVFX("PA_SpawnReinforcement", "wave23FX")
	AddTimer(1,spawn2)
end

function spawn2()
	SpawnUnits("wave2",Army1)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()			-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army2)
		SpawnUnits("startpikes",Army)	
		SpawnUnits("wave2",Army1)
		SpawnUnits("militia",Army)
	end
end










