destroyed = 0
SpellLevel = 0
Rank = 0
Titan = 25
Army = 10
Army1 = 9
Army2 = 9

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
													-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	
end

function onLevelStart()
	
	SetTriggerCallbacks("pass", pass_onTriggerEnter, pass_onTriggerLeave)
	SetBattleTimeoutTime(300, 0) -- set battle timer for 5 minutes
	AddTimer(300,Lose)
	AddTimer (15.0, wave1)
end

function pass_onTriggerEnter(unit)

	if unit.attacker then
		AddTimer(1.0, vfx3)
		DisableTrigger("pass")
	end

end
		
		
function vfx3()
									
	PlayVFX("PA_SpawnReinforcement", "vfx1")
	PlayVFX("PA_SpawnReinforcement", "vfx2")
	PlayVFX("PA_SpawnReinforcement", "vfx3")
	PlayVFX("PA_SpawnReinforcement", "vfx4")
	AddTimer(1.0, wave3)
	
end

function wave1()
	SpawnUnits("enemy1",Army1)
	AddTimer(10.0, wave2)
end

function wave2()
	SpawnUnits("enemy2",Army2)
end

function wave3()
	SpawnUnits("enemy3",Army2)
	SetWinnable(true)
end
		

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("enemy",Army)
	SpawnUnits("titan",Titan)	
			
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("enemy",Army)
		SpawnUnits("enemy1",Army1)
		SpawnUnits("enemy2",Army2)
		SpawnUnits("enemy3",Army2)
		
	end
end










