

destroyed = 0
SpellLevel = 0
Army = 0
Titan = 0
Rank = 0

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
end

function createStartingTroops(forPlinthInspector)

	-- Balanced for castle level 6
	SpellLevel = 7
	Army = 5
	Army2 = 5
	Titan = 11

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("rand1", Army2)
		SpawnUnits("rand2", Army)
		SpawnUnits("rand3", Army)
		SpawnUnits("rand4", Army2)
		SpawnUnits("titan", Titan)
	end
end


function onLevelStart()
	SetupVictoryBar()
	SetTriggerCallbacks("protect", protect_onTriggerEnter) -- central area player is supposed to protect
	RespawnUnits("rand1", Army)
	AddTimer(1.0,  FireText)
end

function FireText()
	--ShowDialog("talkingheads/full/guard","TXT_FORTWAVES1_WAVE1")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_FORTWAVES1_INTRO")
	end
end



function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 then
			SetWinnable(true)	
			SpawnUnits("rand2", Army2)
			--ShowDialogInPosition("talkingheads/full/guard", "TXT_FORTWAVES1_WAVE2","BOTTOM_LEFT")
		elseif destroyed == 5 then
			SpawnUnits("rand3", Army)
			--ShowDialog ("talkingheads/full/guard", "TXT_FORTWAVES1_WAVE3")
		elseif destroyed == 7 then
			AddTimer(1.0, SpawnTitan)
			PlayVFX("PA_SpawnReinforcement", "fx1")
			SpawnUnits("rand4", Army2)
			--ShowDialog ("talkingheads/full/almarand", "TXT_FORTWAVES1_WAVE4")
		end
	end
end

function SpawnTitan()
	SpawnUnits("titan", Titan)
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(2/12)
	AddVictoryBarMarker(5/12)
	AddVictoryBarMarker(7/12)
	AddVictoryBarMarker(1.0)
end










